/* Seamless3d

Copyright (C) 2001-2011 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#include <windows.h>
#include <direct.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"
#include "resource.h"
#include "input.h"
#include "robot_aid.h"
#include "seamless3d_gui_render.h"

Ptr<AnimControlPanel> g_acp;
bool PosCompensator::rightSideDrag = false;
Ptr<TimelineFilter> g_timelineFilter = new TimelineFilter;
extern Ptr<PasteOptions> g_pasteOptions;
extern Ptr<DeleteOptions> g_deleteOptions;
void renderScene();

AnimCopy g_animCopy;

bool outOfSyncWithRobot();//if the robot was syncronised with the 3d rendering we would not need this
void sAction(Rotation& v, int command);
void quantizeDec(float& v);
void quantizeInc(float& v);

AnimCurve g_animCurve;

class AnimSliderFakeDrag: public CallBack {
public:
	AnimControlPanel* animCP;
	Anim* anim;
	double timeStart;
	double remDisplayFrom;
	AnimSliderFakeDrag():
		timeStart(0),
		remDisplayFrom(0)
	{}
void doCallBack(){
	AnimTimeLine* timeLine = animCP->timeLine;
	double f = 0;

	const double xPos = g_mousePos.x - animCP->pos.x - timeLine->dstPos.x - timeLine->lineOffset;
	double span = anim->zoom / anim->period;
	
	if(xPos >= timeLine->lineDist &&  anim->zoom < anim->period){
		anim->displayFrom = remDisplayFrom + 1.0 / anim->stepsPerSecond / animCP->animZoom * (g_time - timeStart) * 8;
		if(anim->displayFrom >= 1.0 - span){
			anim->displayFrom = 1.0 - span;
		}
		f = anim->displayFrom + span;
	}
	else if(xPos < 0){
		anim->displayFrom = remDisplayFrom - 1.0 / anim->stepsPerSecond / animCP->animZoom * (g_time - timeStart) * 8;
		if(anim->displayFrom < 0){
			anim->displayFrom = 0;
		}
		f = anim->displayFrom;
	}
	else{
		timeStart = g_time;
		remDisplayFrom = anim->displayFrom;
		f = xPos / timeLine->lineDist / animCP->animZoom + timeLine->anim.displayFrom;
	}
	
	if( f < 0){
		f = 0;
	}
	if( f > 1){
		f = 1;
	}
	animCP->animSlider->bField = f;
/*

	int diff=ptCursor.x-dragPos.x;

	const int beginPos = timeLine.dstPos.x-(bSize.x/2);
	const int endPos = beginPos + timeLine.bSize.x;
	const int relBottom = endPos - beginPos;
	const int relDstPos = dstPos.x - beginPos;


	if( diff < 0 && relDstPos + diff < 0){
		diff = -relDstPos;
	}
	if( diff > 0 && relDstPos + diff >= relBottom){
		diff = relBottom - relDstPos;
	}

	dstPos.x+=diff;
	dragPos.x+=diff;

	float a = static_cast<float>(dstPos.x+(bSize.x/2)-timeLine.dstPos.x);
	float c = a / timeLine.bSize.x;
//	dLog(c);
	bField = c;
//	dLog(bField.refValue());

//	bField = static_cast<float>(dragPos.y-top) / static_cast<float>(bottom-top);
//	g_scene->scroll = static_cast<float>(relDstPos + diff) / relBottom * g_sceneTreeCollapsed.length;
	//win.resizePageUpPageDown();
	//win.keepLeagal();//why is this needed?
//	win.paint();
*/
	};
};

class AnimHighlightFakeDrag: public CallBack {
public:
	AnimControlPanel* animCP;
	Anim* anim;
	double timeStart;
	double remDisplayFrom;
	AnimHighlightFakeDrag():
		timeStart(0),
		remDisplayFrom(0)
	{}
void doCallBack(){
	AnimSelect* animSelect = animCP->animSelect;
	double f = 0;
	
	const double xPos = g_mousePos.x - animCP->pos.x - animSelect->dstPos.x - animSelect->lineOffset;
	double span = anim->zoom / anim->period;

	if(xPos >= animSelect->lineDist &&  anim->zoom < anim->period){
		anim->displayFrom = remDisplayFrom + 1.0 / anim->stepsPerSecond / animCP->animZoom * (g_time - timeStart) * 8;
		if(anim->displayFrom >= 1.0 - span){
			anim->displayFrom = 1.0 - span;
		}
		f = anim->displayFrom + span;
	}
	else if(xPos < 0){
		anim->displayFrom = remDisplayFrom - 1.0 / anim->stepsPerSecond / animCP->animZoom * (g_time - timeStart) * 8;
		if(anim->displayFrom < 0){
			anim->displayFrom = 0;
		}
		f = anim->displayFrom;
	}
	else{
		timeStart = g_time;
		remDisplayFrom = anim->displayFrom;
		f = xPos / animSelect->lineDist / animCP->animZoom + animSelect->anim.displayFrom;
	}



	if( f < 0){
		f = 0;
	}
	if( f > 1){
		f = 1;
	}
	if(animSelect->dragRight){
		if(f < anim->selectFrom){
			animSelect->dragRight = false;
			anim->selectTo = anim->selectFrom;
			anim->selectFrom = f;
		}
		else{
			anim->selectTo = f;
		}
	}
	else{
		if(f > anim->selectTo){
			animSelect->dragRight = true;
			anim->selectFrom = anim->selectTo;
			anim->selectTo = f;
		}
		else{
			anim->selectFrom = f;
		}
	}
}
};

AnimSliderFakeDrag g_animSliderFakeDrag;
AnimHighlightFakeDrag g_animHighlightFakeDrag;

template <class A, class B>void bubbleSort(M_<A>& a, M_<B>& b, int& idx){
	bool flag;
	do{
		flag=false;
		for(int i=0;i<a.length-1;i++){

			if (a[i] > a[i+1]){
				if(idx==i){
					idx++;
				}
				else if(idx==i+1){
					--idx;
				}

				A swapA = a[i+1];
				a[i+1]=a[i];
				a[i]=swapA;

				B swapB = b[i+1];
				b[i+1]=b[i];
				b[i]=swapB;

				flag=true;
			}
		}
	}while(flag);
}

void bubbleSortMorpher(M_Float& a, M_Vec3f& b, int& idx, int numOfChannels){

	bool flag;
	do{
		flag = false;
		for(int i=0;i<a.length-1;i++){

			if (a[i] > a[i + 1]){
				if(idx == i){
					idx++;
				}
				else if(idx == i + 1){
					--idx;
				}

				float swapA = a[i + 1];
				a[i + 1] = a[i];
				a[i] = swapA;

				swapElements((i + 1) * numOfChannels, i * numOfChannels, numOfChannels, b, b);
				flag = true;
			}
		}
	}while(flag);
}

void OrientationInterpolator::setKeyDragPos(int& idx, const float newTime){
	key.refValue()[idx] = newTime;
	bubbleSort(key.refValue(), keyValue.refValue(), idx);
}

void PositionInterpolator::setKeyDragPos(int& idx, const float newTime){
	key.refValue()[idx] = newTime;
	bubbleSort(key.refValue(), keyValue.refValue(), idx);
}

void NurbsTrack::setKeyDragPos(int& idx, const float newTime){
	key.refValue()[idx] = newTime;
	bubbleSort(key.refValue(), keyValue.refValue(), idx);
}

void ScalarInterpolator::setKeyDragPos(int& idx, const float newTime){
	key.refValue()[idx] = newTime;
	bubbleSort(key.refValue(), keyValue.refValue(), idx);
}

void CPMorpher::setKeyDragPos(int& idx, const float newTime){
	key.refValue()[idx] = newTime;
	bubbleSortMorpher(key.refValue(), keyValue.refValue(), idx, cpIndex.length);
}

void PosCompensator::setKeyDragPos(int& idx, const float newTime){
	if(rightSideDrag){
		moment.refValue()[idx].y = newTime;
	}
	else{
		moment.refValue()[idx].x = newTime;
	}
	//bubbleSort(key.refValue(), keyValue.refValue(), idx);
}

bool commonSearchKeyFrameInTimeLine(AnimTimeLine* timeLine, AnimSlider* animSlider, M_Float& key, const float clickPos, SamplePose* samplePose){
	Anim* anim = &timeLine->anim;
	float error = 0.25 / (anim->stepsPerSecond * anim->period);
	for(int i = 0; i < key.length; i++){
		float a = key[i];
		if(abs(a - clickPos) < error){
			animSlider->bField = key[i];
			timeLine->samplePose = samplePose;
			timeLine->keyIndex = i;
			return true;
		}
	}
	return false;
}

bool ScalarInterpolator::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	return commonSearchKeyFrameInTimeLine(animCP.timeLine, animCP.animSlider, key, clickPos, this);
}

bool OrientationInterpolator::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	return commonSearchKeyFrameInTimeLine(animCP.timeLine, animCP.animSlider, key, clickPos, this);
}

bool PositionInterpolator::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	return commonSearchKeyFrameInTimeLine(animCP.timeLine, animCP.animSlider, key, clickPos, this);
}

bool NurbsTrack::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	return commonSearchKeyFrameInTimeLine(animCP.timeLine, animCP.animSlider, key, clickPos, this);
}

bool CPMorpher::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	return commonSearchKeyFrameInTimeLine(animCP.timeLine, animCP.animSlider, key, clickPos, this);
}

bool PosCompensator::searchKeyFrameInTimeLine(AnimControlPanel& animCP, const float clickPos){
	AnimTimeLine* timeLine = animCP.timeLine;
	AnimSlider* animSlider = animCP.animSlider;
	Anim* anim = &timeLine->anim;
	rightSideDrag = false;

	for(int i = 0; i < moment.length; i++){
		float error = .25 / (anim->stepsPerSecond * anim->period);
		float midPoint = (moment[i].x + moment[i].y) * .5;
		if(clickPos >= moment[i].x - error && clickPos <= midPoint){
			animSlider->bField = moment[i].x;
			timeLine->samplePose = this;
			timeLine->keyIndex = i;
			return true;
		}
		if(clickPos >= midPoint && clickPos <= moment[i].y + error){
			animSlider->bField = moment[i].y;
			timeLine->samplePose = this;
			timeLine->keyIndex = i;
			rightSideDrag = true;
			return true;
		}
	}
	return false;
}

void commonPlotRecordNotch(AnimTimeLine* tl, Anim* anim, M_Float& key){
	for(int i = 0; i < key.length; i++){
		int m = (key[i] - tl->anim.displayFrom) * tl->animCP.animZoom * static_cast<float>(tl->lineDist);
		if(m < 0){
			continue;
		}
		if(m <= tl->lineDist){
			m += tl->dstPos.x + tl->lineOffset;
			drawVerticleLine2(0xff0000, m-2, tl->dstPos.y, tl->dstPos.y+tl->bSize.y, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
			drawVerticleLine2(0xff0000, m-1, tl->dstPos.y, tl->dstPos.y+tl->bSize.y, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
			drawVerticleLine2(0xff0000, m+1, tl->dstPos.y, tl->dstPos.y+tl->bSize.y, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
			drawVerticleLine2(0xff0000, m,   tl->dstPos.y, tl->dstPos.y+tl->bSize.y, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
		}
		else{
			break;
		}
	}
}

void OrientationInterpolator::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	if(Art* part = dynamic_cast<Art*>(node)){
		if(g_timelineFilter->rotation){
			if(&part->rotation == field || &part->ikRot == field){
				commonPlotRecordNotch(tl, anim, key);
			}
		}
	}
	else if(Viewpoint* view = dynamic_cast<Viewpoint*>(node)){
		if(g_timelineFilter->orientation){
			commonPlotRecordNotch(tl, anim, key);
		}
	}
}

void PositionInterpolator::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	if(Art* part = dynamic_cast<Art*>(node)){
		if(g_timelineFilter->translation){
			if(&part->translation == field || &part->ikPos == field){
				commonPlotRecordNotch(tl, anim, key);
			}
		}
	}
	else if(Viewpoint* view = dynamic_cast<Viewpoint*>(node)){
		if(g_timelineFilter->position){
			commonPlotRecordNotch(tl, anim, key);
		}
	}
}

void ScalarInterpolator::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	if(Art* part = dynamic_cast<Art*>(node)){
		if(
			g_timelineFilter->fka && &part->fka == field ||
			g_timelineFilter->fkb && &part->fkb == field
			){
			commonPlotRecordNotch(tl, anim, key);
		}
	}
	else if(Viewpoint* view = dynamic_cast<Viewpoint*>(node)){
		if(
			g_timelineFilter->zoom && &view->zoom == field ||
			g_timelineFilter->fieldOfView && &view->fieldOfView == field
			){
			commonPlotRecordNotch(tl, anim, key);
		}
	}
}

void NurbsTrack::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	commonPlotRecordNotch(tl, anim, key);
}
void CPMorpher::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	commonPlotRecordNotch(tl, anim, key);
}

void PosCompensator::plotRecordNotch(AnimTimeLine* tl, Anim* anim, Node* node, Field* field){
	for(int i = 0; i < moment.length; i++){
		int m = tl->dstPos.x + tl->lineOffset + (moment[i].x - tl->anim.displayFrom) * tl->animCP.animZoom * static_cast<float>(tl->lineDist);
		int m2 = tl->dstPos.x + tl->lineOffset + (moment[i].y - tl->anim.displayFrom) * tl->animCP.animZoom * static_cast<float>(tl->lineDist);
		drawHorizontalLine2(0x0, tl->dstPos.y + 2, m, m2, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
		drawHorizontalLine2(0x0, tl->dstPos.y + 3, m, m2, tl->win.size.x, tl->win.size.y, tl->win.pixBuf.getArray());
	}
}

void AnimSlider::paint(){
	setPixelPos();
	if(anim.play){
		animCP.playButton->srcPos.x = 432 + 24;
	}
	else{
		animCP.playButton->srcPos.x = 432;
	}
	if(anim.play==false){
		animCP.pauseButton->srcPos.x = 384 + 24;
	}
	else{
		animCP.pauseButton->srcPos.x = 384;
	}
	if(anim.loop){
		animCP.loopButton->srcPos.x = 384 - 48 + 24;
	}
	else{
		animCP.loopButton->srcPos.x = 384 - 48;
	}

	int srcPosX = srcPos.x;
	int srcPosY = srcPos.y;
	Node* node = g_selNode.getRaw();
	if(Art* part = dynamic_cast<Art*>(node)){
		if(part->track && part->smls->track){
			srcPosX = 3 * 24 + 2;
			srcPosY = 213;
		}
	}

	pasteSprite2(dstPos.x, dstPos.y, srcPosX, srcPosY, win.size.x, win.size.y, iconSrcBufCX, iconSrcBufCY, bSize.x, bSize.y, win.pixBuf.getArray());
	//paintFieldName();
}
void AnimSlider::setPixelPos(){
	AnimTimeLine* timeLine = animCP.timeLine;
	int i = (bField.refValue() - anim.displayFrom) * timeLine->lineDist * animCP.animZoom;
	dstPos.x = timeLine->dstPos.x + timeLine->lineOffset + i - (bSize.x / 2);
}
void AnimSlider::action(){
	removeTypeFromList < Button>(g_callBackList);
	removeTypeFromList < DownButton>(g_callBackList);
	dragPos = g_mousePos;
	g_animSliderFakeDrag.remDisplayFrom = anim.displayFrom;
	g_animSliderFakeDrag.timeStart = g_time;
	g_animSliderFakeDrag.anim = &anim;
	g_animSliderFakeDrag.animCP = &animCP;
	g_drag = this;
	g_callBackList += &g_animSliderFakeDrag;
	anim.selectTo = 0;
	anim.selectFrom = 0;
}

void AnimSlider::doDrag(const Vec2i ptCursor){
}

void AnimControlPanel::updateVideo(){
	if(Video* video = dynamic_cast<Video*>(anim->video.p)){
		int i = anim->slider * anim->period * anim->stepsPerSecond + .5;
		if(i != video->frame){
			video->frame = i;
			if(g_vcp && g_vcp->isVisible()){
				g_vcp->paint();
			}
		}
	}
}

void AnimSlider::endDrag(const Vec2i ptCursor){
	removeTypeFromList<AnimSliderFakeDrag>(g_callBackList);
	g_drag = 0;
	const Vec2i localCursor = ptCursor-win.pos;

	anim.quantizeSlider();

	if(localCursor >= dstPos && localCursor < dstPos + bSize){
		open = true;//prevent tool tip opening
		g_callBackList += this;
	}
}
//void AnimTimeLine::doCallBack(){
//}
extern M_<Ptr<Viewpoint> > g_viewpoints;
extern int g_viewIndex;
void plotPixel2(unsigned color, int x, int y, int dstWidth, int dstHeight, int* pixBuf);

void Composition::plotRecordNotch(AnimControlPanel* animCP, Anim* anim){
	float* fbuf = this->fbuf;
	if(fbuf == 0){
		return;
	}
	AnimTimeLine* timeLine = animCP->timeLine;

	int dstWidth = animCP->size.x;
	int dstHeight = animCP->size.y;
	int* dstPix = animCP->pixBuf.getArray();
	drawHorizontalLine2(0xc0c0c0, 33, 0, dstWidth, dstWidth, dstHeight, dstPix);
	double pixPeriod = anim->zoom / timeLine->lineDist;
	double time = 0;

/*
	//int prevX = timeLine->lineOffset;
	//int prevY = 33 + (fbuf[0] * 40.0 + .5);
	for(int i = 0; i < timeLine->lineDist; i++){
		int x = i + timeLine->lineOffset;
		int idx = time * 44100;
		int y = 33 + (fbuf[idx] * 40.0 + .5);
		//drawVerticleLine2(0x0000ff, i, y, y - prevY, dstWidth, dstHeight, dstPix);
		//line(0x0000ff, prevX, prevY, x, y, dstWidth, dstHeight, dstPix);
		plotPixel2(0x0000ff, x, y, dstWidth, dstHeight, dstPix);
		//prevY = y;
		//prevX = x;
		time += pixPeriod;
	}
*/
	int from = anim->displayFrom * anim->period * 44100;
	float displayPeriod = anim->zoom;
	if(anim->period < displayPeriod){
		displayPeriod = anim->period;
	}
	for(int i = 0; i < 44100 * displayPeriod; i++){
		int y = 33 + (fbuf[from + i] * 30.0 + .5);
		double time = i / 44100.0;
		int x = time / pixPeriod + timeLine->lineOffset;
		plotPixel2(0x00ff00, x, y, dstWidth, dstHeight, dstPix);
	}
}


void AnimTimeLine::paint(){
	float displayTime = anim.period - (anim.displayFrom * anim.period);
	if(displayTime > anim.zoom){
		displayTime = anim.zoom;
	}

	int numOf = anim.stepsPerSecond * displayTime + .5;
	if(numOf == 0){
		numOf = 1;
	}

	if(Composition* composition = dynamic_cast<Composition*>(anim.soundTrack.p)){
		composition->plotRecordNotch(&animCP, &anim);
	}
	float f  = (static_cast<float>(lineDist) / numOf);
	//double d  =  anim.displaySeconds / anim.period / numOf;
	//double step = 1.0 / anim.stepsPerSecond;
	double step = 1.0 / anim.stepsPerSecond / anim.period;

	double qz_displayFrom = quantize(anim.displayFrom, 1.0 / (anim.stepsPerSecond * anim.period));

	//if(anim.period < anim.zoom){
	//	numOf = anim.stepsPerSecond * anim.period + .5;
	//}

	double notchDiv = 1.0 / 5.0;
	if(anim.stepsPerSecond == 10){
		notchDiv = 1.0 / 2.0;
	}
	else if(anim.stepsPerSecond == 15){
		notchDiv = 1.0 / 3.0;
	}
	else if(anim.stepsPerSecond == 20 || anim.stepsPerSecond == 24){
		notchDiv = 1.0 / 4.0;
	}
	else if(anim.stepsPerSecond == 30 || anim.stepsPerSecond == 60){
		notchDiv = 1.0 / 6.0;
	}

	for(int i = 0; i < numOf + 1; i++){
		unsigned int colour = 0x808080;
		int endLine = dstPos.y + bSize.y;
		double a = (i * step + qz_displayFrom);
		double md = abs(fmod(a * anim.period, 1));
		double md2 = abs(fmod(a * anim.period, notchDiv));

		int m = (a - anim.displayFrom) * animCP.animZoom * static_cast<float>(lineDist);
		m += dstPos.x + lineOffset;

		if(md2 < .0001 || notchDiv - md2 < .0001){
			endLine += 2;
			colour = 0;
		}
		if(md < .0001 || 1.0 - md < .0001){
			if(anim.zoom <= 32){
				int seconds = a * anim.period + .5;

				int minutes = seconds / 60;

				seconds -= minutes * 60;

				if(seconds <= 9){
					str = '0';
					str += seconds;
				}
				else{
					str = seconds;
				}

				drawText2(str, 0, Vec2i(m - 8, dstPos.y-4), win.size.x, win.size.y, win.pixBuf.getArray());
			}
		}
		drawVerticleLine2(colour, m,     dstPos.y, endLine, win.size.x, win.size.y, win.pixBuf.getArray());
		drawVerticleLine2(colour, m - 1, dstPos.y, endLine, win.size.x, win.size.y, win.pixBuf.getArray());
	}
	//if(Art* art=Window::returnOpenArt()){
	if(Art* part = dynamic_cast<Art*>(g_selNode.getRaw())){
		anim.plotRecordNotch(this, part);
	}
	else if(Viewpoint* viewpoint = dynamic_cast<Viewpoint*>(g_selNode.getRaw())){
		if(g_viewIndex < g_viewpoints.length){
			if(viewpoint == g_viewpoints[g_viewIndex]){
				anim.plotRecordNotch(this, viewpoint);
			}
		}
	}


	animCP.updateVideo();
}

void AnimTimeLine::action(){
	const Vec2i ptCursor = g_mousePos - win.pos;

	removeTypeFromList < Button>(g_callBackList);
	removeTypeFromList < DownButton>(g_callBackList);

	samplePose=0;
	g_animHighlightFakeDrag.remDisplayFrom = anim.displayFrom;
	g_animSliderFakeDrag.timeStart = g_time;

	const float xPos = ptCursor.x - dstPos.x - lineOffset;
	float f = xPos / lineDist / animCP.animZoom + anim.displayFrom;

	if(Art* art = dynamic_cast<Art*>(g_selNode.getRaw())){
		if(anim.searchKeyFrameInTimeLine(animCP, art, f)){
			//animSlider->setPixelPos();
			dragPos = g_mousePos;
			g_drag = this;
			return;
		}
	}
	f = quantize(f, 1.0 / (anim.stepsPerSecond * anim.period));
	anim.slider = f;
}

void AnimTimeLine::doDrag(const Vec2i ptCursor){
	const float xPos = ptCursor.x - dstPos.x - lineOffset;
	float f = xPos / lineDist / animCP.animZoom + anim.displayFrom;

//	dragPos=g_mousePos;
	samplePose->setKeyDragPos(keyIndex, f);
	//win.paint();
}

void AnimTimeLine::endDrag(const Vec2i ptCursor){
	if(samplePose){
		Anim& anim=*(animCP.anim);

		const float xPos = ptCursor.x - dstPos.x - lineOffset;
		float f = xPos / lineDist / animCP.animZoom + anim.displayFrom;
		f = quantize(f, 1.0/(anim.stepsPerSecond * anim.period));
		samplePose->setKeyDragPos(keyIndex, f);
		//anim.slider=f;
	}
}
void AnimControlPanel::setupNodeWindow(Node* node){
	g_scene->xRayEdit = false;
	this->node=node;
	anim = dynamic_cast<Anim*>(node);

	const M_Properties& properties = node->getProperties();

	g_controlPanelOpen = true;
	g_propWinLine.length = 0;
	buttonList.length = 0;
	int yPos = title_bar_height + 1;
	int lastYPos = yPos;

	size = Vec2i(g_tb->size.x, 52);
	pos = Vec2i(g_tb->pos.x, g_tb->pos.y-52);

	AnimSlider* animSlider=new AnimSlider(Vec2i(20,16), Vec2i(80, 26), Vec2i(316,176), 0, this, this, anim, anim->slider, properties[0], Vec2i(415-24-20, 0), Vec2i(8*8+4, 16));
	this->animSlider=animSlider;
	buttonList+=animSlider;
	g_propWinLine+=PropWinLine(yPos, animSlider);

	AnimTimeLine* timeLine=new AnimTimeLine(Vec2i(size.x,6), Vec2i(0, 42), 0, this, this, anim, anim->timeLine, properties[1]);
	buttonList+=timeLine;
	this->timeLine=timeLine;
	g_propWinLine+=PropWinLine(yPos, timeLine);

	animSelect = new AnimSelect(Vec2i(size.x, 17), Vec2i(0, 42 - 17), 0, this, this, anim, anim->animSelect, properties[2]);
	buttonList += animSelect;
	g_propWinLine += PropWinLine(yPos, animSelect);

	//////
	playButton=new AnimControlPanel::Play(Vec2i(24,24), Vec2i(340-24-20, 0), Vec2i(432,176), 0, this, this, anim, anim->play, properties[3]);
	playButton->srcPos=Vec2i(432,176);
	buttonList+=playButton;
	g_propWinLine+=PropWinLine(yPos, playButton);

	pauseButton=new AnimControlPanel::Pause(Vec2i(24,24), Vec2i(340-20, 0), Vec2i(384,176), 0, this, this, anim, anim->pause, properties[4]);
	buttonList+=pauseButton;
	g_propWinLine+=PropWinLine(yPos, pauseButton);

	loopButton=dynamic_cast<SFBoolButton*>(anim->loop.setUpControl(*node, anim->loop, properties[5], 0, 340+24, 0, *this));
	loopButton->bSize=Vec2i(24, 24);
	loopButton->dstPos=Vec2i(340+24-20, 0);
	loopButton->srcPos=Vec2i(384-48,176);
	loopButton->iconSize=Vec2i(24, 24);
	buttonList+=loopButton;
	g_propWinLine+=PropWinLine(yPos, loopButton);

	//FieldButton* button = anim->zoom.setUpControl(*node, anim->speed, properties[6], 0, 544+78-24-4-24, 1, *this);
	AnimZoom* animZoom = new AnimZoom(Vec2i(24,24), Vec2i(544+78-24-4-24, 1), Vec2i(292,191), 0, this, this, anim, anim->zoom, properties[6]);
	animZoom->bSize = Vec2i(24, 24);
	animZoom->srcPos = Vec2i(24*3,24);
	animZoom->iconSize = Vec2i(24, 24);
	buttonList+=animZoom;
	g_propWinLine+=PropWinLine(yPos, animZoom);

	AnimPeriod* animPeriod = new AnimPeriod(Vec2i(24,24), Vec2i(544+78-24-4, 1), Vec2i(292,191), 0, this, this, anim, anim->period, properties[7]);
	animPeriod->iconSize=Vec2i(24, 18);
	buttonList+=animPeriod;
	g_propWinLine+=PropWinLine(yPos, animPeriod);

	FieldButton* button = anim->stepsPerSecond.setUpControl(*node, anim->stepsPerSecond, properties[8], 0, 544+78, 1, *this);
	button->bSize=Vec2i(24, 24);
	button->srcPos=Vec2i(268, 191);
	button->iconSize=Vec2i(24, 18);
	button->valPos.x=button->dstPos.x+24+4;
	button->valSize.x=8*7;
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

	button = anim->speed.setUpControl(*node, anim->speed, properties[9], 0, 544+78*2, 1, *this);
	button->bSize=Vec2i(24, 24);
	button->srcPos=Vec2i(24*14, 24);
	button->iconSize=Vec2i(24, 24);
	button->valPos.x=button->dstPos.x+24+4;
	button->valSize.x=8*7;
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

//	button = new AnimPlayFrom(*node, anim->speed, properties[10], 0, 400+48+24*1-24-10, 1, *this);
	button = new AnimPlayFrom(Vec2i(24,24), Vec2i(400+48+24*1-24-10, 1), Vec2i(292,191), 0, this, this, anim, anim->playFrom, properties[10]);
	button->bSize=Vec2i(24, 24);
	button->srcPos=Vec2i(96, 209);
	button->iconSize=Vec2i(24, 24);
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

	button=anim->copy.setUpControl(*node, anim->copy, properties[11], 0, 400+48+24*1, 0, *this);
	button->dstPos=Vec2i(410+48+24*1, 0);
	button->srcPos=Vec2i(176,176);
	button->bSize=Vec2i(24,24);
	button->iconSize=Vec2i(16,16);
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

	button=anim->paste.setUpControl(*node, anim->paste, properties[12], 0, 400+48+24*2, 0, *this);
	button->dstPos=Vec2i(410+48+24*2, 0);
	button->srcPos=Vec2i(16,192);
	button->bSize=Vec2i(24,24);
	button->iconSize=Vec2i(16,16);
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

	button=anim->remove.setUpControl(*node, anim->remove, properties[13], 0, 400+48+24*3, 0, *this);
	button->dstPos=Vec2i(410+48+24*3, 0);
	button->srcPos=Vec2i(delete_x, delete_y);
	button->bSize=Vec2i(24,24);
	button->iconSize=Vec2i(16,16);
	buttonList+=button;
	g_propWinLine+=PropWinLine(yPos, button);

//	paint();
	houseKeepVisualClue();
}
void AnimControlPanel::setWinSize(Vec2i& raw){
	pixBuf.length = raw.x * raw.y;
	if(timeLine){
		timeLine->bSize = Vec2i(Vec2i(size.x,8));
		timeLine->lineDist = timeLine->bSize.x-timeLine->lineOffset*2;

	}
	if(E_FAIL == initWindow()){
		throw;
	}
}

void AnimPeriod::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	double s = anim.period / (anim.period + 1.0);

	float v = bField.refValue();
	anim.scaleTime(1.0); //add second

	anim.slider = anim.slider * (v / (v + 1.0));
	v++;

	bField = v;
	
	anim.quantizeSlider();
}

void AnimZoom::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	double& v = bField.refValue();

	switch(command){
		case 0:
			if(v < 8){
				v++;
			}
			else{
				v = v * 2;
			}
			break;
		case 1:
			if(v <= 8){
				v--;
			}
			else{
				v = v * .5;
			}
			if(v < 1){
				v = 1;
			}
			break;
	}
	bField = v;
}

void AnimPlayFrom::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	if(anim.slider < .99){
		bField = anim.slider;
	}
}

void ArtRotationButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	Rotation& v=bField.refValue();
	sAction(v, command);
	bField = v;
	if(Anim* anim=Window::animMode()){
		if(anim->play==false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.rotation);
		}
	}
}

void ArtTranslationButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	Vec3f& v = bField.refValue();
	switch(command){
		case 0:
			quantizeDec(v.x);
			break;
		case 1:
			quantizeInc(v.x);
			break;
		case 2:
			quantizeDec(v.y);
			break;
		case 3:
			quantizeInc(v.y);
			break;
		case 4:
			quantizeDec(v.z);
			break;
		case 5:
			quantizeInc(v.z);
			break;
	}
	bField = v;
	if(Anim* anim = Window::animMode()){
		if(anim->play == false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.translation);
		}
	}
}

void ArtIKRotButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	Rotation& v=bField.refValue();
	sAction(v, command);
	bField = v;
	if(Anim* anim=Window::animMode()){
		if(anim->play==false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.ikRot);
		}
	}
}

void ArtIKPosButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	Vec3f& v = bField.refValue();
	switch(command){
		case 0:
			quantizeDec(v.x);
			break;
		case 1:
			quantizeInc(v.x);
			break;
		case 2:
			quantizeDec(v.y);
			break;
		case 3:
			quantizeInc(v.y);
			break;
		case 4:
			quantizeDec(v.z);
			break;
		case 5:
			quantizeInc(v.z);
			break;
	}
	bField = v;
	if(Anim* anim = Window::animMode()){
		if(anim->play == false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.ikPos);
		}
	}
}

void ArtFkaButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	float& v = bField.refValue();

	switch(command){
		case 0:
			quantizeDec(v);
			if(v < 0){
				v = 0;
			}
			break;
		case 1:
			quantizeInc(v);
			if(v > 1){
				v = 1;
			}
			break;
	}
	bField = v;
	if(Anim* anim = Window::animMode()){
		if(anim->play == false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.fka);
		}
	}
}

void ArtFkbButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	float& v = bField.refValue();

	switch(command){
		case 0:
			quantizeDec(v);
			if(v < 0){
				v = 0;
			}
			break;
		case 1:
			quantizeInc(v);
			if(v > 1){
				v = 1;
			}
			break;
	}
	bField = v;
	if(Anim* anim = Window::animMode()){
		if(anim->play == false && Anim::autoCapture){
			anim->captureSinglePartPose(&part, &part.fkb);
		}
	}
}

void ArtCoordPointButton::action(){
	if(outOfSyncWithRobot()){
		return;
	}
	float res = getIncDecRes();

	if(part.smls->workAnimCP && (Window::animMode() || g_colorOwnership)){

		M_ControlPoint& controlPoint = part.controlPoint;
		if(controlPoint.length == 0){
			return;
		}
		if(MultiSelect::selectedPoint >= controlPoint.length){
			MultiSelect::selectedPoint = 0;
		}
		ControlPoint& cp = part.controlPoint[MultiSelect::selectedPoint];
		NurbsPatch* patch = cp.p;
		patch->index[0] = cp.i;

		M_Vec3f t = patch->dpoint.refValue();
		Vec3f& e = t[cp.i];

		switch(command){
			case 0:
				quantizeDec(e.x);
				break;
			case 1:
				quantizeInc(e.x);
				break;
			case 2:
				quantizeDec(e.y);
				break;
			case 3:
				quantizeInc(e.y);
				break;
			case 4:
				quantizeDec(e.z);
				break;
			case 5:
				quantizeInc(e.z);
				break;
		}
		patch->dpoint = t;
		updateBuild3dWindow(true);
		return;
	}


	if(bField.length==0){
		return;
	}
	M_Vec3f t = bField;
	Vec3f& e = t[node.getFieldGroupIndex(sprop.groupIndex)-sprop.startAtIndex];

	switch(command){
		case 0:
			quantizeDec(e.x);
			break;
		case 1:
			quantizeInc(e.x);
			break;
		case 2:
			quantizeDec(e.y);
			break;
		case 3:
			quantizeInc(e.y);
			break;
		case 4:
			quantizeDec(e.z);
			break;
		case 5:
			quantizeInc(e.z);
			break;
	}
	bField = t;
	updateBuild3dWindow();
}

bool ArtRotationButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	Rotation value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.rotation);
			}
		}
		return true;
	}
	return false;
}

bool ArtTranslationButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	Vec3f value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.translation);
			}
		}
		return true;
	}
	return false;
}

bool ArtIKRotButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	Rotation value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.ikRot);
			}
		}
		return true;
	}
	return false;
}

bool ArtIKPosButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	Vec3f value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.ikPos);
			}
		}
		return true;
	}
	return false;
}

bool ArtFkaButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	float value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.fka);
			}
		}
		return true;
	}
	return false;
}

bool ArtFkbButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	int i = 0;
	float value; textCellStr.toValue(value);
	if(notCloseEnough(bField,value)){
		bField = value;
		if(Anim* anim=Window::animMode()){
			if(anim->play == false && Anim::autoCapture){
				anim->captureSinglePartPose(&part, &part.fkb);
			}
		}
		return true;
	}
	return false;
}

bool ArtCoordPointButton::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	if(!bField.length)return false;
	Vec3f sval; textCellStr.toValue(sval);
	if(notCloseEnough(bField.refValue()[index],sval)){
		M_<Vec3f> m = bField;
		m[index] = sval;
		bField = m;
		return true;
	}
	return false;
}


void AnimControlPanel::Play::action(){
	if(anim.period < .000001){
		return;
	}
	bField = !bField.refValue();

//	if(&anim.play==&bField){
//		int a =0;
//	}

	if(anim.play==false){
		animCP.animSlider->setPixelPos();
	}
	houseKeepVisualClue();
}
void AnimControlPanel::Pause::action(){
	if(anim.period < .000001){
		return;
	}
	bField=!bField.refValue();

	if(anim.play==false){
		animCP.animSlider->setPixelPos();
	}
	houseKeepVisualClue();
}

void ArtIKButton::action(){
	bField=!bField.refValue();
	if(bField){
		if(Anim* anim = Window::animMode()){
			Art* part = dynamic_cast<Art*>(g_selNode.getRaw());
			part->ikPos.refValue() = part->absolutePivotPoint;
		}
	}
	removeTypeFromList < Button>(g_callBackList);
	removeTypeFromList < DownButton>(g_callBackList);
	g_stw->cp->setupNodeWindow(g_selNode.getRaw());
	Window::checkIfMouseIsHoveringAWindowAndUpdate(g_mousePos);
}

void AnimSelect::paint(){
	if(anim.selectFrom == anim.selectTo){
		return;
	}
	int numOf = anim.stepsPerSecond * anim.period;
	if(numOf == 0){
		numOf = 1;
	}
	int m = dstPos.x + lineOffset + (anim.selectFrom - anim.displayFrom) * animCP.animZoom * static_cast<float>(lineDist);
	int m2 = dstPos.x + lineOffset + (anim.selectTo - anim.displayFrom) * animCP.animZoom * static_cast<float>(lineDist);
	paintBlock2(0xFFD060, m, dstPos.y, m2, dstPos.y + bSize.y, win.size.x, win.size.y, win.pixBuf.getArray());
}


void AnimSelect::action(){
	removeTypeFromList<Button>(g_callBackList);
	removeTypeFromList<DownButton>(g_callBackList);

	dragPos = g_mousePos;
	g_animHighlightFakeDrag.anim = &anim;
	g_animHighlightFakeDrag.animCP = &animCP;
	g_drag = this;
	g_callBackList += &g_animHighlightFakeDrag;

	const Vec2i ptCursor = g_mousePos;
	const double xPos = g_mousePos.x-win.pos.x - dstPos.x - lineOffset;
	double f = xPos / lineDist / animCP.animZoom + anim.displayFrom;
	if( f < 0){
		f = 0;
	}
	if( f > 1){
		f = 1;
	}
	anim.selectFrom = anim.selectTo = f;
}

void AnimSelect::doDrag(const Vec2i ptCursor){
}

void AnimSelect::endDrag(const Vec2i ptCursor){
	removeTypeFromList<AnimHighlightFakeDrag>(g_callBackList);
	g_drag = 0;
	const Vec2i localCursor = ptCursor-win.pos;

	int frames = anim.stepsPerSecond * anim.period + .5;
	anim.selectTo = quantize(anim.selectTo, 1.0 / frames);
	anim.selectFrom = quantize(anim.selectFrom, 1.0 / frames);

	if(localCursor >= dstPos && localCursor < dstPos + bSize){
		open = true;//prevent tool tip opening
		g_callBackList += this;
	}
}

void PasteOptions::Ok::operator=(bool const &){
	//if(home.addRelative){
	//	Window::closeWindow(Window::activeWindow.getActiveWindow());
	//	g_stw->cp->setupNodeWindow(g_addRelative.p);
	//	Window::activeWindow=g_stw->cp.p;
	//}
	Window::closeWindow(Window::activeWindow.getActiveWindow());
	if(dynamic_cast<Anim*>(g_selNode.getRaw()) == 0){
		g_stw->cp->setupNodeWindow(g_selNode.getRaw());
		Window::activeWindow = g_stw->cp.p;
	}
	Window::animMode()->pasteSection();
}

void PasteOptions::Filter::operator=(bool const &){
	Window::closeWindow(Window::activeWindow.getActiveWindow());
	g_timelineFilter->okMode = TimelineFilter::back_to_pasteOptions;
	g_stw->cp->setupNodeWindow(g_timelineFilter);
	Window::activeWindow = g_stw->cp.p;
}

void DeleteOptions::Filter::operator=(bool const &){
	Window::closeWindow(Window::activeWindow.getActiveWindow());
	g_timelineFilter->okMode = TimelineFilter::back_to_deleteOptions;
	g_stw->cp->setupNodeWindow(g_timelineFilter);
	Window::activeWindow = g_stw->cp.p;
}


//void AddRelative::Ok::operator=(bool const &){
//	Window::closeWindow(Window::activeWindow.getActiveWindow());
//	g_stw->cp->setupNodeWindow(g_selNode.getRaw());
//	Window::activeWindow=g_stw->cp.p;
//	Window::animMode()->pasteSection(g_selNode.getRaw());
//}

void openAnimEditOptions(){
	g_timelineFilter->okMode = TimelineFilter::back_to_selected_node;
	g_stw->cp->setupNodeWindow(g_timelineFilter);
	Window::activeWindow = g_stw->cp.p;
}

void TimelineFilter::Ok::operator=(bool const &){
	Window::closeWindow(Window::activeWindow.getActiveWindow());
	switch(g_timelineFilter->okMode){
		case TimelineFilter::back_to_deleteOptions:{
			g_stw->cp->setupNodeWindow(g_deleteOptions);
			Window::activeWindow = g_stw->cp.p;
			break;
		}
		case TimelineFilter::back_to_pasteOptions:{
			g_stw->cp->setupNodeWindow(g_pasteOptions);
			Window::activeWindow = g_stw->cp.p;
			break;
		}
		case TimelineFilter::back_to_selected_node:{
			if(dynamic_cast<Anim*>(g_selNode.getRaw()) == 0){
				g_stw->cp->setupNodeWindow(g_selNode.getRaw());
				Window::activeWindow = g_stw->cp.p;
			}
			break;
		}
	}
}

void DeleteOptions::Ok::operator=(bool const &){
	Window::closeWindow(Window::activeWindow.getActiveWindow());
	if(dynamic_cast<Anim*>(g_selNode.getRaw()) == 0){
		g_stw->cp->setupNodeWindow(g_selNode.getRaw());
		Window::activeWindow = g_stw->cp.p;
	}
	Window::animMode()->deleteSection();
}

void doCurveDistance(bool state){
	g_pasteOptions->curveDistance = 0;
	g_animCurve.processed = false;
	if(state){
		if(NurbsTrack* nurbsTrack = dynamic_cast<NurbsTrack*>(g_selNode.getRaw())){
			g_animCurve.processFields(nurbsTrack, (g_animCopy.selectTo - g_animCopy.selectFrom) * g_animCopy.period);
		}
		else if(NurbsTrack* nurbsTrack = dynamic_cast<NurbsTrack*>(g_copyNode.getRaw())){
			g_animCurve.processFields(nurbsTrack, (g_animCopy.selectTo - g_animCopy.selectFrom) * g_animCopy.period);
		}
	}
}

void doCalcRot(bool state){
	if(Art* selPart = dynamic_cast<Art*>(g_selNode.getRaw())){
		if(state){
			if(selPart->ik){
				g_pasteOptions->rotate = g_animCopy.rotDiff * selPart->ikRot;
				g_pasteOptions->translate = selPart->ikPos - g_pasteOptions->rotate.refValue() * g_animCopy.tranDiff;
			}
			else{
				g_pasteOptions->rotate = g_animCopy.rotDiff * selPart->rotation;
				g_pasteOptions->translate = selPart->translation - g_pasteOptions->rotate.refValue() * g_animCopy.tranDiff;
			}
		}
		else{
			g_pasteOptions->rotate = Rotation();
			if(selPart->ik){
				g_pasteOptions->translate = selPart->ikPos - g_animCopy.tranDiff;
			}
			else{
				g_pasteOptions->translate = selPart->translation - g_animCopy.tranDiff;
			}
		}
	}
}

void PasteOptions::CalcRot::operator=(bool const& par){
	refValue() = par;
	doCalcRot(par);
}

void PasteOptions::Curve::operator=(bool const& par){
	refValue() = par;
	doCurveDistance(par);
}

void Anim::PastePose::operator=(const bool& par){
	g_pasteOptions->pivotPoint = Vec3f();
	g_pasteOptions->scale = Vec3f(1, 1, 1);
	g_pasteOptions->rotate = Rotation();
	g_pasteOptions->translate = Vec3f();

	doCalcRot(g_pasteOptions->calcRot);
	doCurveDistance(g_pasteOptions->curve);

	g_pasteOptions->steps = (g_animCopy.selectTo - g_animCopy.selectFrom) * g_animCopy.period / (1.0 / home.stepsPerSecond) + .5;
	g_stw->cp->setupNodeWindow(g_pasteOptions);
	Window::activeWindow = g_stw->cp.p;
		//}
		//else{
		//	float currentSlider = home.slider;
		//	home.slider.refValue() = home.copySlider;
		//	home.update = true;
		//	home.renderNodeFirst();
		//	Seamless* smls = part->smls;
		//	if(smls->animCP && smls->workAnimCP){
		//		smls->doBuild();
		//	}
		//	else{
		//		renderScene();
		//	}
		//	home.slider.refValue() = currentSlider;
		//	home.captureMultiplePartPose(part);
		//	home.update = true;
		//}
}

void Anim::DeletePose::operator=(const bool& par){
	home.copySlider = home.slider;
	g_stw->cp->setupNodeWindow(g_deleteOptions);
	Window::activeWindow = g_stw->cp.p;

	//if(home.selectFrom != home.selectTo){
	//	if(Art* part = dynamic_cast<Art*>(g_selNode.getRaw())){
	//		g_stw->cp->setupNodeWindow(g_deleteSection);
	//	}
	//}
	//else if(MemberFunction* function=dynamic_cast<MemberFunction*>(home.onFrame.p)){

	//	M_Node& m_codeLine=function->codeLine;

	//	M_Word& m_word=function->m_word;
	//	W_Field* w_dstField = 0;
	//	W_Field* w_srcField = 0;
	//	W_Node* w_morpher = 0;
	//	W_Node* w_part = 0;

	//	for(int i=m_codeLine.length; --i>=0;){
	//		if(getEquiveRoute(m_word, w_dstField, w_srcField, m_codeLine, i)){
	//			if(Art* part=dynamic_cast<Art*>(w_dstField->node)){
	//				if(SamplePose* samplePose=dynamic_cast<SamplePose*>(w_srcField->node)){
	//					if((0x8000&GetKeyState(VK_LCONTROL)) && part != dynamic_cast<Art*>(g_selNode.getRaw())){
	//						continue;
	//					}
	//					if((0x8000&GetKeyState(VK_LMENU))){
	//						continue;
	//					}
	//					samplePose->deleteSample(home.slider);
	//				}
	//			}
	//		}
	//		else if(getMorphFunction(m_word, w_morpher, w_part, m_codeLine, i)){
	//			if(CPMorpher* morpher = dynamic_cast<CPMorpher*>(w_morpher->node)){
	//				if(Art* part = dynamic_cast<Art*>(w_part->node)){
	//					if((0x8000&GetKeyState(VK_LCONTROL)) && part != dynamic_cast<Art*>(g_selNode.getRaw())){
	//						continue;
	//					}
	//					if((0x8000&GetKeyState(VK_LSHIFT))){
	//						continue;
	//					}
	//					morpher->deleteSample(home.slider);
	//				}
	//			}
	//		}
	//	}
	//	home.update=true;
	//}
}

void Anim::CopyPose::operator=(const bool& par){
	home.copySlider = home.slider;
	if((home.selectFrom - home.selectTo) == 0){
		home.selectFrom = home.selectTo = home.slider;
	}
	home.copySection();
}

void paintTrack(int x, int y, int dstWidth, int dstHeight, int* dstPix);

void AnimControlPanel::paint(){
	animZoom = anim->period / anim->zoom;
	if(anim->play){
		if(anim->slider < anim->displayFrom){
			anim->displayFrom = anim->slider;
		}
		if(anim->slider > anim->displayFrom + anim->zoom / anim->period){
			anim->displayFrom = anim->slider - anim->zoom / anim->period;
		}
	}
	ControlPanel::paint();
}

int String::hourMinSecFormatToValue(){
	int i = 0;
	int seconds = 0;
	int minutes = 0;
	int hours = 0;

	stb(i);
	if(i < length){
		hours = getInt(*this, i);
		stb(i);
		if(i < length){
			if(i < length && (*this)[i]==':'){
				i++;
			}
			stb(i);
			if(i < length){
				minutes = getInt(*this, i);
				stb(i);
				if(i < length && (*this)[i]==':'){
					i++;
				}
				stb(i);
				if(i < length){
					seconds = getInt(*this, i);
				}
			}
		}
	}

	return hours * 60 * 60 + minutes * 60 + seconds;
}

bool AnimSlider::updateValFromTextCell(String textCellStr, const int &index, const Properties& properties){
	float seconds = textCellStr.hourMinSecFormatToValue();
	if(seconds != bField * anim.period){
		if(seconds > anim.period){
			seconds = anim.period;
		}
		else if(seconds < 0){
			seconds = 0;
		}
		anim.slider = seconds / anim.period;

		if(anim.slider < anim.displayFrom){
			anim.displayFrom = anim.slider;
		}
		if(anim.slider > anim.displayFrom + anim.zoom / anim.period){
			anim.displayFrom = anim.slider - anim.zoom / anim.period;
		}

		return true;
	}
	return false;
}

void AnimSlider::toString(String& str)const{
	//bField.refValue() = (60 * 60 * 05 + 60 * 07 + 21) / anim.period;
	if(anim.period == 0){
		int a = 0;
	}
	int seconds = bField.refValue() * anim.period;
	int minutes = seconds / 60;
	int hours = minutes / 60;

	seconds -= minutes * 60;
	minutes -= hours * 60;

	if(hours <= 9){
		str += '0';
	}
	str += hours;
	str += ':';

	if(minutes <= 9){
		str += '0';
	}
	str += minutes;
	str += ':';

	if(seconds <= 9){
		str += '0';
	}
	str += seconds;
}


void AnimPeriod::paint(){
	int* dstPix = win.pixBuf.getArray();

	const int subDx=bSize.x;
	const int subDy=bSize.y;
	const int yLn=dstPos.y;

		
	int offset=0;
	int xLn=dstPos.x;

	int strx = sprop.name.length * 8 - 8;

	if(this==getHoverButton()){
		pasteRectangle2( activeColor, dstPos.x, yLn, win.size.x, win.size.y, subDx, subDy, dstPix);
		drawHorizontalLine2( 0x808080, yLn+subDy-1, xLn+1, xLn+subDx, win.size.x, win.size.y, dstPix);
		drawVerticleLine2( 0x808080, xLn+subDx, yLn+1, yLn+subDy, win.size.x, win.size.y, dstPix);
	}
	if(this==DownButton::getDownButton()){
		pasteRectangle2( activeColor, dstPos.x, yLn, win.size.x, win.size.y, subDx, subDy, dstPix);
		offset++;
		drawHorizontalLine2( 0x808080, yLn, xLn, xLn+subDx, win.size.x, win.size.y, dstPix);
		drawVerticleLine2( 0x808080, xLn, yLn+1, yLn+subDy-2, win.size.x, win.size.y, dstPix);
	}
	int dx = dstPos.x + ((bSize.x - iconSize.x) >> 1) + offset + 4;
	int dy = dstPos.y + ((bSize.y - iconSize.y) >> 1) + offset;

	pasteSprite2(dstPos.x+((bSize.x-iconSize.x)>>1)+offset, dstPos.y+((bSize.y-iconSize.y)>>1)+offset, srcPos.x, srcPos.y, win.size.x, win.size.y, iconSrcBufCX, iconSrcBufCY, iconSize.x, iconSize.y, win.pixBuf.getArray());
}

void AnimPlayFrom::paint(){
	int* dstPix = win.pixBuf.getArray();

	const int subDx=bSize.x;
	const int subDy=bSize.y;
	const int yLn=dstPos.y;

		
	int offset=0;
	int xLn=dstPos.x;

	int strx = sprop.name.length * 8 - 8;

	if(this==getHoverButton()){
		pasteRectangle2( activeColor, dstPos.x, yLn, win.size.x, win.size.y, subDx, subDy, dstPix);
		drawHorizontalLine2( 0x808080, yLn+subDy-1, xLn+1, xLn+subDx, win.size.x, win.size.y, dstPix);
		drawVerticleLine2( 0x808080, xLn+subDx, yLn+1, yLn+subDy, win.size.x, win.size.y, dstPix);
	}
	if(this==DownButton::getDownButton()){
		pasteRectangle2( activeColor, dstPos.x, yLn, win.size.x, win.size.y, subDx, subDy, dstPix);
		offset++;
		drawHorizontalLine2( 0x808080, yLn, xLn, xLn+subDx, win.size.x, win.size.y, dstPix);
		drawVerticleLine2( 0x808080, xLn, yLn+1, yLn+subDy-2, win.size.x, win.size.y, dstPix);
	}
	int dx = dstPos.x + ((bSize.x - iconSize.x) >> 1) + offset + 4;
	int dy = dstPos.y + ((bSize.y - iconSize.y) >> 1) + offset;

	pasteSprite2(dstPos.x+((bSize.x-iconSize.x)>>1)+offset, dstPos.y+((bSize.y-iconSize.y)>>1)+offset, srcPos.x, srcPos.y, win.size.x, win.size.y, iconSrcBufCX, iconSrcBufCY, iconSize.x, iconSize.y, win.pixBuf.getArray());
}

void AnimPeriod::workOutSubIndex(const Vec2i ptCursor){}
void AnimPlayFrom::workOutSubIndex(const Vec2i ptCursor){}


void TimelineFilter::UnTickAllFields::operator=(bool const&){
	home.morph = false;
	home.rotation = false;
	home.translation = false;
	home.posCompensation = false;
	home.fka = false;
	home.fkb = false;
	home.zoom = false;
	home.fieldOfView = false;
	home.orientation = false;
	home.position = false;
}
void TimelineFilter::TickPartFieldsOnly::operator=(bool const&){
	home.morph = true;
	home.rotation = true;
	home.translation = true;
	home.posCompensation = true;
	home.fka = true;
	home.fkb = true;
	home.zoom = false;
	home.fieldOfView = false;
	home.orientation = false;
	home.position = false;
}
void TimelineFilter::TickViewpointFieldsOnly::operator=(bool const&){
	home.morph = false;
	home.rotation = false;
	home.translation = false;
	home.posCompensation = false;
	home.fka = false;
	home.fkb = false;
	home.zoom = true;
	home.fieldOfView = true;
	home.orientation = true;
	home.position = true;
}
void TimelineFilter::SelectAllFields::operator=(bool const&){
	home.morph = true;
	home.rotation = true;
	home.translation = true;
	home.posCompensation = true;
	home.fka = true;
	home.fkb = true;
	home.zoom = true;
	home.fieldOfView = true;
	home.orientation = true;
	home.position = true;
}

/*
void AnimCurve::genCurve(){
	
	line.length=0;
		float step = 1.0 / numOfSteps;
		float t = step;
		
		//line+=Vec3f(point[p].x, point[p].y, point[p].z);
		//pnt.length = nopfs[s];

		for (int k = 1; k < numOfSteps; k++){
		//	line+=genCurve3(numOfSteps, p, s, t, pnt);
			t += step;
		}
	//line+=point[point.length-1];
*/
void CurvePoint (int dim, int degree, const float *knot, const Vec3f *pnt, const float *w, const float t, Vec3f& outPoint);

void NurbsTrack::genCurve(M_Vec3f& line, const int steps){

	if(!keyValue.length){
		return;
	}
	setMathHiPresision();
	const float inverseSize=(1 / g_scene->getZoom());
	const Vec3f* p = keyValue.getArray();
	const float* w = weight.getArray();;
	
	line.length = 0;

	int lineOffset = 0;
	for(int seg = 0; seg < dim.length; seg++){
		const int dm = dim[seg];

		int const knotOffset = knotRedirect[seg];
		float mint = minT(knotOffset);
		int const endOfKnotSeg = seg < (knotRedirect.length - 1) ? knotRedirect[seg + 1] : knot.length;
		float maxt = maxT(endOfKnotSeg);

		if(dm == 2){
			line.length += 2;
			Vec3f* linePtr = line.getArray();
			linePtr[lineOffset] = p[0];
			linePtr[lineOffset + 1] = p[1];
		}
		else{
			line.length += steps;
			Vec3f* linePtr = line.getArray();
			const float* knotPtr = knot.getArray() + knotOffset;


			for(int i = 0; i < steps; i++){
				float t = static_cast<float>(i) / (steps + 1);
				t = (maxt - mint) * t + mint;
				CurvePoint(dm - 1, degree, knotPtr, p, w, t, *(linePtr + lineOffset + i));
			}
		}
		lineOffset = line.length;
		p += dm - 1;
	}

}

void AnimCurve::genFlatHeight(){
	flatHeight.length = line.length - 1;
	float h = 0;
	for(int i = 0; i < flatHeight.length; i++){
		float xDiff = line[i+1].x - line[i].x;
		float yDiff = line[i+1].y - line[i].y;
		float zDiff = line[i+1].z - line[i].z;
		h += sqrt(xDiff * xDiff + yDiff * yDiff + zDiff * zDiff);
		flatHeight[i] = h;
	}
}

void AnimCurve::genHeightIndex(){
	heightIndex.length=flatHeight.length;

	float bezArcLen=flatHeight[flatHeight.length-1];
	float step=bezArcLen/flatHeight.length;
	for(int i=0, j=0; i<flatHeight.length; i++){
		float h = step*(i+1);
		while(j < line.length - 2 && h > flatHeight[j]){
			j++;
		}
		heightIndex[i]=j;
	}
}

void AnimCurve::generate(float t, int& idx, float& ratio){
	float bezArcLen = flatHeight[flatHeight.length-1];

	float timeDistanceRatio = selectedPeriod / bezArcLen;

	t = t / timeDistanceRatio;
	idx = t / bezArcLen * flatHeight.length;

	if(idx >= heightIndex.length){
		idx = heightIndex.length-1;
	}
	else if(idx < 0){
		idx = 0;
	}
	idx = heightIndex[idx];
		
	while(idx > 0 && t < flatHeight[idx-1]){
		idx--;
	}
	float flatDiff = flatHeight[idx];
	float coordDiff = t;

	if(idx > 0){
		flatDiff -= flatHeight[idx-1];
		coordDiff -= flatHeight[idx-1];
	}
	ratio = coordDiff / flatDiff;
}

void AnimCurve::generate(Vec3f& coord, float t){
	t = t * g_pasteOptions->newPeriod;

	int idx = 0;
	float ratio = 0;

	generate(t, idx, ratio);
	Vec3f s_crd = line[idx] + (line[idx + 1] - line[idx]) * ratio;
	float bezArcLen = flatHeight[flatHeight.length-1];
	float timeDistanceRatio = selectedPeriod / bezArcLen;
	float flatDistrance = t / timeDistanceRatio;



	Vec3f o = line[idx+1] - line[idx];
	o.y = 0;
	Rotation rot = Rotation(Vec3f(0, 0, 1), o);

	Vec3f v = rot * (coord - Vec3f(0, 0, flatDistrance));

	coord = v + s_crd - firstPoint;
}

void AnimCurve::generate(Rotation& rotation, float t){
	t = t * g_pasteOptions->newPeriod;

	int idx = 0;
	float ratio = 0;

	generate(t, idx, ratio);

	Vec3f o = line[idx+1] - line[idx];
	o.y = 0;
	Rotation rot = Rotation(Vec3f(0, 0, 1), o);
	rotation = rotation *  rot;
}

void AnimCurve::processFields(NurbsTrack* nurbsTrack, float selectedPeriod){
	this->selectedPeriod = selectedPeriod;
	flatHeight.length=0;
	heightIndex.length=0;
	line.length=0;

	M_Vec3f& point = nurbsTrack->keyValue.refValue();

	if(point.length==0){
		return;
	}

	firstPoint = point[0];

	nurbsTrack->genCurve(line, numOfSteps);
	genFlatHeight();
	genHeightIndex();

	g_pasteOptions->curveDistance = flatHeight[flatHeight.length-1];
	processed = true;
}

void transformInterpolators2(float selectFrom, OrientationInterpolator* orientationInterpolator, PositionInterpolator* positionInterpolator){
	float rem = orientationInterpolator->set_fraction;
	orientationInterpolator->set_fraction = selectFrom;
	g_animCopy.rotDiff = -orientationInterpolator->value_changed;
	orientationInterpolator->set_fraction = rem;

	rem = positionInterpolator->set_fraction;
	positionInterpolator->set_fraction = selectFrom;
	g_animCopy.tranDiff = positionInterpolator->value_changed;
	positionInterpolator->set_fraction = rem;
}

void Anim::transformInterpolators(const Art* part){
	if(part->ik){
		if(OrientationInterpolator* orientationInterpolator = getOrientationInterpolator(part, &part->ikRot)){
			if(PositionInterpolator* positionInterpolator = getPositionInterpolator(part, &part->ikPos)){
				transformInterpolators2(selectFrom, orientationInterpolator, positionInterpolator);
			}
		}
	}
	else{
		if(OrientationInterpolator* orientationInterpolator = getOrientationInterpolator(part, &part->rotation)){
			if(PositionInterpolator* positionInterpolator = getPositionInterpolator(part, &part->translation)){
				transformInterpolators2(selectFrom, orientationInterpolator, positionInterpolator);
			}
		}
	}
}

void setPasteDefault(){
	g_pasteOptions->insert = false;
	g_pasteOptions->beginEdge = true;
	g_pasteOptions->endEdge = true;
	g_pasteOptions->quantize = true;
	g_pasteOptions->transform = false;
	g_pasteOptions->calcRot = false;
	g_pasteOptions->mirror = false;
	g_pasteOptions->curve = false,

	g_deleteOptions->time = false;
	g_deleteOptions->beginEdge = true;
	g_deleteOptions->endEdge = true;

	g_timelineFilter->morph = true;
	g_timelineFilter->rotation = true;
	g_timelineFilter->translation = true;
	g_timelineFilter->posCompensation = true;
	g_timelineFilter->fka = true;
	g_timelineFilter->fkb = true;
	g_timelineFilter->zoom = true;
	g_timelineFilter->fieldOfView = true;
	g_timelineFilter->orientation = true;
	g_timelineFilter->position = true;
}