#include <windows.h>
#include <direct.h>
#include "seamless3d.h"
#include "gui.h"

#ifdef RECORD_SOUNDMOVIE

#define NUM_NOTIFICATIONS  16
#include <dsound.h>
#pragma   comment(lib,"dsound.lib")

extern HWND hWndMain;
LPDIRECTSOUNDCAPTURE g_pDsd = 0; //direct sound capture
LPDIRECTSOUND8 g_playDsd = 0; //direct sound play
LPDIRECTSOUNDCAPTUREBUFFER g_pDSBuffer8 = 0;
LPDIRECTSOUNDBUFFER g_playDSBuffer8 = 0;

LPDIRECTSOUNDNOTIFY g_pDSNotify = 0;
DSBPOSITIONNOTIFY g_aPosNotify[NUM_NOTIFICATIONS + 1];
DWORD g_dwCaptureBufferSize = 0;
DWORD g_bufferNextOffset = 0;
DWORD g_dwNotifySize = 0;
HANDLE g_hNotificationEvent;
int g_fps = 25;
int g_numOfSeconds = 10;

int g_sampleRate = 44100;

String g_mainFilename = "frame";
unsigned int g_counter = 0;
unsigned int g_remCounter = 0;
unsigned int g_numOfFrames = g_fps * g_numOfSeconds;
unsigned short int* g_frameBufferS = 0;
Pix24* g_frameBuffer = 0;
unsigned int g_frameSizeS = 0;
unsigned int g_frameSize = 0;
unsigned int g_frameBufferSLen = 0;
unsigned int g_frameBufferLen = 0;
extern Ptr<_3DWin> g_3d;
void createPNG24(const char* filename, int width, int height, Pix24* pixels);
bool g_recordSoundMovie = false; //true = single shot
bool g_playSoundMovie = false;
extern LPCSTR g_currentType;
extern bool mouse3dMode;
extern bool g_viewPosDragMode;
extern bool g_viewRotDragMode;
short int* g_playBuf = 0;
int g_playBufLen = 0;
int g_playBufferIndex = 0;
bool g_playing = false;

HRESULT exitPlaySound();

void updatePlayBuffer(){
	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos = 0;
	DWORD   dwCapturePos = 0;

	//String filename = g_mainFilename;
	//cntrStr = g_counter;
	//while(cntrStr.length < 3){
	//	cntrStr = "0" + cntrStr;
	//}
	//filename = filename + cntrStr;
	//filename += ".pcm";
	//FILE* stream = fopen(filename.c_str(), "rb");
	//if(stream == 0){
	//	return;
	//}


	g_playDSBuffer8->Lock(g_bufferNextOffset, g_dwNotifySize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);

	//fread(lockedBuffer, 1, lockedBufferLen, stream);
	int len = lockedBufferLen >> 1;
	for(int i = 0; i < len; i++){
		reinterpret_cast<short int*>(lockedBuffer)[i] = g_playBuf[g_playBufferIndex++]; 
	}
	if(g_playBufferIndex >= g_playBufLen - 1764){
		g_playDSBuffer8->Stop();
		g_playing = false;
		g_playBufferIndex = 0;
		//exitPlaySound();
		g_playDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
		return;
	}

	g_bufferNextOffset += lockedBufferLen; 
	g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer

	if(lockedBuffer2){
		//fread(lockedBuffer2, 1, lockedBufferLen2, stream);
		int len = lockedBufferLen2 >> 1;
		for(int i = 0; i < len; i++){
			reinterpret_cast<short int*>(lockedBuffer2)[i] = g_playBuf[g_playBufferIndex++]; 
		}

		g_bufferNextOffset += lockedBufferLen2; 
		g_bufferNextOffset %= g_dwCaptureBufferSize; // Circular buffer
	}

	g_playDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
//	fclose(stream);
	if(g_playBufferIndex >= g_playBufLen - 1764){
		g_playDSBuffer8->Stop();
		g_playing = false;
		g_playBufferIndex = 0;
		//exitPlaySound();
		return;
	}

	g_counter++;
}

void updateBuffer(){
	VOID*   lockedBuffer    = NULL;
	DWORD   lockedBufferLen;
	VOID*   lockedBuffer2   = NULL;
	DWORD   lockedBufferLen2;
	DWORD   dwReadPos;
	DWORD   dwCapturePos;

	if(NULL == g_pDSBuffer8){
		return;
	}
	if(g_frameBuffer == 0){
		return;
	}
	g_remCounter = g_counter;

	g_pDSBuffer8->GetCurrentPosition(&dwCapturePos, &dwReadPos);

	LONG lLockSize = dwReadPos - g_bufferNextOffset;
	if(lLockSize < 0){
		lLockSize += g_dwCaptureBufferSize;
	}

	lLockSize -= (lLockSize % g_dwNotifySize);

	static int f = 0;
	if(++f == 16){
		int a = 0;
	}

	if(lLockSize == 0){
		return;
	}
	//dLog((int)lLockSize);

	g_pDSBuffer8->Lock(g_bufferNextOffset, lLockSize, &lockedBuffer, &lockedBufferLen, &lockedBuffer2, &lockedBufferLen2, 0L);
	g_bufferNextOffset += lockedBufferLen + lockedBufferLen2;
	g_bufferNextOffset %= g_dwCaptureBufferSize;
	//dLog((int)(lockedBufferLen + lockedBufferLen2));
	//dLog((int)g_bufferNextOffset);

	unsigned short int* _lockedBuffer = reinterpret_cast<unsigned short int*>(lockedBuffer);
	unsigned short int* _lockedBuffer2 = reinterpret_cast<unsigned short int*>(lockedBuffer2);

	unsigned int s = 0;
	for(unsigned int lockedBufferLenInt = lockedBufferLen / 2; s < lockedBufferLenInt;){

		unsigned short int* dest = &g_frameBufferS[g_counter * g_frameSizeS];
		for(unsigned int i = 0; i < g_frameSizeS; i++, s++){
			dest[i] = _lockedBuffer[s];
		}
		if(++g_counter == g_numOfFrames){
			g_counter = 0;
		}
	}

	if(lockedBuffer2){
		s = 0;
		for(unsigned int lockedBufferLenInt = lockedBufferLen2 / 2; s < lockedBufferLenInt;){

			unsigned short int* dest = &g_frameBufferS[g_counter * g_frameSizeS];
			for(unsigned int i = 0; i < g_frameSizeS; i++, s++){
				dest[i] = _lockedBuffer2[s];
			}
			if(++g_counter == g_numOfFrames){
				g_counter = 0;
			}
		}
	}

	g_pDSBuffer8->Unlock(lockedBuffer,  lockedBufferLen, lockedBuffer2, lockedBufferLen2);
}

void initSoundCapture(){
	g_frameSizeS = g_sampleRate / g_fps;
	g_dwNotifySize = g_frameSizeS * 2;
	g_frameSize = g_3d->size.x * g_3d->size.y;
	g_frameBufferLen = g_frameSize * g_numOfFrames;
	g_frameBufferSLen = g_frameSizeS * g_numOfFrames;
	g_frameBufferS = new unsigned short int[g_frameBufferSLen];
	g_frameBuffer = new Pix24[g_frameBufferLen];

	g_hNotificationEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	if(S_OK != DirectSoundCaptureCreate8((LPGUID)&DSDEVID_DefaultCapture, &g_pDsd, NULL)){
		return;
	}

	WAVEFORMATEX wfxInput;
	wfxInput.cbSize = 0;
	wfxInput.nBlockAlign = 2;
	wfxInput.nChannels = 1;
	wfxInput.nSamplesPerSec = g_sampleRate;
	wfxInput.nAvgBytesPerSec = wfxInput.nSamplesPerSec * 2;
	wfxInput.wBitsPerSample = 16;
	wfxInput.wFormatTag = 1;


	g_dwCaptureBufferSize = g_dwNotifySize * NUM_NOTIFICATIONS;

	DSCBUFFERDESC dsbd;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	//dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.lpwfxFormat = &wfxInput; // Set the format during creatation
	dsbd.dwBufferBytes = g_dwCaptureBufferSize;

	g_pDsd->CreateCaptureBuffer(&dsbd, &g_pDSBuffer8, NULL);//2
	//g_pDSBuffer8->QueryInterface(IID_IDirectSoundBuffer8,(LPVOID*)&g_pDSBuffer8);

	g_bufferNextOffset = 0;

	//g_pDSBuffer8->Release();
	g_hNotificationEvent = CreateEvent( NULL, FALSE, FALSE, NULL);

	g_pDSBuffer8->QueryInterface( IID_IDirectSoundNotify, (VOID**)&g_pDSNotify);//3 and 4

	//	g_pDSNotify->Release();

	for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
		g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
		g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
	}

	g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5

	g_pDSBuffer8->Start(DSCBSTART_LOOPING); //6
}


void initPlaySound(){
	g_playBufferIndex = 0;
	g_frameSizeS = g_sampleRate / g_fps;
	g_dwNotifySize = g_frameSizeS * 2;
	g_frameSize = g_3d->size.x * g_3d->size.y;
	g_frameBufferLen = g_frameSize * g_numOfFrames;
	g_frameBufferSLen = g_frameSizeS * g_numOfFrames;
	g_frameBufferS = new unsigned short int[g_frameBufferSLen];

	g_hNotificationEvent = CreateEvent(NULL, FALSE, FALSE, NULL);

	if(S_OK != DirectSoundCreate8(NULL, &g_playDsd, NULL)){
		return;
	}
	if(S_OK != g_playDsd->SetCooperativeLevel(hWndMain, DSSCL_NORMAL)){
		return;
	}

	WAVEFORMATEX wfxInput;
	wfxInput.cbSize = 0;
	wfxInput.nBlockAlign = 2;
	wfxInput.nChannels = 1;
	wfxInput.nSamplesPerSec = g_sampleRate;
	wfxInput.nAvgBytesPerSec = wfxInput.nSamplesPerSec * 2;
	wfxInput.wBitsPerSample = 16;
	wfxInput.wFormatTag = 1;


	g_dwCaptureBufferSize = g_dwNotifySize * NUM_NOTIFICATIONS;


	DSBUFFERDESC dsbd;
	memset(&dsbd, 0, sizeof(dsbd));
	dsbd.dwSize = sizeof(dsbd);
	dsbd.dwFlags = DSBCAPS_GLOBALFOCUS | DSBCAPS_CTRLPOSITIONNOTIFY | DSBCAPS_GETCURRENTPOSITION2;
	dsbd.lpwfxFormat = &wfxInput; // Set the format during creatation
	dsbd.dwBufferBytes = g_dwCaptureBufferSize;

	g_playDsd->CreateSoundBuffer(&dsbd, &g_playDSBuffer8, NULL);
	//g_pDSBuffer8->QueryInterface(IID_IDirectSoundBuffer8,(LPVOID*)&g_pDSBuffer8);

	g_bufferNextOffset = 0;

	//g_pDSBuffer8->Release();
	g_hNotificationEvent = CreateEvent( NULL, FALSE, FALSE, NULL);

	g_playDSBuffer8->QueryInterface( IID_IDirectSoundNotify, (VOID**)&g_pDSNotify);//3 and 4

	//	g_pDSNotify->Release();

	for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
		g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
		g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
    }

	g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5

	
}

void paintCross(int x, int y, int dstWidth, int dstHeight, Pix24* dstPix){
	x -= 8;
	int iconWidth = 17;
	int iconHeight = 17;

	if(x > dstWidth - iconWidth){
		iconWidth = dstWidth - x;
	}
	
	int idx = y * dstWidth + x;

	for(int i = iconWidth; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx++;
	}

	x += 8;
	y -= 8;
	if(y > dstHeight - iconHeight){
		iconHeight = dstHeight - y;
	}

	idx = y * dstWidth + x;

	for(int i = 8; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx += dstWidth;
	}
	idx += dstWidth;
	for(int i = 8; --i >=0;){
		Pix24 pixel = dstPix[idx];
		pixel.r ^= 0xff;
		pixel.g ^= 0xff;
		pixel.b ^= 0xff;
		dstPix[idx] = pixel;
		idx += dstWidth;
	}
}

void saveScreenshotToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height, Pix24* lpDest){
	for(unsigned int r = 0; r < height; r++){
		for(unsigned int c = 0; c < width; c++){
			int idx = r * width + c;
			unsigned int rawPix = pBits[r * screenWidth + c];
			Pix24 pixel;
			pixel.b = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.g = rawPix & 0x00ff;
			rawPix >>= 8;
			pixel.r = rawPix & 0x00ff;
			lpDest[idx] = pixel;
		}
	}
	if(g_settings->screenshotMouse){
		if(g_viewPosDragMode || g_viewRotDragMode){
			paintCross(g_mousePos.x, g_mousePos.y, width, height, lpDest);
		}
		else if(mouse3dMode == false){
			if(g_currentType == IDC_CROSS){
				paintCross(g_mousePos.x, g_mousePos.y, width, height, lpDest);
			}
			else{
				pasteSprite(g_mousePos.x, g_mousePos.y, 469, 209, width, height, iconSrcBufCX, iconSrcBufCY, 11, 21, lpDest);
			}
		}
	}
}

void saveFrameToMem(unsigned int* pBits, unsigned int screenWidth, unsigned int width, unsigned int height){
	if(g_frameBuffer == 0){
		return;
	}
	int numOfFrams = g_counter - g_remCounter;
	if(numOfFrams < 0){
		numOfFrams += g_numOfFrames;
	}
	for(int k = numOfFrams; --k >= 0;){

		Pix24* lpDest = &g_frameBuffer[g_remCounter * g_frameSize];
		saveScreenshotToMem(pBits, screenWidth, width, height, lpDest);

		g_remCounter++;
		if(g_remCounter == g_numOfFrames){
			g_remCounter = 0;
		}
	}
}

#endif

extern const String g_screenshotDir;

void saveMemToFiles(unsigned int width, unsigned int height){
	SYSTEMTIME ToDaySystemTime;

	GetLocalTime(&ToDaySystemTime);
	char tmpChar[0x200];
	ToDaySystemTime.wYear -= 2000;
	sprintf(tmpChar,"%.2i%.2i%.2i_%.2i%.2i%.2i\\",ToDaySystemTime.wYear, ToDaySystemTime.wMonth, ToDaySystemTime.wDay, ToDaySystemTime.wHour,ToDaySystemTime.wMinute, ToDaySystemTime.wSecond);
	String folder = g_screenshotDir;
	folder += tmpChar;
	mkdir(folder.c_str());
	folder += g_mainFilename;

	String cntrStr;

	for(unsigned int k = 0; k < g_numOfFrames; k++, g_counter++){
		
		if(g_counter == g_numOfFrames){
			g_counter = 0;
		}

		Pix24* pixels = &g_frameBuffer[g_counter * g_frameSize];

		String filename = folder;

		cntrStr = static_cast<int>(k);
		while(cntrStr.length < 4){
			cntrStr = '0' + cntrStr;
		}
		filename += cntrStr;

		filename += ".png";

		createPNG24(filename.c_str(), width, height, pixels);

		//save pcm
		//filename = folder;

		//cntrStr = static_cast<int>(k);
		//while(cntrStr.length < 3){
		//	cntrStr = '0' + cntrStr;
		//}
		//filename += cntrStr;

		//filename += ".pcm";

		//FILE* stream = fopen(filename.c_str(), "w+b");
		//if(stream == 0){
		//	return;
		//}
		//unsigned short int* samples = &g_frameBufferS[g_counter * g_frameSizeS];
		//fwrite(samples, 2, g_frameSizeS, stream);
		//fclose(stream);
	}
}

void exitSoundCapture(){
	if(g_pDSNotify){
		g_pDSNotify->Release();
		g_pDSNotify = 0;
	}
	if(g_pDSBuffer8){
		g_pDSBuffer8->Release();
		g_pDSBuffer8 = 0;
	}
	if(g_pDsd){
		g_pDsd->Release();
		g_pDsd = 0;
	}
    // Release COM
	CoUninitialize();

	CloseHandle(g_hNotificationEvent);

	saveMemToFiles(g_3d->size.x, g_3d->size.y);

	delete[] g_frameBufferS;
	delete[] g_frameBuffer;
	g_frameBufferS = 0;
	g_frameBuffer = 0;
}

HRESULT exitPlaySound(){
//8
	if(g_pDSNotify){
		g_pDSNotify->Release();
		g_pDSNotify = 0;
	}
	if(g_pDSBuffer8){
		g_playDSBuffer8->Release();
		g_playDSBuffer8 = 0;
	}
	if(g_playDsd){
		g_playDsd->Release();
		g_playDsd = 0;
	}
    // Release COM
    CoUninitialize();
//	g_playSoundMovie = false;

    return S_OK;
}

extern bool g_screenshotLate;
extern bool g_screenshotEarly;

void toggleRecordSoundMovie(){

	g_recordSoundMovie = !g_recordSoundMovie;

	if(g_recordSoundMovie){
		g_screenshotLate = false;
		g_screenshotEarly = false;
		if(g_settings->screenshotWindows){
			g_screenshotLate = true;
		}
		else{
			g_screenshotEarly = true;
		}
		initSoundCapture();
	}
	else{
		g_screenshotLate = false;
		g_screenshotEarly = false;
		exitSoundCapture();
	}
}

extern String g_currentFilename;
bool modifyWavFilename(String& filename);

void togglePlaySound(bool state, short int* ibuf, int bufLen){
	String filename = g_currentFilename;

	if(modifyWavFilename(filename)){
		int a = PlaySound(
			filename.c_str(),
			0,
			SND_ASYNC
		);
	}

	return;

	if(bufLen == 0){
		return;
	}
	g_playSoundMovie = state;

	if(g_playSoundMovie){
		if(g_playing == false){
			//for( INT i = 0; i < NUM_NOTIFICATIONS; i++ ){
			//	g_aPosNotify[i].dwOffset = (g_dwNotifySize * i) + g_dwNotifySize - 1;
			//	g_aPosNotify[i].hEventNotify = g_hNotificationEvent;             
			//}

			//g_pDSNotify->SetNotificationPositions( NUM_NOTIFICATIONS, g_aPosNotify );//5
			//initPlaySound();


			g_playing = true;
			g_playBufferIndex = 0;
			g_bufferNextOffset = 0;
			//updatePlayBuffer();
			g_playDSBuffer8->Play(0, 0, DSBPLAY_LOOPING);
			//updatePlayBuffer();
		}
	}
	else{
		g_playDSBuffer8->Stop();
		g_playing = false;
		//exitPlaySound();
	}
}

void Anim::setUpSoundPlay(){
	if(Composition* composition = dynamic_cast<Composition*>(soundTrack.p)){
		g_playBuf = composition->ibuf;
		g_playBufLen = composition->bufLen;
		g_playSoundMovie = true;
		initPlaySound();
	}
}
