#include <dos.h> 
#include <conio.h> 
#include <stdio.h> 
#include <string.h> 
#include <stdlib.h> 
#include "console.h"
#include "seamless3d.h"

void NewGame();
void TimeUp(double t);


//g_bindSmlsFile contains the URL to our .smls file we want to bind to
String g_bindSmlsFile="C:\\Documents and Settings\\thyme\\My Documents\\Content\\bumpy_game\\bumpy_game_bind.smls";

extern unsigned g_key;

//insert global variables here:
const char cmaze[12][26] = { 
   "#########################",
   "#:::!::#::::#::::#::!:::#",
   "#:##:#:#:##:#:##:#:#:##:#",
   "#:#::#::::#:!:#::::#::#:#",
   "#:::###:#:::#:::#:###:::#",
   "#:#:#:::###:#:###:::#:#:#",
   "|:#:::#:::#:#:#:::#:::#:|",
   "#:###:#:#::: :::#:#:###:#",
   "#::::!::#:# # #:#::!::::#",
   "#:##:#:##:#   #:##:#:##:#",
   "#::::#::::#   #::::#::::#",
   "#########################", };


#define BOARDER     0x01 
#define FOOD        0x02 
#define PILL        0x04 
#define DOOR        0x08 
#define ROBOT       0x10
#define PACMAN      0x20

enum
{
   GameInvalid,
   GameReady,
   GameRunning,
   GameEnded,
};

char maze[12][26] = { "", };
int doorX[] = {0, 0};
int doorY[] = {0, 0};

int dirx[] = { 0,  0,  1,  0, -1 };
int diry[] = { 0, -1,  0,  1,  0 };

double nextT = 0.0;
int state         = GameInvalid;
int score         = 0;
int highscore     = 0;
int lives         = 0;
int level         = 0;
int speed         = 0;
int chasing       = 0;
int tick          = 0;
int food          = 0;
int numrobots     = 0;
int quit          = 0;
bool alive        = true;
int openTime      = 0;
int sound         = 0;

// pacman movement variables
int pc            = 0;
int px            = 0;                       // x co-ord
int py            = 0;                       // y co-ord 
int pt            = 0;
int pa            = 0;                       // orientation

// robot movement constants and variables
int crx[]         = { 11, 13, 11, 13 };
int cry[]         = {  9,  9, 10, 10 };
int cra[]         = {  2,  3,  1,  4 };
int rx[]          = {  0,  0,  0,  0 };      // x co-ord
int ry[]          = {  0,  0,  0,  0 };      // y co-ord 
int ra[]          = {  0,  0,  0,  0 };      // orientation
int rh[]          = {  0,  0,  0,  0 };      // hidden

M_<Transform*> monster;

class ScriptBind{//user definable class for binding nodes and containing script functions
public:
	//define node references to match nodes that will be found in the .smls file
	Transform& bumpy;
	Transform& monster0;
	Transform& monster1;
	Transform& monster2;
	Transform& monster3;
	Group& tileWithSugar;
	Shape& tileShape;
	Group& tileWithPlate;
	Group& eatenTile;
	Shape& plate;
	Group& nmaze;

	ScriptBind(//bind the nodes from the smls file to the ScriptBind class
		Transform& i_bumpy,
		Transform& i_monster0,
		Transform& i_monster1,
		Transform& i_monster2,
		Transform& i_monster3,
		Group& i_tileWithSugar,
		Shape& i_tileShape,
		Group& i_tileWithPlate,
		Group& i_eatenTile,
		Shape& i_plate,
		Group& i_nmaze
	):
	bumpy(i_bumpy),
	monster0(i_monster0),
	monster1(i_monster1),
	monster2(i_monster2),
	monster3(i_monster3),
	tileWithSugar(i_tileWithSugar),
	tileShape(i_tileShape),
	tileWithPlate(i_tileWithPlate),
	eatenTile(i_eatenTile),
	plate(i_plate),
	nmaze(i_nmaze)
{
	initialize();
}

void initialize(){//equivelent to initialize in vrml
//insert initialize code here
	monster+=&monster0;
	monster+=&monster1;
	monster+=&monster2;
	monster+=&monster3;

	nmaze.children.refValue().length=25*12;

	for(int r = 0; r<12; r++){
		for(int c = 0; c<25; c++){
			TransformPtr transform = new Transform;
			nmaze.children.refValue()[r*25+c] = transform;
			if(cmaze[r][c]==':'){
				transform->children.refValue()+=&tileWithSugar;
			}
			else if(cmaze[r][c]=='!'){
				transform->children.refValue()+=&tileWithPlate;
			}
			else if(cmaze[r][c]==' '){
				transform->children.refValue()+=&eatenTile;
			}
			transform->translation=Vec3f(c-25.0*.5+.5, 0, r-12*.5+.5);
		}
	}

	highscore = 0;
	state = GameReady;
	NewGame();
}

void onFrame(float v){//simulate Anim's onFrame (can add break point here and single step to check a point in time for the animation)
	bumpy.rotation = Rotation(0, 1, 0, PI*v);
	TimeUp(g_vrmlTime);
}
//add user defined script functions here


int KeyHit()
{
   return _kbhit();
}

char GetKey()
{
	if(g_key==39){
		return 77;
	}
	else if(g_key==37){
		return 75;
	}
	else if(g_key==38){
		return 72;
	}
	else if(g_key==40){
		return 80;
	}
	return 0;
}

void print_string(char *s)
{
   while (*s) _putch(*s++);
}


void printnum(int n)

{
  int m;

  m = n / 10;
  if (m) printnum(m);
  _putch((char)n-m*10+'0');
}


void print_number(char *s, int n)
{
  int i;

  while (*s) {
    if (*s == '%') {
      i = *++s -'0';
      while (i--) _putch('0');
      printnum(n);  
    }
    else
      _putch(*s);
    s++;
  }
}


void Pause(int msec)
{
	Sleep(msec);
}


void ShowScore()
{
   locate(1,12);
   printf("LIVES %02d", lives);
   locate(10, 12);
   printf("LEVEL %02d", level);
   locate(19,12);
   printf("SCORE %05d", score);
   locate(33,12);
   printf("HIGH SCORE %05d", highscore);
}

bool TestTile(int x, int y, char m)
{
   return (maze[y][x] & m) != 0;
}

void ShowTile(int x, int y)
{
   locate(x * 2, y);
   char tile = maze[y][x];

   if (TestTile(x, y, ROBOT))
   {
      print_string( chasing ? "@@" : "OO" );
   }
   else if (TestTile(x, y, PACMAN))
   {
	  //bumpy.translation=Vec3f(x, y, 0);
	  bumpy.translation=Vec3f(x-25.0*.5+.5, .5, y-12*.5+.5);
      settextcolor(FOREGROUND_RED|FOREGROUND_GREEN);
      print_string("**" );
   }
   else if (TestTile(x, y, BOARDER))
   {
      settextcolor(FOREGROUND_GREEN);
      print_string("##" );
   }
   else if (TestTile(x, y, DOOR))
   {
      settextcolor(FOREGROUND_GREEN);
      print_string("||" );
   }
   else if (TestTile(x, y, PILL))
   {
      settextcolor(FOREGROUND_GREEN);
      print_string("!!" );
   }
   else if (TestTile(x, y, FOOD))
   {
      settextcolor(FOREGROUND_GREEN);
      print_string(".." );
   }
   else
   {
      settextcolor(FOREGROUND_GREEN);
      print_string("  ");
   }

   settextcolor(FOREGROUND_RED|FOREGROUND_GREEN|FOREGROUND_BLUE);
}


void InclTile(int x, int y, char m)
{
   maze[y][x] |= m;

   ShowTile(x, y);
}


void ExclTile(int x, int y, char m)
{
   maze[y][x] &= ~m;

   ShowTile(x, y);
}


void ShowMaze()
{
   int x, y;

   clrscr();
   setcursor(1, 0);

   for (y = 0; y < 12; y++) 
   {
      for (x = 0; x < 25 != 0; x++) 
      {
         ShowTile(x, y);
      }
   }
}


void NewMaze()
{
   int i, j;
   food = 0;
   for (i = 0; i < 12; i++)
   {
      for (j = 0; j < 25; j++)
      {
         switch (cmaze[i][j])
         {
         case '#': maze[i][j] = BOARDER;      break;
         case ':': maze[i][j] = FOOD; food++; break;
         case '!': maze[i][j] = PILL; food++; break;
         case '|': maze[i][j] = DOOR;         break;
         default : maze[i][j] = 0;            break;
         }
      }
   }
   ShowMaze();
   ShowScore();
}


void NewRobot(int r)
{
   // remove robot from maze
   ExclTile(rx[r], ry[r], ROBOT);

   // set initial location
   rx[r] = crx[r];
   ry[r] = cry[r];
   ra[r] = cra[r];
   rh[r] = 0;
}

void NewRobots()
{
   for (int r = 0; r < numrobots; r++)
   {
      NewRobot(r);
   }
}

void EatRobot()
{
   for (int r = 0; r < numrobots; r++)
   {
      if (px == rx[r] && py == ry[r])
      {
         NewRobot(r);
         rh[r] = 6; 
         score += 100;
      }
   }
}

void MoveRobot(int r)
{
   int x, y, a;
   int dx, dy;

   if (rh[r]) 
   {
      rh[r]--;
      return;
   }
   
   x = rx[r];
   y = ry[r];
   a = ra[r];
   
   // remove robot from maze
   ExclTile(x, y, ROBOT);

   char OCCUPIED = BOARDER | DOOR | ROBOT;
   
   // robot brain
   dx = (px - x) / 2;
   dy = py - y;
   if      (a != 3 && dx < dy && y > py && !TestTile(x, y - 1, OCCUPIED))
      a = 1;
   else if (a != 1 && dx < dy && y < py && !TestTile(x, y + 1, OCCUPIED))
      a = 3;
   else if (a != 4 && x < px && !TestTile(x + 1, y, OCCUPIED))
      a = 2;
   else if (a != 2 && x > px && !TestTile(x - 1, y, OCCUPIED))
      a = 4;
   else if (a != 3 && y > py && !TestTile(x, y - 1, OCCUPIED))
      a = 1;
   else if (a != 1 && y < py && !TestTile(x, y + 1, OCCUPIED))
      a = 3;
   else if (a == 1 || a == 3)
   {
      if      (!TestTile(x + 1, y, OCCUPIED)) 
         a = 2;
      else if (!TestTile(x - 1, y, OCCUPIED)) 
         a = 4;
   }
   else if (a == 2 || a == 4) 
   {
      if      (!TestTile(x, y + 1, OCCUPIED))
         a = 3;
      else if (!TestTile(x, y - 1, OCCUPIED))
         a = 1;
   }
   else {
      for (a = 4; TestTile(y + diry[a], x + dirx[a], OCCUPIED); a--);
   }
   
   // check new robot position
   if (!TestTile(x + dirx[a], y + diry[a], OCCUPIED))
   {
      x += dirx[a];
      y += diry[a];
   }
   else
   {
      a = 0;
   }

   // re-insert robot into maze
   rx[r] = x;
   ry[r] = y;
   ra[r] = a;

   InclTile(x, y, ROBOT);

   //monster[r]->translation=Vec3f(x,y,0);
   monster[r]->translation=Vec3f(x-25.0*.5+.5, .5, y-12*.5+.5);


   // touch bumpy?
   if (TestTile(x, y, PACMAN))
   {
      if (chasing)
      {
         EatRobot();
      }
      else if (food)
      {
         alive = false;
      }
   }
}


void MoveRobots()
{
   for (int i = 0; i < numrobots; i++ )
   {
      MoveRobot(i);
   }
}


void NewBumpy()
{
   ExclTile(px, py, PACMAN);

   px = 12;
   py = 7;
   pa = 0;
   pc = 0;
   pt = 2;

   InclTile(px, py, PACMAN);

   alive = true;
   chasing = false;
}

void KillBumpy()
{
   for (int i = 220; i > 0; i -= 5) 
   {
      locate(px*2, py);
      if (i > 195)
        print_string("**");
      else if (i > 170)
        print_string("++");
      else if (i > 145)
        print_string("--");
      else
        print_string("__");

      Pause(20);
   }
   lives--;
   ExclTile(px, py, PACMAN);
   alive = false;
}

void MoveBumpy()
{   
   // remove bumpy from maze
   ExclTile(px, py, PACMAN);

   // permit new direction?
   if (!TestTile(px + dirx[pc], py + diry[pc], BOARDER))
   {
      pa = pc;
   }

   // calc next position
   int x = px + dirx[pa];
   int y = py + diry[pa];

   // thru magic door?
   if (x < 0)
      x = 24;
   else if (x > 24)
      x = 0;
    
   // update position?
   if (!TestTile(x, y, BOARDER))
   {
      px = x;
      py = y;
   }

   // re-insert bumpy into maze
   InclTile(px, py, PACMAN);
   
   // touch robot?
   if (TestTile(px, py, ROBOT))
   {
      if (chasing)
      {
         EatRobot();
      }
      else if (food)
      {
         alive = false;
         return;
      }
   }
   
   // eat pill?
   if (TestTile(px, py, PILL))
   {
      chasing = 20;
      score += 5;
      food--;
      ExclTile(px, py, PILL);
   }
   
   // eat food?
   if (TestTile(px, py, FOOD))
   {
      score += 5;
      food--;
      ExclTile(px, py, FOOD);
   }  
   
   if (chasing) 
   {
      chasing--;
      pt = 1;
   }
   else
   {
      pt = 2;
   }
   
   return;
}

void NewLevel()
{
   tick = 0;
   NewMaze();
   NewBumpy();
   NewRobots();
  
   InclTile(11, 8, BOARDER);
   InclTile(13, 8, BOARDER);
}

void NewGame()
{
   score = 0;
   lives = 3;
   level = 1;
   speed = 260;
   numrobots = 2;

   NewLevel();
}

void EndGame()
{
   if ( state == GameEnded )
   {
      return;
   }

   state = GameEnded;

   locate(20, 15); print_string("GAME OVER");

   // high score
   if (highscore < score)
   {
      highscore = score;
   }

   ShowScore();

   // clear out key input buffer
   while (GetKey());
}

void Initialise()
{
   highscore = 0;
   state = GameReady;
   NewGame();
}


void TimeUp(double t)
{
   if ( t >= nextT )
   {
      nextT = t + 0.2;
      char key = GetKey();

      if ( state == GameEnded )
      {
         // new game
         if ( key )
         {
            NewGame();
            state = GameReady;
         }
      }

      if ( state == GameReady )
      {
         // start game
         if ( key )
         {
            openTime = tick + 16;
            state = GameRunning;
         }
      }

      // end game?
      if ( key == 27 )
      {
         EndGame();
      }

      if ( state == GameRunning )
      {
         // robot cage doors
         if ( openTime == tick )
         {
            ExclTile(11, 8, BOARDER);
            ExclTile(13, 8, BOARDER);
         }

         // bumpy direction
         switch (key)
         {
         case 72 : pc   = 1; break;
         case 77 : pc   = 2; break;
         case 80 : pc   = 3; break;
         case 75 : pc   = 4; break;
         }
         
         if (tick % pt == 0) 
         {
            MoveBumpy();
         }

         if ( food == 0 )
         {
            NewLevel();
         }

         if ( !alive )
         {
            KillBumpy();

            if ( lives > 0 )
            {
               NewBumpy();
               NewRobots();
              
               InclTile(11, 8, BOARDER);
               InclTile(13, 8, BOARDER);
               state = GameReady;
            }
            else
            {
               EndGame();
            }            
         }

         ShowScore();
      }

      if (tick % 2 == 0)
      {
         MoveRobots();
      }

      tick++;
   }
}

int game_main()
{
   double t = 0;
   Initialise();
   return 0;
   while ( true )
   {
      TimeUp(t);
      Sleep(20);
      t += 0.02;
   }

   return 0;
}
}; //end ScriptBind class



NodePtr getNodeFromName(const String str);

ScriptBind* scriptBind=0;
void initializeDeveloperScript(){
	scriptBind = new ScriptBind(//new instance of ScriptBind binds the nodes to our script
		*dynamic_cast<Transform*>(getNodeFromName("bumpy").p),
		*dynamic_cast<Transform*>(getNodeFromName("monster0").p),
		*dynamic_cast<Transform*>(getNodeFromName("monster1").p),
		*dynamic_cast<Transform*>(getNodeFromName("monster2").p),
		*dynamic_cast<Transform*>(getNodeFromName("monster3").p),
		*dynamic_cast<Group*>(getNodeFromName("tileWithSugar").p),
		*dynamic_cast<Shape*>(getNodeFromName("tileShape").p),
		*dynamic_cast<Group*>(getNodeFromName("tileWithPlate").p),
		*dynamic_cast<Group*>(getNodeFromName("eatenTile").p),
		*dynamic_cast<Shape*>(getNodeFromName("plate").p),
		*dynamic_cast<Group*>(getNodeFromName("nmaze").p)
	);
}
void scriptBindAnimation(){
	float period = 1;
	scriptBind->onFrame(fmodf(g_time/period, period)); // create slider from period and pass as value
}