/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;
extern const char* menu_convert;
extern const char* menu_break_join;
extern const char* menu_break_coord;
extern const char* menu_break_color;
extern const char* menu_join_move;
extern const char* menu_move_vertex;
extern const char* menu_join_vertex_keep_both_colors;
extern const char* menu_join_vertex_keep_source_color;

void breakAndJoinVerticesDemo(){
	const int scene=0;
	const int seamless=1;
	const int part1=seamless+2;
	int coneBuild=part1+1;
	int anim=coneBuild+2;


	InputEvent* eventArray45[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "break-join-color-poly.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
/////
new Section("Add some triangles"),

new ClickButton(newRectangle),

new DecFieldX("bands"),
new DecFieldX("bands"),
new DecFieldX("staves"),
new DecFieldX("staves"),

new MoveToNode(3),
new RightClick,
new Move_MenuItem(menu_convert),
new Click,
new ToggleField("mirror"),
new Section("Color triangles blue"),
new ClickButton(openPalette),
new ClickColorCell(2, 0), //blue
new RectVert(-.66875,1.098437,.63375,.770937),
new RectVert(-.64375,.629687,.60375,-.122812),

new Section("Break coord"),
new SelectTriangle(7,part1),
new ClickButton(breakVertexJoin),
new TugVertex(9,.025,.43,part1),
new ClickColorCell(0, 0), //red
//new SelectVertex(9, part1),
//new ClickButton(colorVertex),
new ClickButton(toggleWireFrame),
new RectVert(-.034375,.460938,.093125,.380938),

new Section("Move vertex to nearest"),
new SelectVertex(9),
new MoveToF10(),
new Move_MenuItem(menu_join_move),
new Move_MenuItem(menu_join_vertex_keep_both_colors),
new Move_MenuItem(menu_move_vertex),
new Click,
new TugVertex(9,.025,.43,part1),

new Section("Join vertex keeping both colors"),
new SelectVertex(9),
new ClickButton(joinVertexKeepBothColors),
new ClickButton(toggleWireFrame),
new TugVertex(4,-.175,.78,part1),
new TugVertex(4,0,.5,part1),
new ClickButton(toggleWireFrame),

new Section("Join vertex keeping only destination color"),
new SelectTriangle(7,part1),
new ClickButton(breakVertexJoin),
new TugVertex(9,.025,.42,part1),
new ClickButton(joinVertexKeepDestColor),


new Section("Join vertex keeping only source color"),
new SelectTriangle(7,part1),
new ClickButton(breakVertexJoin),
new TugVertex(9,.025,.42,part1),

new ClickColorCell(0, 0), //red
//new ClickButton(colorVertex),
new RectVert(-.034375,.460938,.093125,.380938),

new MoveToF10(),
new Move_MenuItem(menu_join_move),
new Move_MenuItem(menu_join_vertex_keep_source_color),
new Click,

new Section("Clean edge paint triangles"),
new ClickColorCell(1, 0), //green
new RectPoly(-.35,.910937,-.145,.635938),

new Section("Clean edge paint vertex"),
new MoveToExitWindow(),
new Click(),
new RectPoly(.084375,.942187,.441875,.044688),
new ClickButton(openPalette),
new ClickColorCell(3, 0), //yellow
new RectVert(-.034375,.554688,.043125,.442188),

new Section("Specify join vertex destination color"),
new ClickButton(toggleWireFrame),
new SelectTriangle(7,part1),
new ClickButton(breakVertexJoin),
new TugVertex(9,-.04,.465,part1),
new ClickButton(toggleWireFrame),
new ClickButton(joinVertexKeepDestColor),
new SelectTriangle(7,part1),
new ClickButton(breakVertexJoin),
new ClickButton(toggleWireFrame),
new TugVertex(9,-.035,.54,part1),
new ClickButton(toggleWireFrame),
new ClickButton(joinVertexKeepDestColor),

new Section("Break selection border"),
new MoveToExitWindow(),
new Click(),
new ClickButton(toggleWireFrame),
new RectPoly(-.346875,.426562,-.189375,.074063),
new ClickButton(breakVertexJoin),
new TugVertex(0,-.625,-.115,part1),





new ClickButton(saveSmls),
		new Section(Complete)
	};
	InputEvent::list+=EVENT_LIST(eventArray45);
}
void preBreakAndJoinVerticesDemo(){
	g_robotDemo->fileName="break-join-color-poly";
	g_robotDemo->function=breakAndJoinVerticesDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
