/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Complete;

extern const char* menu_delete;

void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="nurbs-lathe-avatar";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name="Open t-piece.smls file";
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int pelvis = 3;
	const int thorax = 6;
	const int foreheadNP = 5;
	const int pelvisNP = 45;

	InputEvent* create_Skeleton_of_PartsArray[]={

		new Section("Open t-piece.smls file"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		new ClickButton(openSmls),
		new SetFieldValue("filename", "t-piece.smls"),
		new ToggleField("open"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0002\\sound.wav"),
		new MoveToNode(14),
		new MoveToNode(5),
		new Wait(.5),
new MoveToExitSceneTree(),
new Click(),
new Section("zoom in"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0003\\sound.wav"),
		new MouseZoom(1.4641),
		new DragViewPos(.037075,-.402829,0),

		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0004\\sound.wav"),
//new ClickButton(toggleWireFrame),
new RectVert(-.021875,.671875,.045625,.431875),
new Wait(2.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0005\\sound.wav"),

new Rotate(.502436,.757074),
//new RectVert(-.80625,.825,-.058751,.3875),
//
//new MoveToMultiSelectPivotPoint(),
//new Move3d(Vec3f(-.016655,.490749,-.000217)),
//
//new MoveToMultiSelectRotPoint(),
//new Move3d(Vec3f(-.016655,1.085748,0)),
//new TugCP(155,.013766,.475453),
new Wait(6.5),
new Section("Each time we select a group of points the pivot point is automatically put in the center of the selected points. Drag the pivot point to change its position."),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0006\\sound.wav"),
new RectVert(.175,.76875,.917499,.41125),
new Wait(1.2),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.135218,.490749,-.000217)),
new Wait(1),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0007\\sound.wav"),//By holding down both the left control and left shift keys while dragging the orientation lever, we can simultaneously rotate and stretch the selected points.
new Wait(4),
new Stretch(.135219,-.274251),
new Wait(1.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0008\\sound.wav"),
new Wait(2),
new TugCP(308,.094,.476375),
new Wait(2),
/////
new Section("By holding down the left alt key while dragging the orientation lever, we can stretch the selected points in the direction of the orientation lever. This is the same stretch function we used before except we are prevented from accidently rotating the selected points, which is useful."),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0009\\sound.wav"),

new RectVert(-.20625,.928125,.28125,.685625),
//new Wait(2),

new Scale1d(1.249776,.792181),
new Wait(9),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0010\\sound.wav"),
new ClickButton(setLeftViewOrientation),

new ClickButton(toggleWireFrame),

new RectVert(-.190625,.871875,.159375,.679375),

new MoveToMultiSelectRotPoint(),
new Scale1d(.915216,.792181),
new RectVert(-.165625,.65625,.194375,.52125),
new Scale1d(.825263,.593363),
new RectVert(-.234375,.56875,.240625,.51875),

new Scale1d(.410455,.554484),
new ClickButton(toggleWireFrame),

new ClickButton(setFrontViewOrientation),
new Section("Ok it already looks like a pair of trousers"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0011\\sound.wav"),
new DragViewRot(-.923965,-.378941,.051888,1.163852),
new MovePointer3d(.203125,.509375),
new MovePointer3d(.30625,.4),
new Wait(5),
new ClickButton(setFrontViewOrientation),
////////////


new RectVert(.11875,.50625,.38125,.43125),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.154493,.475453,-.000217)),
new Stretch(.659493,.705453),
new RectVert(.24375,.746875,.36375,.681875),
new TugCP(30,.295827,.637027),
new RectVert(.265625,.821875,.320625,.766875),
new TugCP(47,.295827,.746213),
new DragViewRot(-.868515,-.487933,.087192,1.125985,.295827,.746213),
new DragViewRot(-.852602,-.506796,-.127388,2.663304,.295827,.746213),
//////////////////
new Section("save trousers"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0012\\sound.wav"),
new MoveToF10(),
new Move_MenuItem("file"),
new Move_MenuItem("open    (Ctrl O)"),
new Move_MenuItem("save as (Ctrl A)"),
new Click,
		new SetFieldValue("filename", "trousers.smls"),
		new ToggleField("save"),

new Section("Open jacket.smls file"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0013\\sound.wav"),
		new ClickButton(openSmls),
		new SetFieldValue("filename", "jacket.smls"),
		new ToggleField("open"),
new DragViewPos(.185,-1.06,0, .028125,.7125),
new MouseZoom(2.357948, .2125,-.35625),
new DragViewPos(.14047,-1.177687,0, .2125,-.35625),
new MoveToExitSceneTree(),
new Click(),
new Section("To change the orientation of the lever"),
new RectVert(.51875,.634375,1.676254,.169375),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0014\\sound.wav"),
new Wait(12.5),
new Neutral(1.057473,-.259825),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0015\\sound.wav"),
new Scale2d(1.037473,0),
new DragViewRot(.472294,-.693009,-.54468,.922884, 1.0375,-.040625),
new ClickButton(setFrontViewOrientation),
new Scale2d(1.037473,-.4),
new DragViewRot(.472294,-.693009,-.54468,.922884, 1.028125,-.43125),
new ClickButton(setFrontViewOrientation),
new Scale2d(1.037473,-.140374),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0016\\sound.wav"),
new UnRectVert(.5125,.628125,.575,.220625),



new Scale2d(1.037473,.024403),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.612473,.425175,.00494)),

new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0017\\sound.wav"),

new IncButtonZ(viewOrientation90),
//new Rotate(-.097527,-.199825),
new Rotate(-.287527,-.899824),
new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0018\\sound.wav"),
new UnRectVert(.18125,.925,1.206251,.5975),
new Rotate(.262473,-.189825),
new ClickButton(setFrontViewOrientation),
new Section("Drag the arms out"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0019\\sound.wav"),
new RectVert(.515625,.64375,1.508125,-.413749),
new TugCP(402,.619595,.36456),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0020\\sound.wav"),
new RectVert(.103125,.571875,.548125,-.723124),
new Neutral(.771221,-.145564),
new Scale1d(1.102344,-.170564),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0021\\sound.wav"),
new RectVert(.065625,.80625,.620625,.59875),
new Scale2d(.671468,.696339),
//
//new ClickButton(setFrontViewOrientation),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0022\\sound.wav"),
new RectVert(.1375,.89375,.335,.71625),
new TugCP(47,.220505,.714132),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0023\\sound.wav"),
new RectVert(.0625,.825,.3325,.74),
new TugCP(64,.143522,.606922),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0024\\sound.wav"),
new ClickButton(setLeftViewOrientation),

new RectVert(-.303125,.775,.231875,.5825),

new Rotate(.442519,.754867),
new RectVert(.328125,.634375,.370625,.536875),
new TugCP(58,.142425,.639636),
new TugCP(51,-.200457,.5351),
new DragViewRot(.440521,.508349,-.739948,.205912,-.200457,.5351),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0025\\sound.wav"),
new TugCP(51,.484421,.416683),
new TugCP(52,.546995,.49869),
//new DragViewRot(.099248,-.994341,.037903,3.593451),
//new DragViewRot(-.184528,-.734373,-.653181,5.476403),
new ClickButton(setFrontViewOrientation),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0026\\sound.wav"),
new TugCP(221,.329178,.497967),
new TugCP(215,.32918,.357384),
new TugCP(101,.334178,.211803),
new TugCP(118,.329178,-.170661),
new TugCP(135,.329178,-.430545),
new TugCP(152,.329178,-.554666),
new DragViewRot(-.940646,-.339376,.003151,1.141615,.329178,-.554666),
new DragViewRot(-.050522,.52166,.851656,.899634,.329178,-.554666),
new DragViewRot(-.829798,-.358399,-.427768,1.278509,.329178,-.554666),
new Section("fff2"),
new TugCP(249,.282259,.240708),
new TugCP(251,.336371,.277929),
new DragViewRot(.835696,-.02267,-.548725,1.089601,.336371,.277929),
new DragViewRot(.98002,-.190128,.058412,1.938505,.336371,.277929),
new TugCP(257,-.093034,-.065948),
new TugCP(243,-.053795,-.036429),
new DragViewRot(.987504,-.153116,-.037304,2.789443,-.053795,-.036429),
new DragViewRot(.701321,-.538796,.466742,.55438,-.053795,-.036429),
new Section("save jacket"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0027\\sound.wav"),
new MoveToF10(),
new Move_MenuItem("file"),
new Move_MenuItem("open    (Ctrl O)"),
new Move_MenuItem("save as (Ctrl A)"),
new Click,
		new SetFieldValue("filename", "jacket-b.smls"),
		new ToggleField("save"),

		new Section("Open nurbs-lathe-avatar.smls file"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0028\\sound.wav"),


		new ClickButton(openSmls),
		new SetFieldValue("filename", "nurbs-lathe-avatar.smls"),
		new ToggleField("open"),
new MoveToExitWindow(1),
new Click(),
		//new Section("Drag control points"),
		//
		//new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		//new Wait(3),
		new SelectNode(seamless),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0029\\sound.wav"),
		new ToggleField("autoIn"),
		new Wait(15),
		new Collapse(pelvis),
		new Collapse(27),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0030\\sound.wav"),
//new Section("shift"),
new SelectNode(28),

		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyDown(VK_DOWN),
//		new Wait(.25),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_LSHIFT),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new SelectNode(32),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new SelectNode(34),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new SelectNode(36),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new SelectNode(38),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new Wait(.1),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new Collapse(27),

//		new VirtKeyDown(VK_SHIFT),
//		new VirtKeyDown(VK_DOWN),
//		new VirtKeyUp(VK_DOWN),
//		new VirtKeyUp(VK_SHIFT),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0031\\sound.wav"),

		new MoveToNode(seamless),
		new RightClick,
		new Move_MenuItem("import build nodes"),
		new Click,
		new SetFieldValue("filename", "trousers.smls"),
		new ToggleField("open"),
new MoveToNode(pelvis),
new MoveToNode(47),
new MoveToNode(50),
new MoveToNode(60),
		new Section("stretch and position trousers"),




new SelectNode(pelvisNP),
new DragViewPos(.0125,-.4925,0, .2375,-.159375),
new MouseZoom(1.61051, .253125,.265625),

new RectVert(-.440625,.903125,.416875,-.854374),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0032\\sound.wav"),

new Neutral(.835131,-.056251),

new Scale2d(.780439,-.036251),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0033\\sound.wav"),

new VirtKeyDown(VK_LCONTROL),
new Wait(.25),
new TypeString("t"),
new VirtKeyUp(VK_LCONTROL),

new IncFieldY("translation"),
new IncFieldY("translation"),
new IncFieldY("translation"),
new IncFieldY("translation"),
new IncFieldY("translation"),
new RectVert(-.384375,.95625,.490625,.49625),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.020131,.484654,-.000242)),

new Neutral(.020132,-.100346),

new Scale1d(.020131,.044609),
new DragViewRot(.034755,-.999392,-.002643,1.846512, .020131,.044609),
new DragViewRot(-.192249,-.943593,-.26958,5.948233, .020131,.044609),
///
new DragViewRot(-.998702,.047015,-.019612,5.148914, .020131,.044609),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0034\\sound.wav"),
new ClickButton(toggleWireFrame),

new RectVert(-.175,-.36875,.0225,-.42375),
new TugCP(276,-.05859,-.409397),
new ClickButton(setRightViewOrientation),

new TugCP(278,.126191,-.672819),
new ClickButton(toggleWireFrame),

new DragViewRot(.882482,-.096435,.460355,.45376),
new ClickButton(setFrontViewOrientation),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0035\\sound.wav"),

new RectVert(-.3375,.396875,.0375,-.315625),
new VirtKeyDown(VK_LCONTROL),
new Wait(.25),
new TypeString("t"),
new VirtKeyUp(VK_LCONTROL),

new IncFieldY("translation"),
new IncFieldY("translation"),

new Section("leave the trouser for now"),
new MouseZoom(1.1),
new DragViewPos(.048864,-.781136,0),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0036\\sound.wav"),
		new MoveToNode(seamless),
		new RightClick,
		new Move_MenuItem("import build nodes"),
		new Click,
		new SetFieldValue("filename", "jacket-b.smls"),
		new ToggleField("open"),
new Wait(4.3),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0037\\sound.wav"),
new MoveToNode(64),
new Wait(1),
new Collapse(pelvis),
new MoveToNode(thorax),
new Wait(4),
new Collapse(pelvis),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0038\\sound.wav"),

new Hide(45),
new Hide(48),
new Hide(51),
new Hide(54),
	new Section("stretch arm"),
new IncButtonZ(viewOrientation90),
new MouseZoom(1.771561,.00625,.539375),
new DragViewPos(-.067885,-.961749,0,.00625,.539375),
new RectVert(-.34375,.70625,.42625,.51375),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0039\\sound.wav"),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.323578,.597384,.003712)),

new Neutral(.426422,.592385),
new Scale1d(.536471,.597384),
//new Scale1d(.516456,.597385),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0040\\sound.wav"),
new ClickButton(setBirdsEyeViewOrientation),
new Wait(1),
new ClickButton(setFrontViewOrientation),
new IncButtonZ(viewOrientation90),
new RectVert(-.528125,.73125,.489374,.48125),
new ClickButton(setBirdsEyeViewOrientation),

//new TugCP(962,.775568,-.105198),
new TugCP(964,.823542,-.063323),
new ClickButton(setFrontViewOrientation),

////
new ClickButton(toggleWireFrame),
new RectVert(-.14375,.8125,.114375,-.15),
new ClickButton(toggleWireFrame),

//new MoveToMultiSelectPivotPoint(),
//new Move3d(Vec3f(-.114185,.348476,.019299)),

new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(-.119185,.348476,.019299)),

new Scale1d(.435837,.348476),
new ClickButton(setLeftViewOrientation),


new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.005701,.348476,-.119185)),

new Scale1d(.705839,.348476),
	new Section("overlap jacket"),
new ClickButton(setFrontViewOrientation),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0041\\sound.wav"),
new RectVert(-.4625,.15625,.235,-.22875),
new Scale1d(.489867,-.025628),
new ClickButton(setLeftViewOrientation),
new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.000313,-.025627,-.120262)),
new Scale1d(.680356,-.025628),
new ClickButton(setFrontViewOrientation),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0042\\sound.wav"),
new Hide(45),
new Hide(48),
new Hide(51),
new Hide(54),

new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0043\\sound.wav"),
new RectVert(-.54375,.1125,.35875,-.305),
new Scale1d(.36484,-.095946),
//new Scale1d(.354763,-.095946),
new ClickButton(setLeftViewOrientation),


new MoveToMultiSelectPivotPoint(),
new Move3d(Vec3f(.001087,-.100946,-.120262)),
//new UnRectVert(-.20625,-.24375,.13875,-.37625),
new UnRectVert(-.134375,-.21875,.138125,-.35625),
new Scale1d(.471191,-.100946),
new UnRectVert(-.003125,.1125,.366875,-.3475),

new Scale1d(.381315,-.100946),
//new TugCP(114,-.134076,-.24239),
new ClickButton(setFrontViewOrientation),

new RectVert(-.484375,.328125,.188125,.185625),

new Scale1d(.439828,.260338),
new Section("align with thorax pivot point"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0044\\sound.wav"),

new RectVert(.21875,.71875,-.16375,.44875),
new TugCP(537,.117041,.484191),

new Wait(4),
new Section("fix shoulders"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0045\\sound.wav"),
new DragViewPos(-.000172,-1.208966,-.018749,.196875,.440625),
new MouseZoom(3.797499,.325,-.021875),
new DragViewRot(-.635152,-.532969,.55904,1.828489,.325,-.021875),
new TugCP(843,-.17369,.586539),
new TugCP(841,-.140553,.554295),

new DragViewRot(-.983862,-.048715,.17217,1.467495,-.140553,.554295),
new TugCP(860,.495068,.37826),
new TugCP(858,.495417,.330781),
//new DragViewRot(-.049889,-.997051,.058312,1.681651),
//new TugCP(694,.144843,.710703),
//new TugCP(694,.144843,.710703),
new DragViewRot(-.038329,-.998119,.047853,1.640907,.495417,.330781),
new TugCP(849,.194704,.698198),
new TugCP(835,.208233,.394999),
new TugCP(866,.129949,.671773),


new DragViewRot(-.351971,-.87313,.337285,1.726617,.129949,.671773),
new TugCP(837,.223562,.503474),
new TugCP(537,-.140759,.42225),



new DragViewRot(-.485855,-.656575,.576935,2.232834,-.140759,.42225),
new TugCP(852,.075252,.636039),
new DragViewRot(-.237995,-.961917,-.13444,3.12081,.075252,.636039),
new TugCP(869,-.439878,.540328),
new TugCP(871,-.428698,.476174),
new DragViewRot(-.398587,.0079,-.917096,6.030172,-.428698,.476174),
new TugCP(875,.571374,.458629),
new TugCP(873,.523136,.356697),


new Section("fix collar"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0046\\sound.wav"),

new DragViewRot(-.912885,.405172,-.049767,4.014888,.523136,.356697),
new ClickButton(toggleWireFrame),
new ClickButton(setLeftViewOrientation),

new TugCP(482,.237746,1.069669),
new DragViewRot(.716059,-.697518,-.026971,3.150733,.237746,1.069669),
new ClickButton(toggleWireFrame),

//new TugCP(484,-1.052933,.176171),
//new ClickButton(toggleWireFrame),

new DragViewRot(.682983,-.65639,-.320449,2.569079),
new DragViewPos(-.000172,-1.208966,-.018749),
new TugCP(482,-.507939,.034482),
new ClickButton(toggleWireFrame),
new TugCP(484,-.617279,.157037),
new ClickButton(toggleWireFrame),


new SelectNode(pelvis),
new ClickButton(toggleXRayMode),
//new DragViewRot(-.110932,.993512,.025042,5.711549,.523136,.356697),
//new DragViewRot(-.110171,-.909152,-.401627,2.697273),
//new DragViewRot(.917614,.021493,-.396891,.067834),
new MouseZoom(1,.64875,-.324375),
//new DragViewPos(.12336,-.892629,-.038172,-.396891,.067834),
new DragViewRot(.70626,.707261,.031289,.384862,.64875,-.324375),
new DragViewPos(.131569,-.728843,-.082973,.64875,-.324375),
new ClickButton(toggleXRayMode),

new Section("animate bad"),
new Collapse(44),
new Collapse(61),
new SelectNode(88),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0047\\sound.wav"),
new ToggleField("play"),
new Wait(12.28),

new Section(Complete),
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
