/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Add_a_Group;
extern const char* Build_the_Pelvis;
extern const char* Add_a_pink_group;
extern const char* Build_the_Left_Eye;
extern const char* Copy_the_Left_Eye_to_the_Right;
extern const char* Build_the_Neck;
extern const char* Build_the_Head;
extern const char* Add_a_Cream_Group;
extern const char* Build_the_Left_Wrist;
extern const char* Build_the_Left_Elbow;
extern const char* Build_the_Left_Shoulder;
extern const char* Copy_the_Left_Arm_to_the_Right;
extern const char* Add_a_Blue_Group;
extern const char* Build_the_Left_Ankle;
extern const char* Build_the_Left_Knee;
extern const char* Build_the_Left_Hip;
extern const char* Copy_the_Left_Leg_to_the_Right;
extern const char* Position_the_Limbs_and_Neck;
extern const char* Add_a_Green_Group;
extern const char* Place_the_Avatar_to_the_Floor;
extern const char* Move_the_Pivot_Points;
extern const char* Move_the_Eye_Pivot_Points;
extern const char* Move_the_Rest_of_the_Pivot_Points;
extern const char* Add_a_Gesture_Group;
extern const char* Setup_Animation;
extern const char* Record_the_poses;
extern const char* Complete;

extern const char* menu_paste;
extern const char* menu_import;
extern const char* menu_all_nodes_from_file;


extern const char* name_pelvis;
extern const char* name_tummy0;
extern const char* name_tummy1;
extern const char* name_thorax;
extern const char* name_neck;
extern const char* name_head;
extern const char* name_l_eyeball;
extern const char* name_r_eyeball;

extern const char* name_l_collar;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

extern const char* name_r_collar;
extern const char* name_r_shoulder;
extern const char* name_r_elbow;
extern const char* name_r_wrist;

extern const char* name_l_hip;
extern const char* name_l_knee;
extern const char* name_l_ankle;
	
extern const char* name_r_hip;
extern const char* name_r_knee;
extern const char* name_r_ankle;

extern const char* name_front_view;
extern const char* name_left_view;
extern const char* name_right_view;
extern const char* name_back_view;
extern const char* name_birds_eye_view;
extern const char* name_worms_eye_view;
extern const char* name_showcase_view;
extern const char* menu_delete;

extern const char* str_hello;

void InputEvent::preNurbsLatheAvDemo(){
	g_robotDemo->fileName="nurbs-lathe-avatar";
	g_robotDemo->function=InputEvent::nurbsLatheAvDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::nurbsLatheAvDemo(){

	const int seamless = 1;
	const int pelvis = 3;
	const int tummy0 = 4;
	const int tummy1 = 5;
	const int thorax = 6;
	const int neck = 7;
	const int head = 8;
	const int headEnd = 9;
	//const int l_eyeball = head+1;
	//const int r_eyeball = l_eyeball+1;

	const int l_collar = 10;
	const int l_shoulder = 11;
	int l_elbow = 12;
	int l_wrist = 13;
	const int l_handEnd = 14;

	const int r_collar = 15;
	const int r_shoulder = 16;
	int r_elbow = 17;
	int r_wrist =	18;
	const int r_handEnd = 19;

	const int l_hip = 20;
	int l_knee = 21;
	int l_ankle = 22;
	const int l_footEnd = 23;

	const int r_hip = 24;
	int r_knee = 25;
	int r_ankle = 26;
	const int r_footEnd = 27;

	const int buildGroup = 28;

	const int gestureGroup = 77;
	const int anim = 78;

	InputEvent* create_Skeleton_of_PartsArray[]={
		
		new Section("Create a new seamless file"),
		new ResizeSceneTreeWin(330, 643),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "nurbs-lathe-avatar.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),
		new Section("Add floor & height guide"),
		new ClickButton(floorBuild),
		new ToggleField("zero_height"),

		new Section(Create_Skeleton_of_Parts),


	new SelectNode(pelvis),
	new ClickButton(toggleXRayMode),
	new ClickButton(toggleXRayEdit),
	new MoveToPivotPoint(pelvis),
new Move3d(0,-.05),
new AddCtrlPnt(0,.07),//tummy0
new AddCtrlPnt(0,.19),//tummy1
new AddCtrlPnt(0,.31),//thorax
new AddCtrlPnt(0,.5),//neck
new AddCtrlPnt(0,.57),//head
new AddCtrlPnt(0,.763374),//headEnd
new MoveToPivotPoint(thorax),
new Move3d(0,.31),//thorax
new AddCtrlPnt(.02,.44),//l_collar

new AddCtrlPnt(.16,.44),//l_shoulder
new AddCtrlPnt(.598406,.001594),//l_handEnd
new AddCtrlPnt(.499411,.100589),//l_wrist
new AddCtrlPnt(.329706,.270294),//l_elbow

new MoveToPivotPoint(pelvis),
new Move3d(0,-.05),
new AddCtrlPnt(.09,-.05),//l_hip
new AddCtrlPnt(.09,-.46),//l_knee
new AddCtrlPnt(.09,-.87),//l_ankle
new AddCtrlPnt(.09,-.92017),//l_footEnd

new MoveToPivotPoint(l_collar),
new Move3d(.02,.44),
new ClickButton(setLeftViewOrientation),
new MoveToPivotPoint(l_collar),
new Move3d(-.02,.44),
new ClickButton(setFrontViewOrientation),


		new NameNode(pelvis, name_pelvis),
		new NameNode(tummy0, name_tummy0),
		new NameNode(tummy1, name_tummy1),
		new NameNode(thorax, name_thorax),
		new NameNode(neck, name_neck),
		new NameNode(head, name_head),

		new NameNode(l_collar, name_l_collar),
		new NameNode(l_shoulder, name_l_shoulder),
		new NameNode(l_elbow, name_l_elbow),
		new NameNode(l_wrist, name_l_wrist),

		new NameNode(l_hip, name_l_hip),
		new NameNode(l_knee, name_l_knee),
		new NameNode(l_ankle, name_l_ankle),
		new ClickButton(toggleXRayEdit),

		new ClickButton(saveSmls),
new Section("Add lathes"),
new MoveToNode(1),
new RightClick,
new Move_MenuItem("create lathes from pivotPoints"),
new Click,
	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);


/*
new Section("Modify shape"),


		new Section(Add_a_pink_group),
		new NewNodeAsChild(GROUPBUILD, seamless),
		new SelectNode(pinkGroup),
		new DecFieldY("marker", 10),
		new DecFieldZ("marker", 10),

		new Section(Build_the_Pelvis),

		new SelectNode(pelvis),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 93),
		new ClickControlPoint(4),
		new Move3d(Vec3f(0, .61, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.15, .61, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.114768, .298663, 0)),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.157916, 0, 0)),
		new IncFieldGroup("point"),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.145376, .125742, 0)),
		new SelectVertex(3),
		new IncFieldGroup("point"),
		new ClickControlPoint(4),
		new Move3d(Vec3f(.150782, .477376, 0)),
		new ClickButton(setLeftViewOrientation),
		new DecFieldZ("scale", 100-70),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100-80),

		new Section(Build_the_Neck),
		new SelectNode(neck),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 35),
		new DecFieldX("rotation", 3),
		new DecFieldY("scale", 100-35),
		new DecFieldX("color", 100-90),
		new DecFieldY("color", 100-67),
		new DecFieldZ("color", 100-55),

		new Section(Build_the_Head),
		new ClickButton(setFrontViewOrientation),
		new SelectNode(head),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 28),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.0685, 0, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.092602, .082352, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.074807, .212197, 0)),
		new ClickControlPoint(4),
		new Move3d(Vec3f(0, .213292, 0)),
		new ClickButton(setLeftViewOrientation),
		new IncFieldZ("translation", 3),
		new DecFieldX("color", 100-90),
		new DecFieldY("color", 100-67),
		new DecFieldZ("color", 100-55),
		//////////
	//build eyes
		new Section(Build_the_Left_Eye),
//		new SelectNode(l_eyeball),
		new ClickButton(buildSphereForSelPart),
		new DecFieldCtrlX("rotation", 1),
		new DecFieldX("radius", 25-3),
		new DecFieldY("translation", 17),
		new IncFieldZ("translation", 7),
		new ClickButton(setFrontViewOrientation),
		new ClickButton(toggleWireFrame),
		new IncFieldX("translation", 3),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100),
		new DecFieldZ("color", 100),

	//Copy the Left Eye to the Right
		new Section(Copy_the_Left_Eye_to_the_Right),
//		new SelectNode(l_eyeball),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_LSHIFT),
		new ClickButton(copyPartForSelParts),
		new ToggleField("mirrorX"),
	};
	list+=EVENT_LIST(add_a_Pink_GroupArray);

	InputEvent* add_a_Cream_GroupArray[]={
		new Section(Add_a_Cream_Group),
		new Collapse(pinkGroup),
		new NewNodeAsChild(GROUPBUILD, seamless),
		new SelectNode(creamGroup),
		new DecFieldZ("marker", 20),
		new Section(Build_the_Left_Shoulder),
		new SelectNode(l_shoulder),
		new ClickButton(buildAvSegmentForSelPart),
		new IncFieldX("translation", 16),
		new DecFieldY("translation", 65),
		new DecFieldY("scale", 3),
		new ClickButton(toggleWireFrame),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.034578, 0, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.041518, .148037, 0)),
		new DecFieldZ("rotation", 3),

		new ClickButton(setLeftViewOrientation),
		new IncFieldZ("translation", 2),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100-80),

		new Section(Build_the_Left_Elbow),
		new SelectNode(l_elbow),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 88),
		new IncFieldZ("translation", 2),
		new DecFieldY("scale", 5),
		new ClickButton(setFrontViewOrientation),
		new IncFieldX("translation", 16),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.024554, 0, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.032073, .187374, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.035735, .293102, 0)),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100-80),

		new Section(Build_the_Left_Wrist),
		new SelectNode(l_wrist),
		new ClickButton(buildAvSegmentForSelPart),
		new IncFieldX("translation", 16),
		new DecFieldY("translation", 101),
		new DecFieldY("scale", 100-54),
		new DecFieldX("scale", 100-57),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.048195, .252597, 0)),
		new ClickButton(setLeftViewOrientation),
		new IncFieldZ("translation", 2),
		new DecFieldZ("scale", 100-90),
		new DecFieldX("color", 100-90),
		new DecFieldY("color", 100-67),
		new DecFieldZ("color", 100-55),
		new ClickButton(setFrontViewOrientation),

		//Copy the Left Arm to the Right
		new Section(Copy_the_Left_Arm_to_the_Right),
		new SelectNode(l_shoulder),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_LSHIFT),
		new ClickButton(copyPartForSelParts),
		new ToggleField("mirrorX"),

		new ClickButton(saveSmls),
	};
	list+=EVENT_LIST(add_a_Cream_GroupArray);

	InputEvent* add_a_Blue_GroupArray[]={
		new Section(Add_a_Blue_Group),
		new Collapse(creamGroup),
		new NewNodeAsChild(GROUPBUILD, seamless),
		new SelectNode(blueGroup),
		new DecFieldX("marker", 10),
		new DecFieldY("marker", 10),
		new Section(Build_the_Left_Hip),
		new SelectNode(l_hip),
		new ClickButton(buildAvSegmentForSelPart),
		new IncFieldX("translation", 9),
		new DecFieldY("translation", 133),
		new IncFieldY("scale", 53),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.065422, .147206, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.067349, .3, 0)),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100-80),

		new Section(Build_the_Left_Knee),
		new SelectNode(l_knee),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 172),
		new IncFieldX("translation", 9),
		new IncFieldY("scale", 53),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.037226, -.002623, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.048573, .137332, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.056204, .300033, 0)),
		new DecFieldX("color", 100),
		new DecFieldY("color", 100-80),

		new Section(Build_the_Left_Ankle),
		new SelectNode(l_ankle),
		new ClickButton(buildAvSegmentForSelPart),
		new DecFieldY("translation", 175),
		new IncFieldX("translation", 9),
		new DecFieldY("scale", 100-28),
		new ClickControlPoint(1),
		new Move3d(Vec3f(.059609, -.008864, 0)),
		new ClickControlPoint(2),
		new Move3d(Vec3f(.062153, .158957, 0)),
		new ClickControlPoint(3),
		new Move3d(Vec3f(.026871, .282803, 0)),
		new ClickButton(setLeftViewOrientation),
		new IncFieldZ("scale", 50),
		new IncFieldZ("translation", 4),
		new ClickButton(setFrontViewOrientation),
		new DecFieldY("color", 100),
		new DecFieldZ("color", 100-70),

		//Copy the Left Leg to the Right
		new Section(Copy_the_Left_Leg_to_the_Right),
		new SelectNode(l_hip),
		new VirtKeyDown(VK_LSHIFT),
		new VirtKeyDown(VK_DOWN),
		new VirtKeyUp(VK_DOWN),
		new VirtKeyUp(VK_LSHIFT),
		new ClickButton(copyPartForSelParts),
		new ToggleField("mirrorX"),

		new ClickButton(saveSmls),
	};
	list+=EVENT_LIST(add_a_Blue_GroupArray);

	InputEvent* move_the_Pivot_PointsArray[]={
		new Section(Move_the_Pivot_Points),
		new SelectNode(pelvis),
		new DecFieldY("pivotPoint", 88),
		new SelectNode(neck),
		new IncFieldY("pivotPoint", 55),
		new SelectNode(head),
		new IncFieldY("pivotPoint", 7),

		new SelectNode(l_shoulder),
		new IncFieldY("pivotPoint", 49),
		new IncFieldX("pivotPoint", 16),

		new ClickButton(setLeftViewOrientation),

		new IncFieldZ("pivotPoint", 2),
		new SelectNode(l_elbow),
		new DecFieldY("pivotPoint", 24),
		new SelectNode(l_wrist),
		new DecFieldY("pivotPoint", 24),

		new ClickButton(setFrontViewOrientation),
		new SelectNode(l_hip),
		new IncFieldX("pivotPoint", 9),
		new SelectNode(l_knee),
		new DecFieldY("pivotPoint", 41),
		new SelectNode(l_ankle),
		new DecFieldY("pivotPoint", 41),
	};
	list+=EVENT_LIST(move_the_Pivot_PointsArray);
*/
	InputEvent* Add_a_Gesture_GroupArray[]={
		new Section(Add_a_Gesture_Group),
		new Collapse(buildGroup),
		new SelectNode(gestureGroup), //at this stage this is the no output group
		new NewNodeAsSiblingAbove(GESTUREGROUP, gestureGroup),
		new Section(Setup_Animation),
		new NewNodeAsChild(ANIM, gestureGroup),
		new NameNode(anim, str_hello),
		new IncFieldX("period", 1),

//		new Section("Set begin and end poses"),
		new Section(Record_the_poses),

new SelectNode(l_shoulder),
new MoveToAnimRotPoint(),
new Move3d(.495,.105),
new SelectNode(r_shoulder),
new MoveToAnimRotPoint(),
new Move3d(.245,.845),
		new ToggleField("copy", 1),
		new DragAnimSlider(1),
		new ToggleField("paste"),
		new ToggleField("ok"),

		//new MouseZoom(1),
		new DragAnimSlider(.25),
		new SelectNode(r_collar),
		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.48,.36,.02)),

		new SelectNode(r_shoulder),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.265,.3,.020002)),
		new SelectNode(r_elbow),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.311474,.42654,.020002)),
		new SelectNode(l_shoulder),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.635,.53,.020002)),
		new SelectNode(l_elbow),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.705608,.114373,.020002)),
		new SelectNode(l_wrist),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.732901,.064384,.020002)),
		new ClickButton(setRightViewOrientation),

		new SelectNode(r_shoulder),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.015002,1.03,.17)),
		new SelectNode(r_elbow),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.523454,.916936,.243526)),
		new SelectNode(r_wrist),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.766737,.895295,.229557)),
		new ClickButton(setBirdsEyeViewOrientation),

		new SelectNode(r_shoulder),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.27,-.255002,.44)),
		new SelectNode(r_wrist),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(-.085883,-.687791,.650296)),
		new ClickButton(setRightViewOrientation),

		new SelectNode(pelvis),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.500002,-.11,0)),
		new SelectNode(r_hip),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.525002,.08,.09)),
		new SelectNode(r_knee),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.530427,-.566887,.09)),
		new SelectNode(r_ankle),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.513688,-.819757,.09)),
		new SelectNode(l_hip),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.530002,.03,-.09)),
		new SelectNode(l_knee),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.432457,-.654811,-.09)),
		new SelectNode(l_ankle),

new SelectNode(tummy0),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.544298,.089145,0)),
new SelectNode(tummy1),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.549093,.198745,0)),
new SelectNode(thorax),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.556608,.318509,0)),
new SelectNode(neck),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.554893,.503328,0)),
new SelectNode(head),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.557266,.578288,0)),

		//new MoveToAnimRotPoint(),
		//new Move3d(Vec3f(.361178,-.726758,-.09)),
		//new SelectNode(neck),

		//new MoveToAnimRotPoint(),
		//new Move3d(Vec3f(.58054,.556081,0)),
		//new SelectNode(head),

		new ClickButton(setFrontViewOrientation),

		new SelectNode(pelvis),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.5,.005,.000002)),
		new SelectNode(r_hip),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.41054,-.119841,.000002)),
		new SelectNode(l_hip),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.55946,-.065159,.000002)),
new SelectNode(tummy0),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.491973,.048431,.014298)),
new SelectNode(tummy1),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.49861,.162738,.024093)),
new SelectNode(thorax),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.455984,.297473,.031611)),
new SelectNode(neck),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.470773,.487292,.0399)),
new SelectNode(head),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.472109,.552239,.042273)),

		new ClickButton(setRightViewOrientation),
		new ClickButton(invertBackgroundColor),
		new DragViewRot(.002363,.999995,.002291,1.587749),
		new SelectNode(pelvis),
		new MoveToPivotPoint(pelvis),
		new Move3d(Vec3f(-.025,-.045,0)),

		new ClickButton(setFrontViewOrientation),
		new ToggleField("copy", 1),
		new DragAnimSlider(.75),
		new ToggleField("paste"),
		new ToggleField("ok"),
		new DragAnimSlider(.5),
		new ToggleField("paste"),
		new ToggleField("ok"),

new SelectNode(r_collar),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.511285,.486438,.032331)),

		new SelectNode(r_shoulder),
		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.269089,.207605,.053353)),

		new SelectNode(r_elbow),
		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.148984,.20125,.219281)),
		new SelectNode(r_wrist),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.201875,.843881,.354247)),
		//////////////
		new SelectNode(pelvis),
		//new Section("here"),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.491004,-.06503,-.024897)),
		new SelectNode(r_hip),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.426214,-.026176,-.024897)),
		new SelectNode(pelvis),

		new MoveToPivotPoint(pelvis),
		//new Move3d(Vec3f(.011004,-.04503,-.024897)),
		new Move3d(Vec3f(0,-.05,-.024897)),


new SelectNode(tummy0),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.506814,.078864,-.010692)),
new SelectNode(tummy1),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.511004,.198323,-.000912)),
new SelectNode(thorax),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.493655,.313061,.006653)),
new SelectNode(neck),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.487022,.50287,.015014)),
new SelectNode(head),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.517141,.572829,.017403)),


		new SelectNode(l_shoulder),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.637545,.424586,.053281)),
		new SelectNode(l_elbow),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.742213,.261463,.025237)),
		new SelectNode(l_wrist),

		new MoveToAnimRotPoint(),
		new Move3d(Vec3f(.688207,-.105409,-.003327)),
		new ClickButton(toggleWireFrame),
		new DragViewRot(.552273,-.814241,-.178901,.430118),

		new ToggleField("play", 1),
		new Wait(2),
		new Section("Delete unwanted nodes"),
	new MoveToExitWindow(),
	new Click(),
new ClickButton(setFrontViewOrientation),
new MoveToNode(27),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(23),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(19),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(14),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(9),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new Collapse(pelvis),
new Collapse(23),
new MoveToNode(36),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(36),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(42),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(42),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(48),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(54),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
		new Section("Shape lathes"),
new ClickButton(invertBackgroundColor),
new ClickButton(toggleWireFrame),
		new SelectNode(24), //pelvis
		new ClickControlPoint(0),
		new Move3d(0, -.05),
		new ClickControlPoint(1),
		new Move3d(.15, -.05),
		new ClickControlPoint(2),
		new Move3d(.153, .043),
		new ClickControlPoint(3),
		new Move3d(.135, .12),
		new ClickControlPoint(4),
		new Move3d(0, .14),

		new SelectNode(26), //tummy0
		new ClickControlPoint(0),
		new Move3d(0, -.019),
		new ClickControlPoint(1),
		new Move3d(.138, 0),
		new ClickControlPoint(2),
		new Move3d(.126, .062),
		new ClickControlPoint(3),
		new Move3d(.122, .12),
		new ClickControlPoint(4),
		new Move3d(0, .140276),

		new SelectNode(28), //tummy1
		new ClickControlPoint(0),
		new Move3d(0, -.010139),
		new ClickControlPoint(1),
		new Move3d(.124, -.002),
		new ClickControlPoint(2),
		new Move3d(.123, .063),
		new ClickControlPoint(3),
		new Move3d(.141, .123),
		new ClickControlPoint(4),
		new Move3d(0, .140277),

		new SelectNode(30), //thorax
		new ClickControlPoint(0),
		new Move3d(0, -.015932),
		new ClickControlPoint(1),
		new Move3d(.139, -.001),
		new ClickControlPoint(2),
		new Move3d(.15, .081),
		new ClickControlPoint(3),
		new Move3d(.151, .194),
		new ClickControlPoint(4),
		new Move3d(0, .202),

		new SelectNode(32), //neck
		new ClickControlPoint(0),
		new Move3d(0, -.02),
		new ClickControlPoint(1),
		new Move3d(.05, -.02),
		new ClickControlPoint(2),
		new Move3d(.05, .0325),
		new ClickControlPoint(3),
		new Move3d(.05, .085),
		new ClickControlPoint(4),
		new Move3d(0, .085),

		new SelectNode(34), //head
		new ClickControlPoint(0),
		new Move3d(0, -.02),
		new ClickControlPoint(1),
		new Move3d(.0685, -.02),
		new ClickControlPoint(2),
		new Move3d(.092602, .062352),
		new ClickControlPoint(3),
		new Move3d(.074807, .192197),

		new SelectNode(36), //shoulder
		new ClickControlPoint(0),
		new Move3d(0, -.031),
		new ClickControlPoint(1),
		new Move3d(.05, -.031),
		new ClickControlPoint(2),
		new Move3d(.041518, .116404),
		new ClickControlPoint(3),
		new Move3d(.034578, .26),
		new ClickControlPoint(4),
		new Move3d(0, .26),
new DecFieldZ("rotation"),
new DecFieldZ("rotation"),
new DecFieldZ("rotation"),
new DecFieldX("translation"),
new DecFieldX("translation"),
new IncFieldCtrlX("translation", 3),

		new SelectNode(38), //elbow
		new ClickControlPoint(0),
		new Move3d(0, -.035),
		new ClickControlPoint(1),
		new Move3d(.035735, -.0284471),
		new ClickControlPoint(2),
		new Move3d(.032073, .071995),
		new ClickControlPoint(3),
		new Move3d(.024554, .25),
		new ClickControlPoint(4),
		new Move3d(0, .25),

		new SelectNode(40), //wrist
		new ClickControlPoint(0),
		new Move3d(0, -.022),
//		new ClickControlPoint(1),
//		new Move3d(.05, .003598),
//		new ClickControlPoint(2),
//		new Move3d(.05, .059),
//		new ClickControlPoint(3),
//		new Move3d(.05, .14),
//		new DecFieldX("scale",100-57),

		new SelectNode(48), //hip
		new ClickControlPoint(0),
		new Move3d(0, -.009),
		new ClickControlPoint(1),
		new Move3d(.067349, -.009),
		new ClickControlPoint(2),
		new Move3d(.065422, .224775),
		new ClickControlPoint(3),
		new Move3d(.05, .45),
		new ClickControlPoint(4),
		new Move3d(0, .45),

		new SelectNode(50), //knee
		new ClickControlPoint(0),
		new Move3d(0, -.029),
		new ClickControlPoint(1),
		new Move3d(.056204, -.029021),
		new ClickControlPoint(2),
		new Move3d(.048573, .219882),
		new ClickControlPoint(3),
		new Move3d(.037226, .434013),
		new ClickControlPoint(4),
		new Move3d(0, .43),

		new SelectNode(52), //ankle
		new ClickControlPoint(0),
		new Move3d(0, -.034),
		new ClickControlPoint(1),
		new Move3d(.026871, -.029185),
		new ClickControlPoint(2),
		new Move3d(.062153, .005492),
		new ClickControlPoint(3),
		new Move3d(.059609, .052482),
		new ClickButton(setLeftViewOrientation),
		new SelectNode(24), //pelvis
		new DecFieldZ("scale", 100-70),
		new SelectNode(26), //tummy0
		new DecFieldZ("scale", 100-70),
		new SelectNode(28), //tummy1
		new DecFieldZ("scale", 100-70),
		new SelectNode(30), //thorax
		new DecFieldZ("scale", 100-70),
		new SelectNode(32), //neck
		new DecFieldX("rotation", 3),
		new SelectNode(34), //head
		new IncFieldZ("translation", 3),
		new SelectNode(40), //wrist
		new IncFieldZ("scale", 80),
		new SelectNode(52), //ankle
		new IncFieldZ("scale", 50),
		new IncFieldZ("translation", 4),
		new Section("Insert extra control points"),
		new ClickButton(setFrontViewOrientation),
		new MouseZoom(4),
		new DragViewPos(0,-1.08,0),
		new SelectNode(24),
		new AddCtrlPnt(.384229,-.336923),
new SelectNode(26),
new AddCtrlPnt(.402812,-.38054),
new AddCtrlPnt(.365831,.140304),
new SelectNode(28),
new AddCtrlPnt(.37193,.103856),
new AddCtrlPnt(.437236,.627533),
new SelectNode(30),
new AddCtrlPnt(.434362,.582933),
new ClickButton(toggleWireFrame),
new MouseZoom(1),
new DragViewPos(0,-.92,0),

		new Section("Color parts"),
new Collapse(pelvis),
new SelectNode(pelvis),
//new ClickButton(toggleWireFrame),
new ClickButton(openPalette),

new ClickColorCell(14, 0), //skin
new RectVert(-.609375,-.023438,.543125,.684062),
new ClickColorCell(8, 3), //blue
new RectVert(-.409375,.414063,.423125,-.613437),
new ClickColorCell(6, 1), //hot pink
//new RectVert(-.159375,-.895312,.180625,-.955312),
new RectVert(.184375,-1.010937,-.160625,-.890938),
		new Section("Add eyes"),
		new SelectNode(head),
new ClickButton(centerViewToPivotPoint),
		new ClickButton(toggleXRayEdit),
new MouseZoom(4),
new AddCtrlPnt(.12, .36),//l_eye
new ClickButton(setLeftViewOrientation),
new MoveToPivotPoint(head + 1),
new Move3d(-.4, .36),
new AddCtrlPnt(-.4 - .12, .36),//l_eye end
new NameNode(head + 1, name_l_eyeball),
new ClickButton(buildSphereForSelPart),
new ClickButton(setFrontViewOrientation),
new Hide(head),
new ClickColorCell(7, 0), //black
new RectVert(-.353125,.501562,.334375,.189063),
new Hide(head),
//new ClickButton(toggleWireFrame),

new Collapse(27), //build group
new Collapse(69), //anim
new SelectNode(69), //anim
new SelectNode(135), //showcase view
//new DragViewRot(-.483572, .867491, .116694, .675209),
new ToggleField("play", 1),
};
	list+=EVENT_LIST(Add_a_Gesture_GroupArray);

	l_knee++;
	l_ankle++;
	r_elbow+=2;
	r_wrist+=2;
	l_elbow+=3;
	l_wrist+=3;
	//r_knee++;
	//r_ankle++;

// IK Demo	
	InputEvent* ik_array[]={
		new Section("Setup IK"),
	new MoveToExitWindow(2),
	new Click(),

new MoveToNode(69),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
		new NewNodeAsChild(ANIM, 68),
		new SelectNode(69),
		new IncFieldX("period", 1),
		new SelectNode(pelvis),
		new ToggleField("ik"),
		new ToggleField("pin"),
new SelectNode(l_knee),
new ToggleField("ik"),
new SelectNode(l_ankle),
new ToggleField("ik"),
new ToggleField("pin"),
new SelectNode(r_knee),
new ToggleField("ik"),
new SelectNode(r_ankle),
new ToggleField("ik"),
new ToggleField("pin"),

new SelectNode(l_elbow),
new ToggleField("ik"),
new SelectNode(l_wrist),
new ToggleField("ik"),
new ToggleField("pin"),

new SelectNode(r_elbow),
new ToggleField("ik"),
new SelectNode(r_wrist),
new ToggleField("ik"),
new ToggleField("pin"),

new MoveToNode(r_wrist),
new RightClick,
new Move_MenuItem("capture IK points"),
new Click,
new Section("Pose the first key frame"),

//new MoveToPivotPoint(r_knee),
//new Move3d(Vec3f(-.071082,-.425175,-.196945)),

//new MoveToPivotPoint(l_knee),
//new Move3d(Vec3f(.073658,-.449873,-.101571)),

new ClickButton(setFrontViewOrientation),
new MoveToPivotPoint(pelvis),
new Move3d(Vec3f(-.04,-.420001,.000001)),

new MoveToPivotPoint(l_wrist),
new Move3d(Vec3f(.509996,.304999,.020002)),

new MoveToPivotPoint(l_elbow),
new Move3d(Vec3f(.339999,.109999,.020001)),

new MoveToPivotPoint(r_wrist),
new Move3d(Vec3f(-.254992,-.405001,.020001)),

new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.224996,-.165001,-.049996)),


new ClickButton(setLeftViewOrientation),


new MoveToPivotPoint(r_knee),
new Move3d(Vec3f(-.340001,-.645001,-.09)),

new MoveToPivotPoint(l_knee),
new Move3d(Vec3f(-.335001,-.645001,.09)),

new ClickButton(setRightViewOrientation),
new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.049998,-.180001,.194996)),

//new Section("Drag pelvis up"),
new DragViewRot(.719866,-.516647,-.463539,.360229),

		new ToggleField("copy", 1),
		new DragAnimSlider(1),
		new ToggleField("paste"),
		new ToggleField("ok"),

new Section("Pose the 2nd key frame"),
new DragAnimSlider(.5),

new MoveToPivotPoint(pelvis),
new Move3d(Vec3f(-.257362,-.042749,-.119455)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.252638,.117251,-.119455)),

////////
new MoveToPivotPoint(r_wrist),
new Move3d(Vec3f(-.66619,.757055,-.074227)),

new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.554334,.550381,-.006165)),



new MoveToPivotPoint(l_ankle),
new Move3d(Vec3f(.081297,-.468112,-.222077)),

new DragViewRot(.112671,-.993511,-.015499,1.637876),


new MoveToAnimRotPoint(),
new Move3d(Vec3f(.486297,.081888,-.222077)),

new MoveToPivotPoint(r_knee),
new Move3d(Vec3f(-.010789,-.446593,-.194857)),

new MoveToPivotPoint(l_knee),
new Move3d(Vec3f(-.195451,-.310396,-.016429)),

new DragViewRot(.939592,.204884,-.274208,.223375),
new MoveToPivotPoint(r_knee),
new Move3d(Vec3f(-.24942,-.494929,-.024117)),

//new Section("pin wrist"),

//new MoveToPivotPoint(l_elbow),
//new Move3d(Vec3f(.167237,.066218,.05835)),


///
new MoveToPivotPoint(pelvis),
new Move3d(Vec3f(-.268947,-.080961,-.058691)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.216053,-.270961,-.058692)),

new MoveToPivotPoint(tummy0),
new Move3d(Vec3f(-.252006,.033303,-.026184)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.247994,-.086697,-.026184)),

new MoveToPivotPoint(tummy1),
new Move3d(Vec3f(-.208866,.140458,.006323)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.281134,.000458,.006323)),

new MoveToPivotPoint(thorax),
new Move3d(Vec3f(-.137948,.231639,.03883)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.367052,.136639,.03883)),

new MoveToPivotPoint(neck),
new Move3d(Vec3f(-.000906,.35276,.0903)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.494094,.47276,.0903)),

new MoveToPivotPoint(head),
new Move3d(Vec3f(.037648,.408023,.109263)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.517648,.608023,.109263)),
///
//new MoveToPivotPoint(l_elbow),
//new Move3d(Vec3f(.312237,-.103782,.05835)),

new MoveToPivotPoint(pelvis),
new Move3d(Vec3f(-.268947,-.080961,-.058691)),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.816052,-.045961,-.058691)),

//new Section("left arm"),

new MoveToPivotPoint(r_wrist),
new Move3d(Vec3f(-.495586,.77695,.066202)),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(-.500586,.27695,.066202)),

new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.370255,.563119,.092499)),

new ClickButton(setBirdsEyeViewOrientation),


new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.33548,.122055,.544578)),
new DragViewRot(.719866,-.516647,-.463539,.360229),
new MoveToPivotPoint(r_elbow),
new Move3d(Vec3f(-.290042,.670696,-.024722)),

new ToggleField("play"),
new ToggleField("loop"),
new ClickButton(toggleXRayMode),
new DragViewRot(.065786,.964547,.25558,2.323816),
new Wait(2),
new DragViewRot(.719866,-.516647,-.463539,.360229),
new Wait(2),
new Section("Copy & insert paste mirror section"),
new ToggleField("pause"),
new DragAnimSlider(1),
new DragAnimSelect(0, 1),
new ToggleField("copy"),
new ToggleField("paste"),
new ToggleField("insert"),
new ToggleField("mirror"),
new ToggleField("ok"),

new Section("Copy & paste first key frame to last"),

new DragAnimSlider(0),
new ToggleField("copy"),
new DragAnimSlider(1),
new ToggleField("paste"),
new ToggleField("mirror"),
new ToggleField("ok"),


new Section("Translate 2nd key frame forward"),
new MoveToNode(r_ankle),
new RightClick,
new Move_MenuItem("unselect track"),
new Click,
new SelectNode(pelvis),
new DragAnimSlider(.25),
new ToggleField("copy"),
new ToggleField("paste"),
new ToggleField("transform"),
new SetFieldValue("translate", "0 0 .2"),
new ToggleField("ok"),

new Section("Translate 3rd key frame forward some more"),
new DragAnimSlider(.5),
new ToggleField("copy"),
new ToggleField("paste"),
new SetFieldValue("translate", "0 0 .4"),
new ToggleField("ok"),

new Section("Make first key frame mirror of 3rd"),
new MoveToNode(r_ankle),
new RightClick,
new Move_MenuItem("select track"),
new Click,
new SelectNode(pelvis),
new ToggleField("copy", 1),
new DragAnimSlider(0),
new ToggleField("paste"),
new ToggleField("mirror"),
new SetFieldValue("translate", "0 0 -.4"),
new ToggleField("ok"),

new Section("Make last half of walk cyckle from first half"),
new DragAnimSlider(.5),
new DragAnimSelect(0, .5),
new ToggleField("copy"),
new ToggleField("paste"),
new ToggleField("insert"),
new SetFieldValue("translate", "0 0 .4"),
new ToggleField("ok"),
new ToggleField("play", 1),
new Wait(5),

new Section("Speed up walk cycle"),
new ToggleField("pause"),
new DragAnimSlider(0),
new DragAnimSelect(1, 0),
new ToggleField("copy"),
new ToggleField("paste"),
new ToggleField("mirror"),
new ToggleField("transform"),
new SetFieldValue("steps", "50"),
new ToggleField("ok"),
new ToggleField("play", 1),
new Wait(5),

new Section("Duplicate walk cycle"),
new ToggleField("pause"),
new DragAnimSlider(1),
new DragAnimSelect(0, 1),
new ToggleField("copy"),
new ToggleField("paste"),
new ToggleField("insert"),
new ToggleField("transform"),
new ToggleField("ok"),
new ToggleField("play", 1),
new Wait(8),
new ClickButton(setBirdsEyeViewOrientation),
new Wait(8),

new Section("Change angle in walk"),

new DragViewPos(.039999,-.920001,-1.632499, -.6, -1),
new ToggleField("pause"),
new DragAnimSlider(1),
new DragAnimSelect(0, 1),

new SelectNode(tummy0),
new SelectNode(pelvis),
new DragViewPos(-.100001,-.920001,-1.477499, -.6, 0),

new MoveToAnimRotPoint(),
new Move3d(Vec3f(.354999,.327499,-.420001)),
new ToggleField("copy", 1),
new ToggleField("paste"),
new ToggleField("calcRot"),
new ToggleField("ok"),
new DragViewRot(.99752,.067991,.018207,.240893),

new Section("Stop foot sliding at turn"),
new MoveToNode(l_ankle),
new RightClick,
new Move_MenuItem("select track exclusive"),
new Click,

new ToggleField("play", 1),
new ToggleField("pause"),
new DragAnimSlider(1.0 / 8.0 * 3.0),
new ToggleField("copy"),
new DragAnimSlider(.5),
new ToggleField("paste"),
new ToggleField("transform"),
new ToggleField("calcRot"),
new ToggleField("ok"),
new ToggleField("play", 1),
new MoveToNode(l_ankle),
new RightClick,
new Move_MenuItem("select model tracks"),
new Click,
new ClickButton(saveSmls),

new Section("Import avatar"),
		new MoveToNode(0),
		new RightClick,
		new Move_MenuItem(menu_paste),
		new Move_MenuItem("children"),
		new Move_MenuItem(menu_import),
		new Move_MenuItem(menu_all_nodes_from_file),
		new Click,
		new SetFieldValue("filename", "nurbs-lathe-avatar.smls"),
		new ToggleField("open"),

new Section("Copy 2nd Anim bar and paste to 1st Anim bar"),
new Collapse(69),
new MoveToNode(128),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new Collapse(128),
new SelectNode(196),
new ToggleField("pause"),
new RightClick,
new Move_MenuItem("select all of timeline"),
new Click,
new ToggleField("copy"),
new MoveToNode(195),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,
new MoveToNode(195),
new RightClick,
new Move_MenuItem(menu_delete),
new Click,


new SelectNode(69),

new Collapse(128),
new MoveToNode(128+2),
new RightClick,
new Move_MenuItem("select model tracks exclusive"),
new Click,


new ToggleField("pause"),
new ToggleField("play"),
new ToggleField("pause"),
new DragAnimSlider(1.0 / 8.0 * .4),
//new DragAnimSlider(0),
new ToggleField("paste"),
new ToggleField("insert"),
new ToggleField("transform"),
new SetFieldValue("translate", "-.3 0 -.3"),
new ToggleField("ok"),
new ToggleField("play", 1),

new Section(Complete),
	};
	list+=EVENT_LIST(ik_array);
}
//new AddCtrlPnt(.418654,.522792),