/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;

extern const char* Build_a_Sphere;
extern const char* Convert_White_Part_to_Blue;
extern const char* Setup_Mirror_Editing;
extern const char* Mirror_Triangle_Structure;
extern const char* Tug_Ears_and_Nose;


void InputEvent::preImmediateRadialTugDemo(){
	g_robotDemo->fileName="poly-radial-tug";
	g_robotDemo->function=InputEvent::immediateRadialTugDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::immediateRadialTugDemo(){
	const int scene=0;
	const int seamless=1;
	const int part1=seamless+2;
	int sphereBuild=part1+1;

	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "poly-radial-tug.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),

		new Section(Build_a_Sphere),
		new ClickButton(buildSphereForSelPart),

new MouseZoom(1.7809),
new IncFieldX("staves",16),
new IncFieldX("bands",8),
//new ToggleField("yCentred"),
new DecFieldCtrlX("rotation"),

	new Section(Convert_White_Part_to_Blue),
	new MoveToNode(part1),
	new RightClick(),
	new Move_MenuItem("convert"),
	new Click,
/*
	new Section(Setup_Mirror_Editing),
new MoveToNewNode(MIRRORGROUP),
new LeftButtonDown(),
new MoveToNodeAsChild(1),
new LeftButtonUp(),
new MoveToNewNode(MIRROREDIT),
new LeftButtonDown(),
new MoveToNodeAsChild(4),
new LeftButtonUp(),
new MoveToNode(part1),
new VirtKeyDown(VK_LMENU),
new LeftButtonDown(),
new MoveToNodeAsChild(5),
new LeftButtonUp(),
new VirtKeyUp(VK_LMENU),
new Collapse(4),
*/
new MoveToExitSceneTree(),
new Click(),
new MoveToExitWindow(),
new Click(),

new Section(Mirror_Triangle_Structure),

new ClickButton(copyAndPasteMirroredPart),
new ClickButton(joinCloseVerticesMacro),

new Section(Tug_Ears_and_Nose),
new DragViewRot(.161442,-.986729,-.017415,.40896),
new IncButtonX(decTugRadius, 20),

new TugVertex(132,.528922,.58939,part1),
new ClickButton(setLeftViewOrientation),

new TugVertex(132,-.273431,.500413,part1),

//new ClickButton(invertBackgroundColor),
new DragViewRot(.987824,-.137071,-.073596,.707784),

new SelectVertex(256,part1),
new ClickButton(setBirdsEyeViewOrientation),

new TugVertex(256,-.005,-.605225,part1),

new TugVertex(248,.096155,-.599112,part1),
new TugVertex(232,.183491,-.518358,part1),
new TugVertex(255,.01522,-.596193,part1),
new DragViewRot(.717101,-.604499,.34691,1.384466),
new TugVertex(418,-.368225,.092773,part1),
new DragViewRot(.847051,.499371,-.182027,1.407294),
new SelectVertex(201,part1),
new DragViewRot(.802014,.560403,-.206694,1.680469),
new TugVertex(201,.381197,-.078811,part1),
new DragViewRot(.289825,-.637135,.714185,2.229115),
new TugVertex(201,-.385879,-.146285,part1),
new ClickButton(toggleWireFrame),
new DragViewRot(.896981,-.437121,-.06596,1.510187),
new DragViewRot(.843251,.531914,-.077429,1.226942),


new ClickButton(saveSmls),

	new Section(Complete),
	};
	list+=EVENT_LIST(eventArray);
}
