/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to , copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Complete;

extern const char* menu_delete;
extern const char* name_l_shoulder;
extern const char* name_l_elbow;
extern const char* name_l_wrist;

void InputEvent::preYouTubeTut(){
	g_robotDemo->fileName="";
	g_robotDemo->function=InputEvent::youTubeTut;
	g_robotDemo->name="Open t-piece.smls file";
	robotDemoStart(setupSequence);
}
void InputEvent::youTubeTut(){

	const int seamless = 1;
	const int l_shoulder = 3;
	const int l_elbow = 4;
	const int l_wrist = 5;

	InputEvent* create_Skeleton_of_PartsArray[]={
		//new Section("Open Lucy"),
		//new ClickButton(openSmls),
		//new SetFieldValue("filename", "mouth-morph-example.smls"),
		//new ToggleField("open"),
		//new SelectNode(3),
		//new ClickButton(openOwnership),
		//new Section("Begin movie from here"),
		//new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0000\\sound.wav"),
		//new DragViewRot(-.836293,-.509645,.202178,1.000069),
		//new Wait(2),
		//new DragViewRot(.306029,-.951177,-.040105,.526618),
		//new Wait(2),
		//new ClickButton(toggleWireFrame),
		//new Wait(2),
		//new ClickButton(openOwnership),
		//new Wait(2),
		//new DragViewRot(.404445,.911188,.078488,.49024),
		//new Wait(6),
		//new Section(Complete),

		new Section("Open t-piece.smls file"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0001\\sound.wav"),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "skinmorph"),
		new ToggleField("save"),
		new ClickYes(),

new Section("zoom in"),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0002\\sound.wav"),
		new ClickButton(buildAvSegmentForSelPart),
		new Wait(3),
		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0003\\sound.wav"),
		new MouseZoom(5.8865, .5,.65625),
		new DragViewPos(-.007135,-.121549,0, .5,.65625),

		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0004\\sound.wav"),
		new DecFieldX("staves",10),
		new DecFieldX("bands",6),


		new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0005\\sound.wav"),
//new ClickButton(toggleWireFrame),
new MoveToNode(3),
new Wait(1),
new MoveToNode(1),
new RightClick,
new Move_MenuItem("convert all"),
new Click,
new SelectNode(3),
new Wait(1),
new Section("drag 2 rings to elbow"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0006\\sound.wav"),
new RectVert(-.4375,-.021875,.44,-.211875),
new TugVertex(24,.214728,.052584,l_shoulder),
new RectVert(-.38125,.528125,.34875,.358125),
new TugVertex(36,.214728,.29737,l_shoulder),
new MoveToNode(3),
new Wait(1),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0007\\sound.wav"),
new RectVert(-.3625,.75625,.27,.63875),
new TugVertex(42,.207161,.607847,l_shoulder),

new Section("toggle into xray mode"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0008\\sound.wav"),
new ClickButton(toggleXRayMode),
new Wait(1.25),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0009\\sound.wav"),
new ClickButton(toggleXRayEdit),
new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0010\\sound.wav"),

	new MoveToPivotPoint(l_shoulder),
	new Move3d(-.032,1.052999),
	new Wait(3),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0011\\sound.wav"),
new Wait(1),
new AddCtrlPnt(-.042,.168451), //elbow
new Wait(4),
new AddCtrlPnt(-.042,-.726875), //wrist
new Section("Name the parts"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0012\\sound.wav"),
new MoveToNodeAsChild(l_shoulder),
new DoubleClick(),
new TypeString(name_l_shoulder),
new Wait(1.08),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0013\\sound.wav"),
new NameNode(l_elbow, name_l_elbow),
new NameNode(l_wrist, "l_wrist\n"),
new Wait(19.45),
new Section("easter egg"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0014\\sound.wav"),
new ClickButton(openOwnership),
new Wait(5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0015\\sound.wav"),
new SelectNode(l_shoulder),
new Wait(10),
new SelectNode(l_elbow),
new Wait(1.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0016\\sound.wav"),
new RectVert(-.48125,.234375,.39125,-.833124),
new Wait(6),
new Section("inspect work"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0017\\sound.wav"),
new DragViewRot(.771961,.632737,.060983,1.552691),
new DragViewRot(.847825,.348684,-.399515,3.716351),
new ClickButton(setFrontViewOrientation),
//new Wait(2),
new Section("plug in an anim node"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0018\\sound.wav"),
new MoveToNewNode(ANIM),
new LeftButtonDown(),
new MoveToNodeAsChild(0),
new LeftButtonUp(),
new SelectNode(6),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0019\\sound.wav"),
new IncFieldX("period"),
new Wait(2.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0020\\sound.wav"),
new DragAnimSlider(.5),
new SelectNode(l_elbow),
//new Wait(3),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0021\\sound.wav"),
new MoveToAnimRotPoint(),
new Move3d(Vec3f(.358,1.028453,0)),
//new Wait(3),
new Section("Click loop"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0022\\sound.wav"),
new ToggleField("loop", 1),
new Wait(1.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0023\\sound.wav"),
new ToggleField("pause"),
new Wait(4),
new Section("how to improve elbow"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0024\\sound.wav"),
new DragViewRot(-.579695,.811445,-.07423,1.802532),
new DragViewRot(-.589263,.807899,-.008267,3.293559),
new ClickButton(setFrontViewOrientation),
new Wait(1),
new ToggleField("pause"),
//new Wait(2),
new DragAnimSlider(1),
new Section("paint first ring"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0025\\sound.wav"),
new ClickButton(openOwnership),
new Wait(1),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0026\\sound.wav"),
new ToggleField("insert"),
new RectVert(-.44375,.246875,.36875,.111875),
new ToggleField("play", 1),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0027\\sound.wav"),
new DragViewRot(-.063828,.997629,.025727,1.979897),
new Wait(1),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0028\\sound.wav"),
new ClickButton(setFrontViewOrientation),
new ToggleField("pause"),
new Wait(1),
new Section("enable poly morphing"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0029\\sound.wav"),
new ClickButton(togglePolyMorphCapture),
new Wait(2),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0030\\sound.wav"),
new MoveToExitWindow(1),
new Click(),
new Wait(5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0031\\sound.wav"),
new DragAnimSlider(.5),
new Wait(1.55),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0032\\sound.wav"),
new RectVert(.14375,.70625,.31375,.53625),
new TugVertex(10,.257163,.622846,l_shoulder),
new ToggleField("pause"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0033\\sound.wav"),
new DragViewRot(-.608809,-.78543,.111586,.922519),
new ClickButton(toggleWireFrame),
new DragViewRot(-.618814,-.785244,.021477,3.062261),
//new DragViewRot(-.323706,-.804356,.498223,.585524),
new DragViewRot(.153617,-.987924,.020199,1.554737),
////////////
new Section("resume poly editing"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0034\\sound.wav"),
new Wait(3),
new ToggleField("pause"),
new MoveToExitWindow(),
new Click(),

new ClickButton(setLeftViewOrientation),
new ClickButton(toggleWireFrame),
//new ClickButton(resetRotations),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0035\\sound.wav"),
new ClickButton(toggleBackfaceSelect),
new Wait(5),
new ClickButton(toggleAccumulateSelect),
new Wait(3),
new RectPoly(-.171875,.25625,.150625,.23125),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0036\\sound.wav"),
new RectPoly(-.1625,.121875,.1725,.111875),
new ClickButton(deleteTriangle),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0037\\sound.wav"),
new TugVertex(30,.143935,.167585,l_elbow),
new ClickButton(joinVertexKeepDestColor),
new TugVertex(29,-.153938,.172585,l_elbow),
new ClickButton(joinVertexKeepDestColor),
new TugVertex(4,-.153938,.172369,l_shoulder),
new ClickButton(joinVertexKeepDestColor),
new TugVertex(4,.148935,.167369,l_shoulder),
new ClickButton(joinVertexKeepDestColor),
new Section("resume animation"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0038\\sound.wav"),
new SelectNode(6),
new ToggleField("play"),
new DragViewRot(.273116,-.808519,.521253,.880334),

new DragViewRot(.048535,-.953392,-.297805,3.53467),
new DragViewRot(.048535,-.953392,-.297805,3.53467, -.1375,.6125),
new DragViewRot(.048535,-.953392,-.297805,3.53467, -.2875,.634375),
new DragViewRot(.048535,-.953392,-.297805,3.53467, -.046875,.66875),

new Section("delete channels"),
new SelectNode(l_elbow),
new RectVert(-.3875,.865625,.1475,.485625),

new MoveToF10(),
new Move_MenuItem("delete"),
new Move_MenuItem("vertex"),
new Move_MenuItem("morpher channels for selected points"),
new Click(),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0039\\sound.wav"),
new ClickButton(setFrontViewOrientation),
new ToggleField("pause", 1),
new DragAnimSlider(.5),
new ClickButton(toggleBackfaceSelect),
new RectVert(.14375,.70625,.31375,.53625),
new TugVertex(9,.257163,.622846,l_shoulder),
new ToggleField("pause"),
new DragViewRot(-.608809,-.78543,.111586,.922519),
new ClickButton(toggleWireFrame),
new DragViewRot(-.618814,-.785244,.021477,3.062261),
//new DragViewRot(-.323706,-.804356,.498223,.585524),
//new DragViewRot(.153617,-.987924,.020199,1.554737),
new DragViewRot(.084877,-.964448,.250272,.61422),
new Wait(3),
new Section("explains slider copy and paste options"),
new ToggleField("pause"),
new DragAnimSlider(.5),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0040\\sound.wav"),
new ToggleField("copy"),
new DragAnimSlider(.75),
new ToggleField("paste"),
new Wait(18),
new ToggleField("remove"),

new Wait(5),
new Section("output to hanim"),
new DemoSound("C:\\Documents and Settings\\thyme\\My Documents\\Seamless3d\\Screenshot\\clip0041\\sound.wav"),
new SelectNode(0),
new ToggleField("genContactSBVT"),
new ToggleField("genHAnimNodes"),
new Wait(11),
new ToggleField("genColorIndex"),
new Wait(8),
new ToggleField("outScriptAsRoutes"),
new Wait(6),
new Section(Complete),

	};
	list+=EVENT_LIST(create_Skeleton_of_PartsArray);
}
