/* Seamless3d

Copyright (C) 2001-2011 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"
extern const char* Create_a_New_Seamless_File;
extern const char* Complete;
extern const char* Setup_Animation;
extern const char* dt_Build_a_Cone;
extern const char* dt_Set_Second_Pose;
extern const char* dt_Copy_First_Pose_and_Paste_to_Last_Pose;
extern const char* dt_Move_cones_pivot_point_Up;
extern const char* dt_Move_cone_as_a_Child_of_cylinder;
extern const char* Animate_Position;
extern const char* dt_Create_a_Bxx_Av_PROTO_by_Adding_a_GestureGroup;
extern const char* dt_Animate_cylinder;
extern const char* dt_Set_First_Pose;
extern const char* dt_Build_a_Cylinder;
extern const char* dt_Move_cone_Up;

extern const char* str_hello="hello";



void InputEvent::preBeelineAnimDemo(){
	g_robotDemo->fileName="beeline_anim";
	g_robotDemo->function=InputEvent::beelineAnimDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	robotDemoStart(setupSequence);
}
void InputEvent::beelineAnimDemo(){
	const int scene=0;
	const int seamless=1;
	const int part1=seamless+2;
	int coneBuild=part1+1;
	int anim=coneBuild+2;

InputEvent* eventArray[]={
	new Section(Create_a_New_Seamless_File),
	//new TypeString(deleteOldFileAndCreateFileName());
	new ClickButton(newSmls),
	new SetFieldValue("filename", "beeline_anim.smls"),
	new ToggleField("save"),
	new ClickYes(),
	new ClickButton(openSceneTree),
	new ClickButton(toggleXRayMode),

	new Section(dt_Build_a_Cone),
	new ClickButton(buildConeForSelPart),

	new Section(Setup_Animation),
};
	list+=EVENT_LIST(eventArray);


/////

	//selNode(0);
	newNodeAsChild(ANIM, scene);
//	list+=new MoveToNodeAsChild(anim);//we need to click it twice to make the carret wink if the window is made visiable for the first time
//	list+=new Click();
	nameNode(anim, str_hello);
	list+=new IncFieldX("period", 1);
/*
	list+=new Section(Make_Another_Control_Panel);
	rightClickNode(anim);
	list+=new Move_MenuItem(menu_new_panel);
	list+=new Click;
	list+=new MoveToTitleBar();
	list+=new LeftButtonDown();
	list+=new Move(100,374);
	list+=new LeftButtonUp();
	list+=new MoveToTitleBar(1);
	list+=new LeftButtonDown();
	list+=new Move(100,137);
	list+=new LeftButtonUp();
*/
	list+=new Section(dt_Set_First_Pose);
	list+=new SelectNode(part1);
	list+=new MoveToAnimRotPoint();
	list+=new Move3d(Vec2f(.415,.365));
	list+=new ToggleField("play", 1);
	list+=new Wait(1.5);

	list+=new Section(dt_Set_Second_Pose);
	list+=new DragAnimSlider(.5);
	list+=new MoveToAnimRotPoint();
//	if(g_robotDemo->express){
//	list+=new Move3d(Vec2f(.415,-.15));
//	}
//	else{
	list+=new Move3d(Vec2f(.415,-.5));
//	}
	list+=new ToggleField("play");
	list+=new Wait(1.5);

	list+=new Section(dt_Copy_First_Pose_and_Paste_to_Last_Pose);
	//list+=new DecFieldX("slider", 24);
	list+=new DragAnimSlider(0);
	list+=new ToggleField("copy");
	//list+=new IncFieldX("slider", 24);
	list+=new DragAnimSlider(1);
	list+=new ToggleField("paste");
	list+=new ToggleField("ok");
	list+=new ToggleField("play", 1);
	list+=new Wait(2);
	list+=new ToggleField("loop");
	list+=new ToggleField("play");

	list+=new Section(dt_Build_a_Cylinder);
	renameNode(part1, "cone");
	const int part2=part1+1;

	newNodeAsChild(PART, seamless);
	list+= new NameNode(part2, "cylinder"),
	list+=new ClickButton(buildCylinderForSelPart);
	coneBuild++;
	anim+=2;

	list+=new Section(dt_Move_cone_Up);
	selNode(coneBuild);
//	list+=new MoveToTitleBar(1);
//	list+=new Click;
	list+=new IncFieldY("translation", 50);
	selNode(part1);
	list+=new Section(dt_Move_cones_pivot_point_Up);
//	list+=new IncButtonY(decPivotX, 50);
	list+=new IncFieldY("pivotPoint", 50);

	list+=new Section(dt_Animate_cylinder);
	list+=new ToggleField("pause", 1);
	//list+=new DecFieldX("slider", 24);
	list+=new DragAnimSlider(0);
	selNode(part2);
	list+=new MoveToAnimRotPoint();
	list+=new Move3d(Vec2f(.415,-.365));
	list+=new ToggleField("copy", 1);
	//list+=new IncFieldX("slider", 24);
	list+=new DragAnimSlider(1);
	list+=new ToggleField("paste");
	list+=new ToggleField("ok");
	//list+=new DecFieldX("slider", 12);
	list+=new DragAnimSlider(.5);
	list+=new MoveToAnimRotPoint();
	list+=new Move3d(Vec2f(.415, .5));
	//list+=new ToggleField("loop");
	list+=new ToggleField("play");

	list+=new Section(dt_Move_cone_as_a_Child_of_cylinder);
	list+=new MoveToNodeAsChild(part1);
	list+=new LeftButtonDown();
	list+=new MoveToNodeAsChild(part2);
	list+=new LeftButtonUp();

	list+=new Section("Move cylinder's pivot point up half way");
	list+=new VirtKeyDown(VK_LMENU);
	list+=new IncFieldY("pivotPoint", 25);
	list+=new VirtKeyUp(VK_LMENU);
	list+=new Wait(1.5);

	list+=new Section(Animate_Position);
	list+=new ToggleField("pause", 1);
	list+=new DragAnimSlider(.25);
	//list+=new SelectNode(part1);
	list+=new MoveToPivotPoint(part1);
	list+=new Move3d(-.3, 0);
	list+=new ToggleField("play", 0);

	list+=new Section(dt_Create_a_Bxx_Av_PROTO_by_Adding_a_GestureGroup);
//	anim+=5;
//	selNode(anim);
	newNodeAsChild(GESTUREGROUP, 0);
//	list+=new MoveToNodeAsChild(anim);
//	list+=new LeftButtonDown();
//	list+=new MoveToNodeAsChild(anim+8);
//	list+=new LeftButtonUp();
	clickButton(saveSmls);
	list+=new Section(Complete);
}
