/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>
#include <direct.h>
#include <process.h>

#include "seamless3d.h"
#include "resource.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"

#include "robot_aid.h"

extern const char* Build_the_Triangles;
extern const char* Transfer_ownership_to_the_rest_of_the_parts;
extern const char* Colour_the_parts;
extern const char* Add_anim_bar;


extern const char* Move_the_Pivot_Points;
extern const char* Create_a_New_Seamless_File;
extern const char* Create_Skeleton_of_Parts;
extern const char* Complete;

void InputEvent::preWormAnimationDemo(){
	g_robotDemo->fileName="worm_animation";
	g_robotDemo->function=wormAnimationDemo;
	g_robotDemo->name=Create_a_New_Seamless_File;
	setupSequence();
}
void InputEvent::wormAnimationDemo(){
	const int seamless=1;
	const int seg0=seamless+2;
	const int seg1=seg0+1;
	const int seg2=seg1+1;
	const int seg3=seg2+1;
	const int seg4=seg3+1;
	const int seg5=seg4+1;
	const int seg6=seg5+1;
	const int seg7=seg6+1;

	const int seg0Build=seg7+1;
	const int nurbsLathe=seg7+1;
	const int colorSweep=nurbsLathe+2;
	const int transfer=nurbsLathe+2;
	const int anim=transfer+10;
	const int function=27;
	const int line0=function+1;
	const int line1=line0+1;
	const int line2=line1+1;
	const int line3=line2+1;
	const int line4=line3+1;
	const int line5=line4+1;
	const int line6=line5+1;
	const int line7=line6+1;
	const int line8=line7+1;

//	goto here;
	InputEvent* eventArray[]={
		new Section("Create a new seamless file"),
		new ResizeSceneTreeWin(385, 660),
		new ClickButton(newSmls),
		new SetFieldValue("filename", "worm_animation.smls"),
		new ToggleField("save"),
		new ClickYes(),
		new ClickButton(openSceneTree),


		new Section(Create_Skeleton_of_Parts),

	};
	list+=EVENT_LIST(eventArray);

	nameNode(seg0, "seg0");
	newNodeAsChild(PART, seg0);
	nameNode(seg1, "seg1");

	newNodeAsChild(PART, seg1);
	nameNode(seg2, "seg2");

	newNodeAsChild(PART, seg2);
	nameNode(seg3, "seg3");

	newNodeAsChild(PART, seg3);
	nameNode(seg4, "seg4");

	newNodeAsChild(PART, seg4);
	nameNode(seg5, "seg5");

	newNodeAsChild(PART, seg5);
	nameNode(seg6, "seg6");

	newNodeAsChild(PART, seg6);
	nameNode(seg7, "seg7\n");

	InputEvent* Build_the_Triangles_Array[]={
		new Section(Build_the_Triangles),

		new SelectNode(seg0),
		new ClickButton(buildAvSegmentForSelPart),
		new MouseZoom(5.615518),
		new DragViewPos(0,-.095325,0),

		new DecFieldX("bands", 4),

		new Section(Transfer_ownership_to_the_rest_of_the_parts),

		new NewNodeAsChild(TRANSFEROWNERSHIP, seamless),
	
		new UseNodeAsSource(seg0, transfer),
		new ClickButton(openOwnership),
		new UseNodeAsDest(14, transfer),
		new UseNodeAsDest(seg1, transfer),
		new UseNodeAsDest(seg2, transfer),
		new UseNodeAsDest(seg3, transfer),
		new UseNodeAsDest(seg4, transfer),
		new UseNodeAsDest(seg5, transfer),
		new UseNodeAsDest(seg6, transfer),
		new UseNodeAsDest(seg7, transfer),

		new SelectNode(transfer),
		new ToggleField("beginSP"),
		new IncFieldGroup("numOf"),
		new SetFieldValue("qty", "16"),
		new IncFieldX("numOf", 3),
		new IncFieldGroup("numOf"),
		new DecFieldX("numOf", 2),
		new IncFieldGroup("numOf"),
		new IncFieldGroup("numOf"),
		new IncFieldGroup("numOf"),
		new IncFieldGroup("numOf"),
		new IncFieldGroup("numOf"),
	};
	list+=EVENT_LIST(Build_the_Triangles_Array);

	InputEvent* move_the_Pivot_PointsArray[]={
		new Section(Move_the_Pivot_Points),
		new SelectNode(seg1),
		new ClickButton(toggleXRayMode),
		new ClickButton(toggleXRayEdit),
		new IncFieldY("pivotPoint", 4),
		new IncFieldCtrlY("pivotPoint", 2),
		new SelectNode(seg2),
		new IncFieldY("pivotPoint", 3),
		new IncFieldCtrlY("pivotPoint", 3),
		new SelectNode(seg3),
		new IncFieldY("pivotPoint", 4),
		new DecFieldCtrlY("pivotPoint", 3),
		new SelectNode(seg4),
		new IncFieldY("pivotPoint", 4),
		new DecFieldCtrlY("pivotPoint", 2),
		new SelectNode(seg5),
		new IncFieldY("pivotPoint", 4),
		new DecFieldCtrlY("pivotPoint", 3),
		new SelectNode(seg6),
		new IncFieldY("pivotPoint", 4),
		new DecFieldCtrlY("pivotPoint", 2),
		new SelectNode(seg7),
		new IncFieldY("pivotPoint", 3),
		new IncFieldCtrlY("pivotPoint", 3),
	};
	list+=EVENT_LIST(move_the_Pivot_PointsArray);

	InputEvent* Add_nodes_for_Animation_Array[]={
		new Section(Add_anim_bar),
		new NewNodeAsChild(ANIM, 0),
		new SelectNode(anim),
		new IncFieldX("period", 3),
		new Section("Add calcRot function"),
		new ToggleField("loop"),
		new ToggleField("play"),
		new NewNodeAsChild(FUNCTION, anim),
	};
	list+=EVENT_LIST(Add_nodes_for_Animation_Array);

	typeToNode(anim+1, "\b\b\b\b\b\b\b", 17);
	list+=new TypeString("Rotation calcRot(float v, float d)\n");
	newNodeAsChild(CODELINE, anim+1);
	list+=new NameNode(anim+2, "float a = sin((v + d) * PI * 2) * .2\n"),
	newNodeAsSiblingBelow(CODELINE, anim+2);
	list+=new NameNode(anim+3, "return Rotation(0, 0, 1, a)\n"),

	list+=new Section("Add anim bar's onFrame function"),
	newNodeAsChild(MEMBERFUNCTION, anim);
	newNodeAsChild(CODELINE, function);
	nameNode(line0, "seg0.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line0);
	nameNode(line1, "seg1.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line1);
	nameNode(line2, "seg2.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line2);
	nameNode(line3, "seg3.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line3);
	nameNode(line4, "seg4.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line4);
	nameNode(line5, "seg5.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line5);
	nameNode(line6, "seg6.rotation=calcRot(v, 0)\n");
	newNodeAsSiblingBelow(CODELINE, line6);
	nameNode(line7, "seg7.rotation=calcRot(v, 0)\n");

	//list+=new Section(Invert_the_Last_4_Parts);
	//typeToNode(line4, "-\n", 16);
	//typeToNode(line5, "-\n", 16);
	//typeToNode(line6, "-\n", 16);
	//typeToNode(line7, "-\n", 16);

	list+=new Section("Add delay");

	typeToNode(line1, ".071\n", 27);
	typeToNode(line2, ".143\n", 27);
	typeToNode(line3, ".214\n", 27);
	typeToNode(line4, ".286\n", 27);
	typeToNode(line5, ".357\n", 27);
	typeToNode(line6, ".429\n", 27);
	typeToNode(line7, ".5\n", 27);

	//list+=new Section(Un_Invert_the_4_Last_Parts_For_a_Cat_Tail_Effect);

	//typeToNode(line4, "\b", 17);
	//typeToNode(line5, "\b", 17);
	//typeToNode(line6, "\b", 17);
	//typeToNode(line7, "\b", 17);
	//clickButton(saveSmls);

	list+=new Section("Invert the delay");
	typeToNode(anim+2, "\b-\n", 18);


	list+=new Section(Colour_the_parts);
	list+=new ToggleField("play", 1),
	list+=new SelectNode(nurbsLathe);
	list+=new NewNodeAsSiblingAbove(COLORSWEEP, transfer);
	useNodeAsDest(nurbsLathe+1, colorSweep);
	selNode(colorSweep);
	list+=new DecFieldCtrlY("location", 1);
	incGroupCount("color");
	decIndex("color");
	setFieldValue("color", "1 1 0");
	incIndex("color");
	setFieldValue("distance", ".006");
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new IncFieldX("distance", 1);
	list+=new IncFieldCtrlX("distance", 4);
	setFieldValue("color", "1 1 0");
	incGroupCount("color");
	list+=new IncFieldX("distance", 1);
	list+=new IncFieldCtrlX("distance", 4);
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new IncFieldX("distance", 1);
	list+=new IncFieldCtrlX("distance", 2);
	setFieldValue("color", "1 1 0");
	incGroupCount("color");
	list+=new IncFieldCtrlX("distance", 6);
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 1);
	setFieldValue("color", "1 1 0");
	incGroupCount("color");
	list+=new IncFieldCtrlX("distance", 1);
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 1);
	setFieldValue("color", "1 1 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 4);
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 9);
	setFieldValue("color", "1 1 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 10);
	setFieldValue("color", "1 0 0");
	incGroupCount("color");
	list+=new DecFieldCtrlX("distance", 10);
	setFieldValue("color", "1 1 0");

	list+=new ClickButton(toggleWireFrame),
	list+=new ToggleField("play", 1),
	list+=new MouseZoom(1.653838),
	list+=new SelectNode(anim+2);
	list+=new DragViewRot(.938041,.036257,-.344623,1.011381),
	list+=new ClickButton(invertBackgroundColor),
	clickButton(saveSmls);

	list+=new Section(Complete);
}