/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/


#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "scene_tree.h"
#include "robot_aid.h"

extern SettingsPtr g_settings;
extern ScenePtr g_scene;
bool g_writeObj = true;
int g_matCnter = 0;
//extern bool g_genNormals;
extern SelNode g_selNode;
void addEffectToList(M_<Effect*>& effectList, Effect* effect, String& str);
void genSkinPovTransforms(Art* part, Matrix parentMatrix, Matrix parentRotMatrix, int& smi, M_Matrix& m_matrix, M_Matrix& m_rotMatrix);
void setUpInternalEffectPtrs2(Art* part, Effect* lastEffect); //this (2) wont be needed when setUpInternalEffectPtrs is fixed
void setUpInternalEffectPtrs2(Seamless* smls); //this (2) wont be needed when setUpInternalEffectPtrs is fixed
void setUpInternalEffectPtrs(Seamless* smls);
void resetCoordLen(M_Art& partList);
void extractFileName(String& filename, const String& path);
bool modifyFilename(String& filename, bool writeX3DXML, bool writeX3DVRMLClassic, bool writeOBJ, bool outputPovRay, Anim* anim);

void exportObj(){
	g_matCnter = 0;
	//Seamless* smls = dynamic_cast<Seamless*>(g_selNode.getRaw());
	//if(smls == 0){
	//	return;
	//}

	String filename = g_currentFilename;

	modifyFilename(filename, false, false, true, false, 0);


	g_genColorIndex = true;
	g_genNormals = true;
	g_writeObj=true;

	static M_<Effect*> effectList;
	effectList.length=0;

	g_writeGzipped=false;

	String str;
	String mtl;

	String mtlFilename;
	extractFileName(mtlFilename, filename);
	int len = mtlFilename.length;
	mtlFilename[len-3] = 'm';
	mtlFilename[len-2] = 't';
	mtlFilename[len-1] = 'l';


	str+="mtllib ";
	str+=mtlFilename;
	str+='\n';

	int vidx = 1;
	int vtidx = 1;
	//smls->outputToString(str, false);
	//smls->outObj(str, mtl, vidx, effectList, Matrix(), Matrix());
	g_scene->outObj(str, mtl, vidx, vtidx, effectList, Matrix(), Matrix());

	mtl.write(mtlFilename);
	str.write(filename);
	g_writeGzipped=g_scene->outputGZipped;
	g_writeObj=false;
	g_genNormals = true;
}
/*
void IndexedFaceSet::toObjString(String& str){

	Coordinate* coord =dynamic_cast<Coordinate*>(this->coord.p);
	TextureCoordinate* texCoord =dynamic_cast<TextureCoordinate*>(this->texCoord.p);
	Normal* normal =dynamic_cast<Normal*>(this->normal.p);

	M_Vec3f point;
	M_Vec2f point2f;
	M_Vec3f vector;

	if(coord){
		point = coord->point;
		for(int i=0; i<point.length; i++){
			str+="v ";
			point[i].toString(str);
			str+='\n';
		}
	}
	if(texCoord){
		point2f = texCoord->point;
		for(int i=0; i<point2f.length; i++){
			str+="vt ";
			point2f[i].toString(str);
			str+='\n';
		}
	}
	//if(normal){
	//	vector = normal->vector;
	//	for(int i=0; i<vector.length; i++){
	//		str+="nv ";
	//		vector[i].toString(str);
	//		str+='\n';
	//	}
	//}

	//str+="s off\n";
	str+="usemtl Object\n";

//	if(vector.length == point.length){
		for(int i=0; i<coordIndex.length; i+=4){
			str+="f ";
			str+=coordIndex[i] + 1;
			str+='/';
			str+=texCoordIndex[i] + 1;
//			str+='/';
//			str+=coordIndex[i] + 1;
			str+=' ';
			str+=coordIndex[i+1] + 1;
			str+='/';
			str+=texCoordIndex[i+1] + 1;
//			str+='/';
//			str+=coordIndex[i+1] + 1;
			str+=' ';
			str+=coordIndex[i+2] + 1;
			str+='/';
			str+=texCoordIndex[i+2] + 1;
//			str+='/';
//			str+=coordIndex[i+2] + 1;
			str+='\n';
		}
//	}
//	else{
	//	for(int i=0; i<coordIndex.length; i+=4){
	//		str+="f ";
	//		str+=coordIndex[i] + 1;
	//		str+=' ';
	//		str+=coordIndex[i+1] + 1;
	//		str+=' ';
	//		str+=coordIndex[i+2] + 1;
	//		str+='\n';
	//	}
	//}
}
void Shape::toObjString(String& str){
	IndexedFaceSet* ifs = dynamic_cast<IndexedFaceSet*>(geometry.p);
	if(ifs==0)return;
	ifs->toObjString(str);
}
/*
void exportObj(){
	Seamless* smls = dynamic_cast<Seamless*>(g_selNode.getRaw());
	if(smls == 0){
		return;
	}

	String filename = g_settings->file;

	modifyFilename(filename, false, false, true, false, 0);


	String str;
	str += "mtllib imported_bikini.mtl\n";

	static M_<Effect*> effectList;
	effectList.length=0;
	smls->outObj(str, effectList, Matrix(), Matrix());

	g_writeGzipped=false;
	str.write(filename);
	g_writeGzipped=g_scene->outputGZipped;
}
*/
void Seamless::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	if(effect==0)return;


	matrix = scaleMatrix(scale) * rotationMatrix(rotation) * translationMatrix(translation) * matrix;
	rotMatrix = rotationMatrix(rotation) * rotMatrix;

/*	addEffectToList(effectList, dynamic_cast<Effect*>(effect.p), str);
	for(int k=0; k<partList.length; k++){
		if(Effect* effect=dynamic_cast<Effect*>(partList[k]->effect.p)){
			addEffectToList(effectList, effect, str);
		}
	}
	*/
	str.requestMoreIfNeeded(4000000);

	const M_SArt& skeleton=this->skeleton;

	static M_Matrix m_matrix;
	static M_Matrix m_rotMatrix;

	m_matrix.length=0;
	m_rotMatrix.length=0;

	for(int i=0, smi=0; i<skeleton.length; i++){
		genSkinPovTransforms(skeleton[i], matrix, rotMatrix, smi, m_matrix, m_rotMatrix);
	}


/////////////////////////
	static GeomSource* geomSource= new GeomSource;

	if(partList.length==0 || partList[0]->workEffect==0)return;
	if(render==0 )return;
	int j=0;

	M_Int& coordIndex=geomSource->coordIndex.refValue();

	const_cast<Seamless*>(this)->catTranslationMatrix();
	geomSource->genTransformedNormals(partList);
	int coordLen=geomSource->coord.length;
	catMatrix();

//	addExtraCoordsRenderForGeomSource(coordIndex);

	int indexCount=coordIndex.length*3;

	if(!indexCount){
		return;
	}
	{
		coordLen=0;
		for(int k=0; k<partList.length; k++){
			coordLen+=partList[k]->coord.length;
		}
	}
//	str+="# coord ";
//	str+=coordLen;
//	str+="\n";
	int smlsCoordLen = 0;

	for(int j=0, smi=0,k=0;k<partList.length;k++){

		Art* part=partList[k];

		//part->renderFromCoord=j;

		const M_Vec3f& coord=part->coord;
		const M_Vec3f& normal=part->normal;
		smlsCoordLen+=coord.length;

		M_Int& coordGroup=part->coordGroup.refValue();
		M_Int& matrixIndex=part->matrixIndex;

		int i=0;

		for(int cg=0;cg<coordGroup.length; cg++){
			for(int c=coordGroup[cg];--c>=0&&i<part->coord.length;i++, j++){
				str+="v ";
				(m_matrix[matrixIndex[i]]*coord[i]).toString(str);
				//coord[i].toString(str);
				str+='\n';
				str+="vn ";
				(m_rotMatrix[matrixIndex[i]]*normal[i]).toString(str);
				//normal[i].toString(str);
				str+='\n';
			}
			smi++;
		}
		for(int i = 0 ;i<part->coord.length; i++, j++){
			str+="v ";
			(m_matrix[matrixIndex[i]]*coord[i]).toString(str);
			//coord[i].toString(str);
			str+='\n';
			str+="vn ";
			(m_rotMatrix[matrixIndex[i]]*normal[i]).toString(str);
			//normal[i].toString(str);
			str+='\n';
		}
		smi++;
	}
//	setUpInternalEffectPtrs2(this);
	effect->outObj(partList, str, mtl, vidx, vtidx, coordLen, coordIndex);
	vidx+=smlsCoordLen;
//	setUpInternalEffectPtrs(this);

//	resetCoordLen( partList);
}
void MonoColorEffect::outObj(const M_Art& partList, String& str, String& mtl, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{
}
void TextureEffect::outObj(const M_Art& partList, String& str, String& mtl, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{
	mtl+="newmtl mat";
	mtl+=g_matCnter;
	mtl+="\nNs 4\n"\
"d 1\n"\
"illum 2\n"\
"Kd ";
	diffuse.refValue().toString(mtl);
	mtl+='\n';
"Ka ";
	ambient.refValue().toString(mtl);
	mtl+='\n';
"Ks ";
	specular.refValue().toString(mtl);
	mtl += '\n';
	mtl += "map_Kd ";
	mtl += url;
	mtl += '\n';

	const M_Vec2f& texCoord = this->texCoord;
	for(int i=0; i<texCoord.length; i++){
		str+="vt ";
		texCoord[i].toString(str);
		str+='\n';
	}
	//str+="s off\n";
	str+="usemtl mat";
	str+=g_matCnter;
	str+='\n';
	for(int t=0, k=0; k<partList.length; k++){
		Art* part=partList[k];
		M_Triangle& triangle=part->triangle;
		int triLen=triangle.length;
		if(part->show){
			for(int tr=0; tr < triLen; tr++){
				str+="f ";
				int idx = coordIndex[t++] + vidx;
				str+=idx;
				str+='/';
				str+=triangle[tr].ta + vtidx;
				str+='/';
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+='/';
				str+=triangle[tr].tb + vtidx;
				str+='/';
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+='/';
				str+=triangle[tr].tc + vtidx;
				str+='/';
				str+=idx;

				str+='\n';

			}
		}
		else{
			t+=triLen*3;
		}
	}
/*
	for(int t=0, k=0; k<partList.length; k++){
		Art* part=partList[k];
		M_Triangle& triangle=part->triangle;
		int triLen=triangle.length;
		if(part->show){
			for(int tr=0, i=triLen; --i>=0; ){
				str+="f ";
				int idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + 1;
				str+=idx;
				str+="//";
				str+=idx;

				str+='\n';

				tr++;
			}
		}
		else{
			t+=triLen*3;
		}
	}
	*/
	vtidx += texCoord.length;
	g_matCnter++;
}

void ColorEffect::outObj(const M_Art& partList, String& str, String& mtl, int& vidx, int& vtidx, int vertexCount, M_Int& coordIndex)const{
	mtl+="newmtl mat";
	mtl+=g_matCnter;
	mtl+="\nNs 4\n"\
"d 1\n"\
"illum 2\n"\
"Kd ";
	diffuse.refValue().toString(mtl);
	mtl+='\n';
"Ka ";
	ambient.refValue().toString(mtl);
	mtl+='\n';
"Ks ";
	specular.refValue().toString(mtl);
	mtl+='\n';

	//str+="s off\n";
	str+="usemtl mat";
	str+=g_matCnter;
	str+='\n';

	for(int t=0, k=0; k<partList.length; k++){
		Art* part=partList[k];
		M_Triangle& triangle=part->triangle;
		int triLen=triangle.length;
		if(part->show){
			for(int tr=0, i=triLen; --i>=0; ){
				str+="f ";
				int idx = coordIndex[t++] + vidx;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+="//";
				str+=idx;
				str+=' ';

				idx = coordIndex[t++] + vidx;
				str+=idx;
				str+="//";
				str+=idx;

				str+='\n';

				tr++;
			}
		}
		else{
			t+=triLen*3;
		}
	}
	g_matCnter++;
}

void PovLight::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void PovFog::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void ModelMorpher::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
}
void Transform::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outPovRay(str, effectList, translationMatrix(-center) * rotationMatrix(-scaleOrientation) * scaleMatrix(scale) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * translationMatrix(center) * translationMatrix(translation) * matrix,
				rotationMatrix(-scaleOrientation) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * rotMatrix
			);
		}
	}
}
void Group::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void LOD::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
/*
void HAnimHumanoid::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& skeleton = this->skeleton.refValue();
	for(int k=0; k<skeleton.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(skeleton[k].p)){
			povRay->outPovRay(str, effectList, translationMatrix(-center) * rotationMatrix(-scaleOrientation) * scaleMatrix(scale) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * translationMatrix(center) * translationMatrix(translation) * matrix,
				rotationMatrix(-scaleOrientation) * rotationMatrix(scaleOrientation) * rotationMatrix(rotation) * rotMatrix
			);
		}
	}
}
*/
void Switch::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Collision::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Anchor::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void Billboard::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();
	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
void ProtoDeclare::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	M_Node& children=protoBody->children.refValue();
	for(int k=0;k<children.length;k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
Matrix getViewMatrix();
void Scene::outObj(String& str, String& mtl, int& vidx, int& vtidx, M_<Effect*>& effectList, Matrix matrix, Matrix rotMatrix){
	const M_Node& children = this->children.refValue();

	matrix=getViewMatrix();
	//rotationMatrix(rotation) * translationMatrix(translation) * matrix=scaleMatrix(scale);
	rotMatrix=rotationMatrix(rotation);

	for(int k=0; k<children.length; k++){
		if(PovRay* povRay=dynamic_cast<PovRay*>(children[k].p)){
			povRay->outObj(str, mtl, vidx, vtidx, effectList, matrix, rotMatrix);
		}
	}
}
