/* Seamless3d

Copyright (C) 2001-2006 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#define IDD_SCENE_TREE_WINDOW	5600
#define IDD_SETTINGS 5601
#define IDD_SELECTVERTEX 5602
#define EVX_COORD			0x6001
#define EVX_COLOR			0x6002

#define IDC_STATIC                      -1



#define MENU_DIFF 300

#define NEW 3500
#define NEW_ABOVE (NEW+MENU_DIFF*1)
#define NEW_REPLACE (NEW+MENU_DIFF*2)
#define NEW_BELOW (NEW+MENU_DIFF*3)

#define USE_NODE		(NEW+MENU_DIFF*4)
#define COPYOF_NODE		(NEW+MENU_DIFF*5)
#define MOVE_NODE		(NEW+MENU_DIFF*6)
//#define RESET_FIELD		(NEW+MENU_DIFF*7)
#define IS_DESTINATION	(NEW+MENU_DIFF*7)
#define ROUTE_DESTINATION (NEW+MENU_DIFF*8)
#define FIELDITEMBASE	7050


#define IDR_MAIN_ACCEL 3000
#define IDM_FONT 3001
#define IDM_SIZE 3002
#define IDM_STYLE 3003
#define OUTPUT_MESSAGE 3004
#define HIDE_SELECTED_CAGES 3005
#define SHOW_ALL_CAGES 3006
#define SHOW_SINGLE_CAGE 3007
#define BREAK_COLOR_JOIN 3008
#define FIND_THIN_TRIANGLE 3009
#define FIND_LAYERED_TRIANGLE 3010
#define RESET_ROTATIONS 3011
#define JOINVERTEXREMCOLOR 3012
#define TRANSFERSINGLEVERTEX 3013
#define MOVE_VERTEX 3014
#define COLOR_PART 3015
#define ZERO_TO_X 3016


#define RESET_3D_CURSOR			3071

#define HELP			3358
#define ABOUT			3359
#define IDS_GENERATE	3360
#define IDS_STAVES		3361
#define IDS_ROWS		3362
#define IDS_SPHERERAD	3363
#define IDS_HEIGHT		3364
#define COLOR_E			3365
#define COLOR_R			3366
#define COLOR_G			3367
#define COLOR_B			3368
#define SELECT_S		3369
#define SELECT_E		3370
#define COUNT_E			3371
#define HOME_TO_INIT	3372
#define DEC_COORD_X_LOCAL 3376
#define INC_COORD_X_LOCAL 3377
#define DEC_COORD_Y_LOCAL 3378
#define INC_COORD_Y_LOCAL 3379
#define DEC_COORD_Z_LOCAL 3380
#define INC_COORD_Z_LOCAL 3381
#define COMPILE_SCALE 3385
#define COMPILE_SCALE_ROTATION 3386
//#define LOOPBACK_IFS 3387
#define IMMEDIATE_RADIAL_TUG 3388
#define MULTI_PART_TUG 3389
#define TUG_RADIUS	3390
#define TUG_VERTEX_0X	3391
#define DEC_RADIUS	3392
#define INC_RADIUS	3393
#define ZOOM_OUT	3394
#define ZOOM_IN	3395

#define USE_ABOVE		3397
#define USE_REPLACE		3398
#define USE_BELOW		3399

#define COPYOF_ABOVE	3400
#define COPYOF_REPLACE	3401
#define COPYOF_BELOW	3402

#define MOVE_ABOVE		3403
#define MOVE_REPLACE	3404
#define MOVE_BELOW		3405

#define SELECT_ROUTE	3406
#define DELETE_ROUTE	3407
#define IMPORT_VERTEXANIM	3411
#define CONVERT_GROUP_TO_SMLS 3412
#define IMPORT_INDEXEDFACESET	3413
#define IMPORT_NODES_FROM_FILE	3414
#define BEAM_TO					3415
#define SPAGHETTI				3416
#define OUTPUT_X3D_HANIM_MODE	3417
#define OUTPUT_X3D_MODE			3418
#define JOIN_MATCHING_COLORS 3419
#define JOIN_COLOR			3421
#define SCENE_TREE_BACKGROUND_COLOR	3422
#define OPEN_NODE_WINDOW 3427
#define DEC_PIVOT_X	3428
#define INC_PIVOT_X	3429
#define DEC_PIVOT_Y	3430
#define INC_PIVOT_Y	3431
#define DEC_PIVOT_Z	3432
#define INC_PIVOT_Z	3433


enum {
	STRETCH_CURVE=3434,
	SAMPLE_POSE,
	SETUP_ANIMATION,

	ELEMENT_BEFORE_COPYOF,
	ELEMENT_BEFORE_MOVE,

	ELEMENT_REPLACE_COPYOF,
	ELEMENT_REPLACE_MOVE,

	ELEMENT_AFTER_COPYOF,
	ELEMENT_AFTER_MOVE,

	DELETE_ELEMENT,
	IMPORT_ANIMATION,


	OPTIMIZE,


	SEAMED_AV_DEMO_CREATE_SKELETON,
	SEAMED_AV_DEMO_GEN_TORSO,
	SEAMED_AV_DEMO_GEN_NECK_HEAD,
	SEAMED_AV_DEMO_GEN_ARMS,
	SEAMED_AV_DEMO_GEN_LEGS,
	SEAMED_AV_DEMO_CENTER_PARTS,
	SEAMED_AV_DEMO_TEXTURE_MAP,
	SEAMED_AV_DEMO_ANIMATE,

	BRANCHJOIN_AV_DEMO_CREATE_SKELETON,
	BRANCHJOIN_AV_DEMO_GEN_TORSO,
	BRANCHJOIN_AV_DEMO_GEN_NECK_HEAD,
	BRANCHJOIN_AV_DEMO_GEN_ARMS,
	BRANCHJOIN_AV_DEMO_GEN_LEGS,
	BRANCHJOIN_AV_DEMO_CENTER_PARTS,
	BRANCHJOIN_AV_DEMO_TEXTURE_MAP,
	BRANCHJOIN_AV_DEMO_ANIMATE,
	OPEN_NET_FILE
	//STRING_FROM_CHAT_WIN_COMMAND,
};
#define IDC_CURSOR1						129
#define IDB_BITMAP_NEWNODEBAR			130
#define IDB_BITMAP_TOOLBAR				131
#define IDI_MAIN_ICON                   101
#define WM_UPDATE						

#define editCol 180
#define textCol 110



/////////////////////////////////



#define IDC_X_DISTANCE 67
#define IDC_Y_DISTANCE 68
#define IDC_X_POINT_CNT 69
#define IDC_Y_POINT_CNT 70
#define IDC_BEGIN_WITH_SINGLE_POINT 71
#define IDC_END_WITH_SINGLE_POINT 72
#define IDC_X_CENTRED 73
#define IDC_Y_CENTRED 74
#define IDC_X_NEG_SIDE 75
#define IDC_Y_NEG_SIDE 76





#define SPHERE_DIALOGUE 1
#define CYLINDER_DIALOGUE 2
#define FLAT_DIALOGUE 3




#define IDM_QUIT      101
#define IDM_HOME      104
////////////////////////////////////////////







//#define NNP_SPHERICAL_CURVE	0x3603
//#define NNP_CIRCULAR_CURVE	0x3604
//#define NNP_CUT	0x3606







