/* Seamless3d

Copyright (C) 2001-2010 Graham John Perrett (AKA thyme) thyme@seamless3d.com www.seamless3d.com

Permission is hereby granted, free of charge, to any person obtaining a copy of this
software and associated documentation files (the "Software"), to deal in the Software
without restriction, including without limitation the rights to use, copy, modify,
merge, publish, distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to the following
conditions:

The above copyright notice and this permission notice shall be included in all copies or
substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
OTHER DEALINGS IN THE SOFTWARE.
*/

#include <windows.h>

#include "seamless3d.h"
#include "techuelife_triangle_editor.h"
#include "gui.h"
#include "resource.h"


Ptr<ToolBarWin> g_tb = new ToolBarWin;
extern const char* tip_toggleWireframe;
extern const char* tip_resetViewPosition;
extern const char* tip_resetViewOrientation;
extern const char* tip_centerViewToControlPoint;
extern const char* tip_centerViewToPivotPoint;
extern const char* tip_findThinTriangle;//"find thin triangle (Alt F)"
extern const char* tip_join_vertex_keep_both_colors;
extern const char* tip_join_vertex_keep_dest_color;
extern const char* tip_joinCloseVertices;
extern const char* tip_joinCloseVertecesForAllShownParts;

extern const char* tip_zeroToX;

extern const char* tip_build_sphere_for_selected_part;
extern const char* tip_build_cylinder_for_selected_part;
extern const char* tip_build_cone_for_selected_part;
const char* tip_build_rings_for_selected_part="build rings for selected part";
const char* tip_build_nurbs_lathe_for_selected_part="build nurbs lathe for selected part";
const char* tip_build_bendy_lathe_for_selected_part="build bendy lathe for selected part";
const char* tip_build_subdivision_for_selected_part="build_subdivision_for_selected_part";
extern const char* tip_build_torus_for_selected_part;
extern const char* tip_build_bezier_lathe_for_selected_part;
extern const char* tip_build_box_for_selected_part;
extern const char* tip_build_rectangle_for_selected_part;

extern const char* tip_undo;
extern const char* tip_redo;
extern const char* tip_reset_rotations;

extern const char* tip_new_smls_file;
extern const char* tip_open_smls_file;
extern const char* tip_open_smls_file_from_the_web;
extern const char* tip_save_smls_file;
extern const char* tip_import_triangles_from_file_to_part;
extern const char* tip_export_triangles_from_part_to_file;
extern const char* tip_scene_tree_window;
extern const char* tip_copy_vertex_part;
extern const char* tip_vertex_coord;
extern const char* tip_vertex_color;
extern const char* tip_zoom;
extern const char* tip_view_orientation;
extern const char* tip_reset_view_orientation;
extern const char* tip_view_orientation_at_right_angle;
extern const char* tip_view_position;
extern const char* tip_move_pivot_point;
extern const char* tip_compile_Part_and_its_decendents_scale_and_rotation_fields;
extern const char* tip_build_a_floor_for_an_avatar;
extern const char* tip_toggle_perspective;
extern const char* tip_help;
extern const char* tip_break_coord_join;
extern const char* tip_delete_selected_triangle;
extern const char* tip_delete_triangles_down_from_selected_vertex;
extern const char* tip_delete_triangles_left_from_selected_vertex;
extern const char* tip_join_colors_in_vertices_that_equal_the_same_color_and_whose_coords_are_joined;
extern const char* tip_paste_copied_color_to_selected_vertex;
extern const char* tip_paste_copied_color_to_part;
extern const char* tip_paste_ownership_from_copied_part_into_the_selected_vertex;
extern const char* tip_paste_triangles_from_the_copied_part_in_X_mirrored_form_into_the_selected_part;
extern const char* tip_add_triangles_from_the_copied_part_in_X_mirrored_form_to_the_selected_part;
const char* tip_copyAndPasteMirroredPart="copy and paste mirrored part";
extern const char* tip_swap_triangle_divide_between_the_copied_and_selected_triangles;
extern const char* tip_mirror_triangle;
extern const char* tip_split_triangle_between_the_vertices_marked_by_the_red_and_green_dots;
extern const char* tip_add_a_ColorSweep_for_selected_parts;
extern const char* tip_copy_upper_selected_parts_to_lower_selected_parts;
extern const char* tip_place_selected_parts;
extern const char* tip_swap_vertexs_index_order_with_previous_next;
extern const char* tip_select_previous_next_vertex_in_index_order;
extern const char* tip_select_previous_next_triangle_that_shares_the_selected_vertex;
extern const char* tip_select_previous_next_corner_in_triangle;
extern const char* tip_toggle_background_color;
const char* tip_quickTriangle="generate triangle from selected edge and copied vertex";
const char* tip_build_model_morpher_for_selected_seamless_node = "build model morpher for selected seamless node";
const char* tip_build_av_segment_for_selected_part = "build av segment for selected part";
const char* tip_do_build_cycle = "do build cycle";


///////////////
const char** tip_list[]={
&tip_toggleWireframe,
&tip_resetViewPosition,
&tip_resetViewOrientation,
&tip_centerViewToControlPoint,
&tip_centerViewToPivotPoint,
&tip_findThinTriangle,
&tip_join_vertex_keep_both_colors,
&tip_join_vertex_keep_dest_color,
&tip_joinCloseVertices,
&tip_joinCloseVertecesForAllShownParts,

&tip_zeroToX,

&tip_build_sphere_for_selected_part,
&tip_build_cylinder_for_selected_part,
&tip_build_cone_for_selected_part,
&tip_build_rings_for_selected_part,
&tip_build_nurbs_lathe_for_selected_part,
&tip_build_bendy_lathe_for_selected_part,
&tip_build_torus_for_selected_part,
&tip_build_bezier_lathe_for_selected_part,
&tip_build_box_for_selected_part,
&tip_build_rectangle_for_selected_part,

&tip_undo,
&tip_redo,
&tip_reset_rotations,

&tip_new_smls_file,
&tip_open_smls_file,
&tip_open_smls_file_from_the_web,
&tip_save_smls_file,
&tip_import_triangles_from_file_to_part,
&tip_export_triangles_from_part_to_file,
&tip_scene_tree_window,
&tip_copy_vertex_part,
&tip_vertex_coord,
&tip_vertex_color,
&tip_zoom,
&tip_view_orientation,
&tip_reset_view_orientation,
&tip_view_orientation_at_right_angle,
&tip_view_position,
&tip_move_pivot_point,
&tip_compile_Part_and_its_decendents_scale_and_rotation_fields,
&tip_build_a_floor_for_an_avatar,
&tip_toggle_perspective,
&tip_help,
&tip_break_coord_join,
&tip_delete_selected_triangle,
&tip_delete_triangles_down_from_selected_vertex,
&tip_delete_triangles_left_from_selected_vertex,
&tip_join_colors_in_vertices_that_equal_the_same_color_and_whose_coords_are_joined,
&tip_paste_copied_color_to_selected_vertex,
&tip_paste_copied_color_to_part,
&tip_paste_ownership_from_copied_part_into_the_selected_vertex,
&tip_paste_triangles_from_the_copied_part_in_X_mirrored_form_into_the_selected_part,
&tip_add_triangles_from_the_copied_part_in_X_mirrored_form_to_the_selected_part,
&tip_copyAndPasteMirroredPart,
&tip_swap_triangle_divide_between_the_copied_and_selected_triangles,
&tip_mirror_triangle,
&tip_split_triangle_between_the_vertices_marked_by_the_red_and_green_dots,
&tip_add_a_ColorSweep_for_selected_parts,
&tip_copy_upper_selected_parts_to_lower_selected_parts,
&tip_place_selected_parts,
&tip_swap_vertexs_index_order_with_previous_next,
&tip_select_previous_next_vertex_in_index_order,
&tip_select_previous_next_triangle_that_shares_the_selected_vertex,
&tip_select_previous_next_corner_in_triangle,
&tip_toggle_background_color,
&tip_quickTriangle,
&tip_build_model_morpher_for_selected_seamless_node,
&tip_build_av_segment_for_selected_part,
&tip_do_build_cycle
};


String g_language;

void doBuild();

void commonDoDrag(const Vec2i ptCursor, Vec2i& pos, Vec2i& dragPos);
void dummyFunction(){}
void openPalette();

extern SingleButton* g_toggleBackfaceSelectButton;
extern SingleButton* g_toggleAccumulateSelectButton;
extern SingleButton* g_togglePolyMorphCaptureButton;
ButtonPtr hold = g_togglePolyMorphCaptureButton;
void togglePolyMorphCapture();
extern Ptr<AnimClue> g_vcArtAnimBase;

MM_Button g_mm_build_button;
MM_Button g_mm_immediate_button;

void ToolBarWin::doDrag(Vec2i ptCursor){
	commonDoDrag(ptCursor, pos, dragPos);
}
void ToolBarWin::paint(){

	int indent=0,line=0;

	int* pEnd=&g_tb->pixBuf[0]+g_tb->size.x*g_tb->size.y;

	{
		paintColorSweepForCurvedBar(&iconSrcBuf[(iconSrcBufCY-1)*480+470], &iconSrcBuf[(iconSrcBufCY-1)*480+471], 10, 0, Vec2i(size.x-9-10, title_bar_height), g_tb->size.x, g_tb->size.y, g_tb->pixBuf.getArray());
		pasteSprite2( 0, 0, 461, 0, g_tb->size.x, g_tb->size.y, iconSrcBufCX, iconSrcBufCY, 10, title_bar_height, g_tb->pixBuf.getArray());
		pasteSprite2( g_tb->size.x-9, 0, 471, 0, g_tb->size.x, g_tb->size.y, iconSrcBufCX, iconSrcBufCY, 9, title_bar_height, g_tb->pixBuf.getArray());

		paintColorSweepForCurvedBar(&iconSrcBuf[(iconSrcBufCY-1)*480+470], &iconSrcBuf[(iconSrcBufCY-1)*480+471], 10, title_bar_height, Vec2i(size.x-9-10, title_bar_height), g_tb->size.x, g_tb->size.y, g_tb->pixBuf.getArray());
		pasteSprite2( 0, title_bar_height, 461, 0, g_tb->size.x, g_tb->size.y, iconSrcBufCX, iconSrcBufCY, 10, title_bar_height, g_tb->pixBuf.getArray());
		pasteSprite2( g_tb->size.x-9, title_bar_height, 471, 0, g_tb->size.x, g_tb->size.y, iconSrcBufCX, iconSrcBufCY, 9, title_bar_height, g_tb->pixBuf.getArray());
	}
	{
		for(int bar=0,barY=BORDER_DIST; bar<g_tb->mm_button->length; bar++,barY+=SINGLE_BAR_CY){
			MM_Button& mm_button=*(g_tb->mm_button);
			M_Button& m_button=mm_button[bar];
			for(int k=0, h=TOOLBAR_BUTTON_OFFSET_X; k<m_button.length; k++){

				Button* button=m_button[k];
				button->paint();
				h+=button->bSize.x;
			}
		}
	}
	if(g_settings->invertWindowColor){
		invert();
	}
	loadSurfaceFromMemory();
}
void ToolBarWin::buttonHover(Vec2i ptCursor){

	MM_Button& mm_button=*(g_tb->mm_button);
	for(int bar=mm_button.length; --bar>=0;){
		M_Button& m_button=mm_button[bar];
		for(int k=m_button.length; --k>=0;){
			if(m_button[k]->initHover(ptCursor)){
				return;
			}
		}
	}
}
void ToolBarWin::onLoseFocus(){
	if(this==0)return;
	removeToolTip();
}

void loadLanguage(String& str){
	str = readFile((g_appDataDir + "language.txt").c_str());

	if(str.length){
		str = str.substring(str.indexOf("*/"));
		int langSize = str.length;
		int i = str.indexOf("Version:") + 8;
		float langVersion = getFloat(str, i);
		str.stb(i);

		for(int k=0; k < sizeof(tip_list)/sizeof(char*); k++){
			*tip_list[k] = str.c_str() + i;
			str.stnl(i);
			str.stb(i);
		}
		unsigned char* langData = reinterpret_cast<unsigned char*>(const_cast<char*>(str.c_str()));
		for(int i = 0; i < langSize; i++){
			if(langData[i] < ' '){
				langData[i] = 0;
			}
		}
	}
}

ButtonPtr g_placeSelParts = new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(placeIcon_x, placeIcon_y),tip_place_selected_parts, 0, placeForSelParts, *g_tb);
ButtonPtr g_tugRadButton = new TwoUpDownButton(Vec2i(24,24), Vec2i(24*18,24*3), "tug radius", decTugRadius, incTugRadius, *g_tb);
ButtonPtr g_deleteTriButton = new SingleButton(Vec2i(24,24), Vec2i(deleteTri_x,deleteTri_y), tip_delete_selected_triangle, "deleteTriangle", deleteTriangle, *g_tb);

void ToolBarWin::initToolbar(){
	loadLanguage(g_language);

	g_tb->mm_button=&g_mm_build_button;
	g_mm_build_button.length=2;
	M_Button& m_button0=g_mm_build_button[0];
	M_Button& m_button1=g_mm_build_button[1];

	g_mm_immediate_button.length=2;
	M_Button& m_button2=g_mm_immediate_button[0];
	M_Button& m_button3=g_mm_immediate_button[1];

	//m_button0+=new Button(24,24,24*15,24*3, "open the F10 menu (F10)", SELECT_PREV_VERTEX);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(newSmls_x,newSmls_y), tip_new_smls_file, "newSmls", newSmls, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(openSmls_x,openSmls_y), tip_open_smls_file, "openSmls", openSmls, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(openNetFile_x,openNetFile_y), tip_open_smls_file_from_the_web, "openNetFile", openNetFile, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(saveSmls_x,saveSmls_y), tip_save_smls_file, "saveSmls", saveSmls, *g_tb);
	m_button2=m_button0;

	m_button2 += new SingleButton(Vec2i(24,24), Vec2i(loadPartFromFile_x,loadPartFromFile_y), tip_import_triangles_from_file_to_part, "importPart", importPart, *g_tb);

	m_button0 += new SingleButton(Vec2i(24,24), Vec2i(savePartAs_x,savePartAs_y), tip_export_triangles_from_part_to_file, "exportPart", exportPart, *g_tb);
	m_button2 += new SingleButton(Vec2i(24,24), Vec2i(savePartAs_x,savePartAs_y), tip_export_triangles_from_part_to_file, "exportPart", exportPart, *g_tb);

	m_button0 += new SingleButton(Vec2i(24,24), Vec2i(openSceneTree_x,openSceneTree_y), tip_scene_tree_window, "openSceneTree", openSceneTree, *g_tb);
	m_button2 += new SingleButton(Vec2i(24,24), Vec2i(openSceneTree_x,openSceneTree_y), tip_scene_tree_window, "openSceneTree", openSceneTree, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24),Vec2i(16,16), Vec2i(remember_x, remember_y), tip_copy_vertex_part, "remember", remember, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24),Vec2i(16,16), Vec2i(remember_x, remember_y), tip_copy_vertex_part, "remember", remember, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(undo_x, undo_y),	tip_undo, "unDo", unDo, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(undo_x, undo_y),	tip_undo, "unDo", unDo, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(redo_x, redo_y),tip_redo, "reDo", reDo, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(redo_x, redo_y),tip_redo, "reDo", reDo, *g_tb);

	//m_button2+=new SixUpDownButton(Vec2i(54,24), Vec2i(0,0),tip_vertex_coord, decCoordX, incCoordX, decCoordY, incCoordY, decCoordZ, incCoordZ, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(360,48), "toggle coloured ownership mode", "openOwnership", openOwnership, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(360,48), "toggle coloured ownership mode", "openOwnership", openOwnership, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(96+24, 24), "open palette window", "openPalette", openPalette, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(96+24, 24), "open palette window", "openPalette", openPalette, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(224,192), tip_do_build_cycle, "doBuild", doBuild, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(224,192), tip_do_build_cycle, "doBuild", doBuild, *g_tb);

	g_toggleBackfaceSelectButton = new SingleButton(Vec2i(24,24), Vec2i(24 * 6, 0), "toggle backface selection", "toggleBackfaceSelect", toggleBackfaceSelect, *g_tb);
	g_toggleAccumulateSelectButton = new SingleButton(Vec2i(24,24), Vec2i(24 * 7, 24 * 3), "toggle accumulate selection", "toggleAccumulateSelect", toggleAccumulateSelect, *g_tb);
	g_togglePolyMorphCaptureButton =  new SingleButton(Vec2i(24,24), Vec2i(24 * 1, 208), "toggle poly morph capture", "togglePolyMorphCapture", togglePolyMorphCapture, *g_tb);
	m_button0 += g_toggleBackfaceSelectButton;
	m_button2 += g_toggleBackfaceSelectButton;
	m_button0 += g_toggleAccumulateSelectButton;
	m_button2 += g_toggleAccumulateSelectButton;

//	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24 * 5, 0), "toggle backface selection", "toggleBackfaceSelect", toggleBackfaceSelect, *g_tb);
//	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24 * 5, 0), "toggle backface selection", "toggleBackfaceSelect", toggleBackfaceSelect, *g_tb);
//	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24 * 11, 24), "toggle accumulate selection", "toggleAccumulateSelect", toggleAccumulateSelect, *g_tb);
//	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24 * 11, 24), "toggle accumulate selection", "toggleAccumulateSelect", toggleAccumulateSelect, *g_tb);

	//m_button0+=new SixUpDownButton(Vec2i(54,24), Vec2i(54,0), tip_vertex_color, decRed, incRed, decGreen, incGreen, decBlue, incBlue, *g_tb);
	//m_button2+=new SixUpDownButton(Vec2i(54,24), Vec2i(54,0), tip_vertex_color, decRed, incRed, decGreen, incGreen, decBlue, incBlue, *g_tb);
	m_button0+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*3,24), tip_zoom, zoom, zoomIn, *g_tb);
	m_button2+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*3,24), tip_zoom, zoom, zoomIn, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*0,24*1), "set front view orientation", "setFrontViewOrientation", setFrontViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*0,24*1), "set front view orientation", "setFrontViewOrientation", setFrontViewOrientation, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*1,24*1), "set back view orientation", "setBackViewOrientation", setBackViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*1,24*1), "set back view orientation", "setBackViewOrientation", setBackViewOrientation, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*2,24*1), "set left view orientation", "setLeftViewOrientation", setLeftViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*2,24*1), "set left view orientation", "setLeftViewOrientation", setLeftViewOrientation, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*15,24*3), "set right view orientation", "setRightViewOrientation", setRightViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*15,24*3), "set right view orientation", "setRightViewOrientation", setRightViewOrientation, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*16,24*3), "set bird's eye view orientation", "setBirdsEyeViewOrientation", setBirdsEyeViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*16,24*3), "set bird's eye view orientation", "setBirdsEyeViewOrientation", setBirdsEyeViewOrientation, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24*17,24*3), "set worm's eye view orientation", "setWormsEyeViewOrientation", setWormsEyeViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24*17,24*3), "set worm's eye view orientation", "setWormsEyeViewOrientation", setWormsEyeViewOrientation, *g_tb);

//	m_button0+=new SixUpDownButton(Vec2i(24*3,24), Vec2i(24*15,24*3), tip_view_orientation, decViewOrientationX, incViewOrientationX, decViewOrientationY, incViewOrientationY, decViewOrientationZ, incViewOrientationZ, *g_tb);
//	m_button2+=new SixUpDownButton(Vec2i(24*3,24), Vec2i(24*15,24*3), tip_view_orientation, decViewOrientationX, incViewOrientationX, decViewOrientationY, incViewOrientationY, decViewOrientationZ, incViewOrientationZ, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(resetViewOrientation_x, resetViewOrientation_y), "quantise view orientation", "quantise view orientation", quantiseViewOrientation, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(resetViewOrientation_x, resetViewOrientation_y), "quantise view orientation", "quantise view orientation", quantiseViewOrientation, *g_tb);

//	m_button0+=new SixUpDownButton(Vec2i(54,24), Vec2i(54*2,0), tip_view_position, decViewPositionX, incViewPositionX, decViewPositionY, incViewPositionY, decViewPositionZ, incViewPositionZ, *g_tb);
//	m_button2+=new SixUpDownButton(Vec2i(54,24), Vec2i(54*2,0), tip_view_position, decViewPositionX, incViewPositionX, decViewPositionY, incViewPositionY, decViewPositionZ, incViewPositionZ, *g_tb);

	m_button0+=new SixUpDownButton(Vec2i(24*3,24), Vec2i(24*7,0), tip_view_orientation_at_right_angle, decViewOrientation90X, incViewOrientation90X, decViewOrientation90Y, incViewOrientation90Y, decViewOrientation90Z, incViewOrientation90Z, *g_tb);
	m_button2+=new SixUpDownButton(Vec2i(24*3,24), Vec2i(24*7,0), tip_view_orientation_at_right_angle, decViewOrientation90X, incViewOrientation90X, decViewOrientation90Y, incViewOrientation90Y, decViewOrientation90Z, incViewOrientation90Z, *g_tb);


	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(resetViewPosition_x,resetViewPosition_y), tip_resetViewPosition, "resetViewPosition", resetViewPosition, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(resetViewPosition_x,resetViewPosition_y), tip_resetViewPosition, "resetViewPosition", resetViewPosition, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(centerViewToControlPoint_x,centerViewToControlPoint_y), tip_centerViewToControlPoint, "centerViewToControlPoint", centerViewToControlPoint, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(centerViewToControlPoint_x,centerViewToControlPoint_y), tip_centerViewToControlPoint, "centerViewToControlPoint", centerViewToControlPoint, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(centerViewToPivotPoint_x,centerViewToPivotPoint_y), tip_centerViewToPivotPoint, "centerViewToPivotPoint", centerViewToPivotPoint, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(centerViewToPivotPoint_x,centerViewToPivotPoint_y), tip_centerViewToPivotPoint, "centerViewToPivotPoint", centerViewToPivotPoint, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(0, 209), "toggle x-ray mode", "toggleXRayMode", toggleXRayMode, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(0, 209), "toggle x-ray mode", "toggleXRayMode", toggleXRayMode, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(24, 24*3), "toggle x-ray edit", "toggleXRayEdit", toggleXRayEdit, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(24, 24*3), "toggle x-ray edit", "toggleXRayEdit", toggleXRayEdit, *g_tb);
//	m_button0+=new SixUpDownButton(Vec2i(20*3,24), Vec2i(54*2,0),tip_move_pivot_point, decPivotX, incPivotX, decPivotY, incPivotY, decPivotZ, incPivotZ, *g_tb);
//	m_button2+=new SixUpDownButton(Vec2i(20*3,24), Vec2i(54*2,0),tip_move_pivot_point, decPivotX, incPivotX, decPivotY, incPivotY, decPivotZ, incPivotZ, *g_tb);
	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(floorBuild_x,floorBuild_y), tip_build_a_floor_for_an_avatar, "floorBuild", floorBuild, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(floorBuild_x,floorBuild_y), tip_build_a_floor_for_an_avatar, "floorBuild", floorBuild, *g_tb);
//	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(freezeTime_x, freezeTime_y), "freeze time (Ctrl F11)", freezeTime, *g_tb);

	m_button0+=new SingleButton(Vec2i(24,24), Vec2i(help_x,help_y), tip_help, "help", help, *g_tb);
	m_button2+=new SingleButton(Vec2i(24,24), Vec2i(help_x,help_y), tip_help, "help", help, *g_tb);

	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(breakVertexJoin_x,breakVertexJoin_y),tip_break_coord_join, "breakVertexJoin", breakVertexJoin, *g_tb);
	//m_button3+=new SingleButton(Vec2i(24,24), Vec2i(breakColorJoin_x,breakColorJoin_y),"break color join (Alt B)", breakColorJoin, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(deleteTri_x,deleteTri_y), tip_delete_selected_triangle, "deleteTriangle", deleteTriangle, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(cutDownFromTheCursor_x, cutDownFromTheCursor_y), tip_delete_triangles_down_from_selected_vertex, "cutDownFromVertex", cutDownFromVertex, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(cutToTheLeftOfTheCursor_x,cutToTheLeftOfTheCursor_y), tip_delete_triangles_left_from_selected_vertex, "toggleMultiSelectTriVert", cutLeftFromVertex, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(cutUpFromTheCursor_x,cutUpFromTheCursor_y), "delete triangles up from selected vertex (Shif U)", "cutUpFromVertex", cutUpFromVertex, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(joinVertexKeepBothColors_x,joinVertexKeepBothColors_y), tip_join_vertex_keep_both_colors, "joinVertexKeepBothColors", joinVertexKeepBothColors, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(joinVertexKeepDestColor_x,joinVertexKeepDestColor_y), tip_join_vertex_keep_dest_color, "joinVertexKeepDestColor", joinVertexKeepDestColor, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(transferCloseVerticesJoin_x,transferCloseVerticesJoin_y), tip_joinCloseVertices, "transferCloseVerticesJoin", transferCloseVerticesJoin, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(joinCloseVerticesMacro_x,joinCloseVerticesMacro_y), tip_joinCloseVertecesForAllShownParts, "joinCloseVerticesMacro", joinCloseVerticesMacro, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(joinMatchingColors_x,joinMatchingColors_y),tip_join_colors_in_vertices_that_equal_the_same_color_and_whose_coords_are_joined, "joinMatchingColors", joinMatchingColors, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(colorVertex_x,colorVertex_y),tip_paste_copied_color_to_selected_vertex, "colorVertex", colorVertex, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(pasteColorToTriangle_x, pasteColorToTriangle_y),"paste copied color to selected triangle (K))", "pasteColorToTriangle", pasteColorToTriangle, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(colorPart_x,colorPart_y),tip_paste_copied_color_to_part, "colorPart", colorPart, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(replaceColorPart_x,replaceColorPart_y),"paste copied color into all vertices that are colored the same as the selected vertex for only the selected part", "replaceColorPart", replaceColorPart, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(replaceColorSkeleton_x,replaceColorSkeleton_y),"paste copied color into all vertices that are colored the same as the selected vertex for all parts", "replaceColorSkeleton", replaceColorSkeleton, *g_tb);
//	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(compileScaleRotation_x,compileScaleRotation_y), tip_compile_Part_and_its_decendents_scale_and_rotation_fields, compileScaleRotation, *g_tb);
	m_button3+=g_tugRadButton;

//	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(transferSingleVertex_x,transferSingleVertex_y),tip_paste_ownership_from_copied_part_into_the_selected_vertex, "transferSingleVertex", transferSingleVertex, *g_tb);
	m_button3 += g_togglePolyMorphCaptureButton;
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(zeroVetexX_x,zeroVetexX_y),tip_zeroToX, "zeroVetexX", zeroVetexX, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(copyAndPasteMirroredPart_x,copyAndPasteMirroredPart_y),tip_copyAndPasteMirroredPart, "copyAndPasteMirroredPart", copyAndPasteMirroredPart, *g_tb);
//	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(replaceWithCopyOfRememberedPartMirrorX_x,replaceWithCopyOfRememberedPartMirrorX_y),tip_paste_triangles_from_the_copied_part_in_X_mirrored_form_into_the_selected_part, replaceWithCopyOfRememberedPartMirrorX, *g_tb);
//	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(pasteAddCopyOfMirrorX_x,pasteAddCopyOfMirrorX_y),tip_add_triangles_from_the_copied_part_in_X_mirrored_form_to_the_selected_part, pasteAddCopyOfMirrorX, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(swapDivide_x,swapDivide_y), tip_swap_triangle_divide_between_the_copied_and_selected_triangles, "swapDivide", swapDivide, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(quickTriangle_x, quickTriangle_y), tip_quickTriangle, "quickTriangle", quickTriangle, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(mirrorTriangleImmediate_x,mirrorTriangleImmediate_y),tip_mirror_triangle, "mirrorTriangleImmediate", mirrorTriangleImmediate, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(projectSingleVertexOntoPoly_x,projectSingleVertexOntoPoly_y),"project selected vertex onto a polygon surface", "projectSingleVertexOntoPoly", projectSingleVertexOntoPoly, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(splitTriangleImmediate_x,splitTriangleImmediate_y),tip_split_triangle_between_the_vertices_marked_by_the_red_and_green_dots, "splitTriangleImmediate", splitTriangleImmediate, *g_tb);

	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(sphereBuildIcon_x, sphereBuildIcon_y),tip_build_sphere_for_selected_part, "buildSphereForSelPart", buildSphereForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(cylinderBuildIcon_x, cylinderBuildIcon_y),tip_build_cylinder_for_selected_part, "buildCylinderForSelPart", buildCylinderForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(coneBuildIcon_x,coneBuildIcon_y),tip_build_cone_for_selected_part, "buildConeForSelPart", buildConeForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(torusBuildIcon_x,torusBuildIcon_y),tip_build_torus_for_selected_part, "buildTorusForSelPart", buildTorusForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(bezierLatheBuildIcon_x,bezierLatheBuildIcon_y),tip_build_bezier_lathe_for_selected_part, "buildBezierLatheForSelPart", buildBezierLatheForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(boxBuildIcon_x,boxBuildIcon_y),tip_build_box_for_selected_part, "buildBoxForSelPart", buildBoxForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), nodeIconLookUp[RINGBUILD].size, nodeIconLookUp[RINGBUILD].srcPos,tip_build_rings_for_selected_part, "buildRingsForSelPart", buildRingsForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(rectangleBuildIcon_x, rectangleBuildIcon_y),tip_build_rectangle_for_selected_part, "newRectangle", newRectangle, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(160+16*3,192-16),tip_build_av_segment_for_selected_part, "buildAvSegmentForSelPart", buildAvSegmentForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), nodeIconLookUp[NURBSLATHE].size, nodeIconLookUp[NURBSLATHE].srcPos,tip_build_nurbs_lathe_for_selected_part, "buildNurbsLatheForSelPart", buildNurbsLatheForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), nodeIconLookUp[BENDYLATHE].size, nodeIconLookUp[BENDYLATHE].srcPos,tip_build_bendy_lathe_for_selected_part, "buildBendyLatheForSelPart", buildBendyLatheForSelPart, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), nodeIconLookUp[SUBDIVISION].size, nodeIconLookUp[SUBDIVISION].srcPos,tip_build_subdivision_for_selected_part, "buildSubdivisionForSelPart", buildSubdivisionForSelPart, *g_tb);
	//m_button1+=new SingleButton(Vec2i(24,24), nodeIconLookUp[MODELMORPHER].size, nodeIconLookUp[MODELMORPHER].srcPos,tip_build_model_morpher_for_selected_seamless_node, "buildModelMorpherForSelSmls", buildModelMorpherForSelSmls, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(colorSweepIcon_x, colorSweepIcon_y),tip_add_a_ColorSweep_for_selected_parts, "colorSweepForSelParts", colorSweepForSelParts, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(copyPartIcon_x, copyPartIcon_y),tip_copy_upper_selected_parts_to_lower_selected_parts, "copyPartForSelParts", copyPartForSelParts, *g_tb);
	m_button1+=g_placeSelParts;

	m_button1+= g_deleteTriButton;
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(joinVertexKeepBothColors_x,joinVertexKeepBothColors_y), tip_join_vertex_keep_both_colors, "joinVertexKeepBothColors", joinVertexKeepBothColors, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(joinVertexKeepDestColor_x,joinVertexKeepDestColor_y), tip_join_vertex_keep_dest_color, "joinVertexKeepDestColor", joinVertexKeepDestColor, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(colorVertex_x,colorVertex_y),tip_paste_copied_color_to_selected_vertex, "colorVertex", colorVertex, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(pasteColorToTriangle_x, pasteColorToTriangle_y),"paste copied color to selected triangle (K))", "pasteColorToTriangle", pasteColorToTriangle, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(16,16), Vec2i(swapDivide_x,swapDivide_y), tip_swap_triangle_divide_between_the_copied_and_selected_triangles, "swapDivide", swapDivide, *g_tb);
	//m_button1+=new SingleButton(Vec2i(24,24), Vec2i(quickTriangle_x, quickTriangle_y), tip_quickTriangle, quickTriangle, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(mirrorTriangleImmediate_x,mirrorTriangleImmediate_y),tip_mirror_triangle, "mirrorTriangleImmediate", mirrorTriangleImmediate, *g_tb);
	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(splitTriangleImmediate_x,splitTriangleImmediate_y),tip_split_triangle_between_the_vertices_marked_by_the_red_and_green_dots, "splitTriangleImmediate", splitTriangleImmediate, *g_tb);
	m_button1+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*12,24), tip_swap_vertexs_index_order_with_previous_next, swapVertexOrderDec, swapVertexOrderInc, *g_tb);


	m_button3+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*12,24), tip_swap_vertexs_index_order_with_previous_next, swapVertexOrderDec, swapVertexOrderInc, *g_tb);


	m_button1+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*14,24*3), tip_select_previous_next_vertex_in_index_order, selectPreviousVertex, selectNextVertex, *g_tb);
	m_button3+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*14,24*3), tip_select_previous_next_vertex_in_index_order, selectPreviousVertex, selectNextVertex, *g_tb);

	m_button1+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*10,24), tip_select_previous_next_triangle_that_shares_the_selected_vertex, decToNextTriThatSharesActivePoint, incToNextTriThatSharesActivePoint, *g_tb);
	m_button3+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*10,24), tip_select_previous_next_triangle_that_shares_the_selected_vertex, decToNextTriThatSharesActivePoint, incToNextTriThatSharesActivePoint, *g_tb);

//	m_button1+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*11,24), tip_select_previous_next_corner_in_triangle, selectPreviousCornerInTri, selectNextCornerInTri, *g_tb);
//	m_button3+=new TwoUpDownButton(Vec2i(24,24), Vec2i(24*11,24), tip_select_previous_next_corner_in_triangle, selectPreviousCornerInTri, selectNextCornerInTri, *g_tb);

	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(findThinTriangle_x,findThinTriangle_y), tip_findThinTriangle, "findThinTriangle", findThinTriangle, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(findThinTriangle_x,findThinTriangle_y), tip_findThinTriangle, "findThinTriangle", findThinTriangle, *g_tb);

	m_button1 += new SingleButton(Vec2i(24,24), Vec2i(invertBackgroundColor_x,invertBackgroundColor_y), tip_toggle_background_color, "invertBackgroundColor", invertBackgroundColor, *g_tb);
	m_button3 += new SingleButton(Vec2i(24,24), Vec2i(invertBackgroundColor_x,invertBackgroundColor_y), tip_toggle_background_color, "invertBackgroundColor", invertBackgroundColor, *g_tb);

	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(togglePerspective_x, togglePerspective_y), tip_toggle_perspective, "togglePerspective", togglePerspective, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(togglePerspective_x, togglePerspective_y), tip_toggle_perspective, "togglePerspective", togglePerspective, *g_tb);

	m_button1+=new SingleButton(Vec2i(24,24), Vec2i(resetRotations_x,resetRotations_y), tip_reset_rotations, "resetRotations", resetRotations, *g_tb);
	m_button3+=new SingleButton(Vec2i(24,24), Vec2i(resetRotations_x,resetRotations_y), tip_reset_rotations, "resetRotations", resetRotations, *g_tb);

	m_button1 += new SingleButton(Vec2i(24,24), Vec2i(toggleWireframeMode_x,toggleWireframeMode_y), tip_toggleWireframe, "toggleWireFrame", toggleWireFrame, *g_tb);
	m_button3 += new SingleButton(Vec2i(24,24), Vec2i(toggleWireframeMode_x,toggleWireframeMode_y), tip_toggleWireframe, "toggleWireFrame", toggleWireFrame, *g_tb);

//	m_button1 += new SingleButton(Vec2i(24*8,24), Vec2i(1,1), Vec2i(1,1), 0, dummyFunction, *g_tb);

	for(int bar = 0, barY = BORDER_DIST; bar < g_mm_build_button.length; bar++, barY += SINGLE_BAR_CY){
		M_Button& m_button=g_mm_build_button[bar];
		for(int k=0, h=TOOLBAR_BUTTON_OFFSET_X; k<m_button.length; k++){
			if(bar==0){
				if(k == 4){
					h += 24;
				}
//				else if(k == 12){
//					h += 24 + 12;
//				}
			}
			else if(bar == 1){
				if( k == 14){
					h+=24 * 2;
				}
			}
			Button* button=m_button[k];
			button->dstPos=Vec2i(h, barY);
			h+=button->bSize.x;
		}
	}
	for(int bar=0,barY=BORDER_DIST; bar<g_mm_immediate_button.length; bar++,barY+=SINGLE_BAR_CY){
		M_Button& m_button=g_mm_immediate_button[bar];
		for(int k=0, h=TOOLBAR_BUTTON_OFFSET_X; k<m_button.length; k++){
			if(bar == 0){
				//if(k == 13){
				//	h += 24 + 12;
				//}
			}
			else if(bar == 1){
				if( k == 15){
					h += 1 * 24;
				}
			}
			Button* button=m_button[k];
			button->dstPos=Vec2i(h, barY);
			h+=button->bSize.x;
		}
	}
	String language;

	//for(int k=0; k < sizeof(tip_list)/sizeof(char*); k++){
	//	language+= *tip_list[k];
	//	language+='\n';
	//}
	//g_writeGzipped=false;
	//language.write(g_appDataDir + "language.txt");


	g_tt->size=Vec2i(100,100);
	g_tb->size=Vec2i(TOOLBAR_CX,TOOLBAR_CY+BORDER_DIST*2);
	g_tb->pos=Vec2i(g_settings->toolBarPos.x, g_settings->toolBarPos.y);
/*
	RGBQUAD rgbQuad={255,255,255,255};
	HBITMAP nhbmp = (HBITMAP)LoadImage( g_hinst, MAKEINTRESOURCE(IDB_BITMAP_TOOLBAR), IMAGE_BITMAP, 0, 0, LR_CREATEDIBSECTION );
	BITMAPINFO iconBitmapInfo;
	BITMAPINFOHEADER& bmiHeader=iconBitmapInfo.bmiHeader;
	bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	bmiHeader.biWidth=480;
	bmiHeader.biHeight=iconSrcBufCY;
	*(iconBitmapInfo.bmiColors)=rgbQuad;
	bmiHeader.biPlanes=1;
	bmiHeader.biBitCount=32;
	bmiHeader.biCompression=BI_RGB;

	int numOfPixles=bmiHeader.biHeight*bmiHeader.biWidth;
	unsigned* iconPixels=new unsigned[numOfPixles];
	
	HDC hdcMemory = CreateCompatibleDC(GetDC(hWndMain));
	GetDIBits(
		hdcMemory,           // handle to device context
		nhbmp,      // handle to bitmap
		0,   // first scan line to set in destination bitmap
		bmiHeader.biHeight,   // number of scan lines to copy
		iconPixels,    // address of array for bitmap bits
		&iconBitmapInfo, // address of structure with bitmap data
		DIB_RGB_COLORS        // RGB or palette index
	);
	String str="const unsigned iconSrcBuf[]={\n";
	for(int i=0, c=0; ;){
		str+="0x";
		str.catHex(iconPixels[i]);
		i++;
		if(i>=numOfPixles){
			break;
		}
		str+=',';
		if(++c>=50){
			c=0;
			str+='\n';
		}
	}
	str+="\n};";
	str.write("iconSrcBuf.cpp");
*/
	g_settings->showToolBar=g_settings->showToolBar.refValue();



/*
	WNDCLASSEX wcToolbar;
	
	wcToolbar.cbSize = sizeof(WNDCLASSEX); 
	wcToolbar.style			= CS_HREDRAW | CS_VREDRAW;
	wcToolbar.lpfnWndProc	= (WNDPROC)ToolBarProc;
	wcToolbar.cbClsExtra	= 0;
	wcToolbar.cbWndExtra	= 0;
	wcToolbar.hInstance		= g_hinst;
	wcToolbar.hIcon			= NULL;
	wcToolbar.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcToolbar.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcToolbar.lpszMenuName	= NULL;
	wcToolbar.lpszClassName	= "wcToolbar";
	wcToolbar.hIconSm		= NULL;
	
	// Register the window class
	RegisterClassEx( &wcToolbar );

	WNDCLASSEX wcTooltip;
	
	wcTooltip.cbSize = sizeof(WNDCLASSEX); 
	wcTooltip.style			= CS_HREDRAW | CS_VREDRAW;
	wcTooltip.lpfnWndProc	= (WNDPROC)ToolTipProc;
	wcTooltip.cbClsExtra	= 0;
	wcTooltip.cbWndExtra	= 0;
	wcTooltip.hInstance		= g_hinst;
	wcTooltip.hIcon			= NULL;
	wcTooltip.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcTooltip.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcTooltip.lpszMenuName	= NULL;
	wcTooltip.lpszClassName	= "wcTooltip";
	wcTooltip.hIconSm		= NULL;
	
	// Register the window class
	RegisterClassEx( &wcTooltip );

	openToolBar();
*/
}
void updateFuseSurfaceClue();

void ToolBarWin::updateToolBarContext(){
	bool paintFlag = false;
	updateFuseSurfaceClue();

	int type = g_selNode->getType();
	bool wasImmediate=false;
	if(mm_button==&g_mm_immediate_button){
		wasImmediate=true;
	}
	if(type==IMMEDIATEPART && wasImmediate==false){
		mm_button=&g_mm_immediate_button;
		paintFlag = true;
	}
	else if(type!=IMMEDIATEPART && wasImmediate){
		mm_button=&g_mm_build_button;
		paintFlag = true;
	}
	if(type==PART){
		if(g_vcArtAnimBase == g_visualClue){
			g_mm_build_button[1][15] = g_togglePolyMorphCaptureButton;
			paintFlag = true;
		}
		else{
			g_mm_build_button[1][15] = g_deleteTriButton;
			paintFlag = true;
		}
	}
	if(dynamic_cast<NurbsPatch*>(g_selNode.getRaw())){
		if(g_mm_build_button[1][14]->baseCommand!=reinterpret_cast<int>(decTugRadius)){
			g_mm_build_button[1][14] = g_tugRadButton;
			paintFlag = true;
		}
	}
	else{
		if(g_mm_build_button[1][14]->baseCommand!=reinterpret_cast<int>(placeForSelParts)){
			g_mm_build_button[1][14] = g_placeSelParts;
			paintFlag = true;
		}
	}
	if(paintFlag){
		paint();
	}
}